<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Passport' => '\\StructType\\Passport',
            'TokenPassportSignature' => '\\StructType\\TokenPassportSignature',
            'TokenPassport' => '\\StructType\\TokenPassport',
            'ChangePassword' => '\\StructType\\ChangePassword',
            'ChangeEmail' => '\\StructType\\ChangeEmail',
            'StatusDetail' => '\\StructType\\StatusDetail',
            'Status' => '\\StructType\\Status',
            'WsRole' => '\\StructType\\WsRole',
            'WsRoleList' => '\\StructType\\WsRoleList',
            'Record' => '\\StructType\\Record',
            'NullField' => '\\StructType\\NullField',
            'SearchRecord' => '\\StructType\\SearchRecord',
            'SearchRecordBasic' => '\\StructType\\SearchRecordBasic',
            'SearchRow' => '\\StructType\\SearchRow',
            'SearchRowBasic' => '\\StructType\\SearchRowBasic',
            'SearchResult' => '\\StructType\\SearchResult',
            'AsyncStatusResult' => '\\StructType\\AsyncStatusResult',
            'GetAllResult' => '\\StructType\\GetAllResult',
            'GetSavedSearchResult' => '\\StructType\\GetSavedSearchResult',
            'GetCustomizationIdResult' => '\\StructType\\GetCustomizationIdResult',
            'GetSelectValueResult' => '\\StructType\\GetSelectValueResult',
            'RecordList' => '\\StructType\\RecordList',
            'SearchRowList' => '\\StructType\\SearchRowList',
            'RecordRefList' => '\\StructType\\RecordRefList',
            'BaseRef' => '\\StructType\\BaseRef',
            'BaseRefList' => '\\StructType\\BaseRefList',
            'RecordRef' => '\\StructType\\RecordRef',
            'Duration' => '\\StructType\\Duration',
            'CustomRecordRef' => '\\StructType\\CustomRecordRef',
            'CustomTransactionRef' => '\\StructType\\CustomTransactionRef',
            'CustomizationRef' => '\\StructType\\CustomizationRef',
            'CustomizationRefList' => '\\StructType\\CustomizationRefList',
            'InitializeRecord' => '\\StructType\\InitializeRecord',
            'InitializeRef' => '\\StructType\\InitializeRef',
            'InitializeRefList' => '\\StructType\\InitializeRefList',
            'InitializeAuxRef' => '\\StructType\\InitializeAuxRef',
            'UpdateInviteeStatusReference' => '\\StructType\\UpdateInviteeStatusReference',
            'GetAllRecord' => '\\StructType\\GetAllRecord',
            'GetSavedSearchRecord' => '\\StructType\\GetSavedSearchRecord',
            'CustomizationType' => '\\StructType\\CustomizationType',
            'ListOrRecordRef' => '\\StructType\\ListOrRecordRef',
            'CustomFieldRef' => '\\StructType\\CustomFieldRef',
            'LongCustomFieldRef' => '\\StructType\\LongCustomFieldRef',
            'DoubleCustomFieldRef' => '\\StructType\\DoubleCustomFieldRef',
            'BooleanCustomFieldRef' => '\\StructType\\BooleanCustomFieldRef',
            'StringCustomFieldRef' => '\\StructType\\StringCustomFieldRef',
            'DateCustomFieldRef' => '\\StructType\\DateCustomFieldRef',
            'SelectCustomFieldRef' => '\\StructType\\SelectCustomFieldRef',
            'MultiSelectCustomFieldRef' => '\\StructType\\MultiSelectCustomFieldRef',
            'CustomFieldList' => '\\StructType\\CustomFieldList',
            'DimensionRef' => '\\StructType\\DimensionRef',
            'StringDimensionRef' => '\\StructType\\StringDimensionRef',
            'SelectDimensionRef' => '\\StructType\\SelectDimensionRef',
            'DimensionList' => '\\StructType\\DimensionList',
            'SearchBooleanField' => '\\StructType\\SearchBooleanField',
            'SearchStringField' => '\\StructType\\SearchStringField',
            'SearchLongField' => '\\StructType\\SearchLongField',
            'SearchTextNumberField' => '\\StructType\\SearchTextNumberField',
            'SearchDoubleField' => '\\StructType\\SearchDoubleField',
            'SearchDateField' => '\\StructType\\SearchDateField',
            'SearchEnumMultiSelectField' => '\\StructType\\SearchEnumMultiSelectField',
            'SearchMultiSelectField' => '\\StructType\\SearchMultiSelectField',
            'SearchCustomField' => '\\StructType\\SearchCustomField',
            'SearchBooleanCustomField' => '\\StructType\\SearchBooleanCustomField',
            'SearchStringCustomField' => '\\StructType\\SearchStringCustomField',
            'SearchLongCustomField' => '\\StructType\\SearchLongCustomField',
            'SearchDoubleCustomField' => '\\StructType\\SearchDoubleCustomField',
            'SearchDateCustomField' => '\\StructType\\SearchDateCustomField',
            'SearchEnumMultiSelectCustomField' => '\\StructType\\SearchEnumMultiSelectCustomField',
            'SearchMultiSelectCustomField' => '\\StructType\\SearchMultiSelectCustomField',
            'SearchCustomFieldList' => '\\StructType\\SearchCustomFieldList',
            'SearchColumnField' => '\\StructType\\SearchColumnField',
            'SearchColumnBooleanField' => '\\StructType\\SearchColumnBooleanField',
            'SearchColumnStringField' => '\\StructType\\SearchColumnStringField',
            'SearchColumnLongField' => '\\StructType\\SearchColumnLongField',
            'SearchColumnTextNumberField' => '\\StructType\\SearchColumnTextNumberField',
            'SearchColumnDoubleField' => '\\StructType\\SearchColumnDoubleField',
            'SearchColumnDateField' => '\\StructType\\SearchColumnDateField',
            'SearchColumnEnumSelectField' => '\\StructType\\SearchColumnEnumSelectField',
            'SearchColumnSelectField' => '\\StructType\\SearchColumnSelectField',
            'SearchColumnCustomField' => '\\StructType\\SearchColumnCustomField',
            'SearchColumnBooleanCustomField' => '\\StructType\\SearchColumnBooleanCustomField',
            'SearchColumnStringCustomField' => '\\StructType\\SearchColumnStringCustomField',
            'SearchColumnLongCustomField' => '\\StructType\\SearchColumnLongCustomField',
            'SearchColumnDoubleCustomField' => '\\StructType\\SearchColumnDoubleCustomField',
            'SearchColumnDateCustomField' => '\\StructType\\SearchColumnDateCustomField',
            'SearchColumnEnumMultiSelectCustomField' => '\\StructType\\SearchColumnEnumMultiSelectCustomField',
            'SearchColumnSelectCustomField' => '\\StructType\\SearchColumnSelectCustomField',
            'SearchColumnMultiSelectCustomField' => '\\StructType\\SearchColumnMultiSelectCustomField',
            'SearchColumnCustomFieldList' => '\\StructType\\SearchColumnCustomFieldList',
            'ItemAvailabilityFilter' => '\\StructType\\ItemAvailabilityFilter',
            'ItemAvailability' => '\\StructType\\ItemAvailability',
            'ItemAvailabilityList' => '\\StructType\\ItemAvailabilityList',
            'GetItemAvailabilityResult' => '\\StructType\\GetItemAvailabilityResult',
            'BudgetExchangeRateFilter' => '\\StructType\\BudgetExchangeRateFilter',
            'BudgetExchangeRate' => '\\StructType\\BudgetExchangeRate',
            'BudgetExchangeRateList' => '\\StructType\\BudgetExchangeRateList',
            'GetBudgetExchangeRateResult' => '\\StructType\\GetBudgetExchangeRateResult',
            'CurrencyRateFilter' => '\\StructType\\CurrencyRateFilter',
            'CurrencyRate' => '\\StructType\\CurrencyRate',
            'CurrencyRateList' => '\\StructType\\CurrencyRateList',
            'GetCurrencyRateResult' => '\\StructType\\GetCurrencyRateResult',
            'DataCenterUrls' => '\\StructType\\DataCenterUrls',
            'GetDataCenterUrlsResult' => '\\StructType\\GetDataCenterUrlsResult',
            'PostingTransactionSummaryField' => '\\StructType\\PostingTransactionSummaryField',
            'PostingTransactionSummaryFilter' => '\\StructType\\PostingTransactionSummaryFilter',
            'PostingTransactionSummary' => '\\StructType\\PostingTransactionSummary',
            'PostingTransactionSummaryList' => '\\StructType\\PostingTransactionSummaryList',
            'GetPostingTransactionSummaryResult' => '\\StructType\\GetPostingTransactionSummaryResult',
            'GetSelectValueFieldDescription' => '\\StructType\\GetSelectValueFieldDescription',
            'GetSelectValueFilter' => '\\StructType\\GetSelectValueFilter',
            'GetSelectFilterByFieldValueList' => '\\StructType\\GetSelectFilterByFieldValueList',
            'GetSelectFilterByFieldValue' => '\\StructType\\GetSelectFilterByFieldValue',
            'GetServerTimeResult' => '\\StructType\\GetServerTimeResult',
            'DeletedRecord' => '\\StructType\\DeletedRecord',
            'DeletedRecordList' => '\\StructType\\DeletedRecordList',
            'GetDeletedResult' => '\\StructType\\GetDeletedResult',
            'GetDeletedFilter' => '\\StructType\\GetDeletedFilter',
            'AttachReference' => '\\StructType\\AttachReference',
            'DetachReference' => '\\StructType\\DetachReference',
            'AttachContactReference' => '\\StructType\\AttachContactReference',
            'AttachBasicReference' => '\\StructType\\AttachBasicReference',
            'DetachBasicReference' => '\\StructType\\DetachBasicReference',
            'DeletionReason' => '\\StructType\\DeletionReason',
            'GetAccountGovernanceInfoResult' => '\\StructType\\GetAccountGovernanceInfoResult',
            'GetIntegrationGovernanceInfoResult' => '\\StructType\\GetIntegrationGovernanceInfoResult',
            'SoapFault' => '\\StructType\\SoapFault',
            'InsufficientPermissionFault' => '\\StructType\\InsufficientPermissionFault',
            'InvalidAccountFault' => '\\StructType\\InvalidAccountFault',
            'InvalidCredentialsFault' => '\\StructType\\InvalidCredentialsFault',
            'InvalidSessionFault' => '\\StructType\\InvalidSessionFault',
            'ExceededConcurrentRequestLimitFault' => '\\StructType\\ExceededConcurrentRequestLimitFault',
            'ExceededRequestLimitFault' => '\\StructType\\ExceededRequestLimitFault',
            'ExceededUsageLimitFault' => '\\StructType\\ExceededUsageLimitFault',
            'ExceededRecordCountFault' => '\\StructType\\ExceededRecordCountFault',
            'InvalidVersionFault' => '\\StructType\\InvalidVersionFault',
            'ExceededRequestSizeFault' => '\\StructType\\ExceededRequestSizeFault',
            'AsyncFault' => '\\StructType\\AsyncFault',
            'UnexpectedErrorFault' => '\\StructType\\UnexpectedErrorFault',
            'ApplicationInfo' => '\\StructType\\ApplicationInfo',
            'PartnerInfo' => '\\StructType\\PartnerInfo',
            'DocumentInfo' => '\\StructType\\DocumentInfo',
            'Preferences' => '\\StructType\\Preferences',
            'SearchPreferences' => '\\StructType\\SearchPreferences',
            'SessionResponse' => '\\StructType\\SessionResponse',
            'WriteResponse' => '\\StructType\\WriteResponse',
            'ReadResponse' => '\\StructType\\ReadResponse',
            'WriteResponseList' => '\\StructType\\WriteResponseList',
            'ReadResponseList' => '\\StructType\\ReadResponseList',
            'ChangePasswordResponse' => '\\StructType\\ChangePasswordResponse',
            'ChangeEmailResponse' => '\\StructType\\ChangeEmailResponse',
            'AddResponse' => '\\StructType\\AddResponse',
            'AddListResponse' => '\\StructType\\AddListResponse',
            'UpdateResponse' => '\\StructType\\UpdateResponse',
            'UpdateListResponse' => '\\StructType\\UpdateListResponse',
            'UpsertResponse' => '\\StructType\\UpsertResponse',
            'UpsertListResponse' => '\\StructType\\UpsertListResponse',
            'DeleteResponse' => '\\StructType\\DeleteResponse',
            'DeleteListResponse' => '\\StructType\\DeleteListResponse',
            'SearchResponse' => '\\StructType\\SearchResponse',
            'SearchMoreWithIdResponse' => '\\StructType\\SearchMoreWithIdResponse',
            'GetResponse' => '\\StructType\\GetResponse',
            'GetListResponse' => '\\StructType\\GetListResponse',
            'GetAllResponse' => '\\StructType\\GetAllResponse',
            'GetSavedSearchResponse' => '\\StructType\\GetSavedSearchResponse',
            'GetCustomizationIdResponse' => '\\StructType\\GetCustomizationIdResponse',
            'InitializeResponse' => '\\StructType\\InitializeResponse',
            'InitializeListResponse' => '\\StructType\\InitializeListResponse',
            'getSelectValueResponse' => '\\StructType\\GetSelectValueResponse',
            'GetItemAvailabilityResponse' => '\\StructType\\GetItemAvailabilityResponse',
            'GetBudgetExchangeRateResponse' => '\\StructType\\GetBudgetExchangeRateResponse',
            'GetCurrencyRateResponse' => '\\StructType\\GetCurrencyRateResponse',
            'GetDataCenterUrlsResponse' => '\\StructType\\GetDataCenterUrlsResponse',
            'GetPostingTransactionSummaryResponse' => '\\StructType\\GetPostingTransactionSummaryResponse',
            'GetServerTimeResponse' => '\\StructType\\GetServerTimeResponse',
            'AttachResponse' => '\\StructType\\AttachResponse',
            'DetachResponse' => '\\StructType\\DetachResponse',
            'UpdateInviteeStatusResponse' => '\\StructType\\UpdateInviteeStatusResponse',
            'UpdateInviteeStatusListResponse' => '\\StructType\\UpdateInviteeStatusListResponse',
            'AsyncStatusResponse' => '\\StructType\\AsyncStatusResponse',
            'GetAsyncResultResponse' => '\\StructType\\GetAsyncResultResponse',
            'AsyncResult' => '\\StructType\\AsyncResult',
            'AsyncAddListResult' => '\\StructType\\AsyncAddListResult',
            'AsyncUpdateListResult' => '\\StructType\\AsyncUpdateListResult',
            'AsyncUpsertListResult' => '\\StructType\\AsyncUpsertListResult',
            'AsyncDeleteListResult' => '\\StructType\\AsyncDeleteListResult',
            'AsyncGetListResult' => '\\StructType\\AsyncGetListResult',
            'AsyncSearchResult' => '\\StructType\\AsyncSearchResult',
            'AsyncInitializeListResult' => '\\StructType\\AsyncInitializeListResult',
            'GetDeletedResponse' => '\\StructType\\GetDeletedResponse',
            'GetAccountGovernanceInfoResponse' => '\\StructType\\GetAccountGovernanceInfoResponse',
            'GetIntegrationGovernanceInfoResponse' => '\\StructType\\GetIntegrationGovernanceInfoResponse',
            'ChangePasswordRequest' => '\\StructType\\ChangePasswordRequest',
            'ChangeEmailRequest' => '\\StructType\\ChangeEmailRequest',
            'AddRequest' => '\\StructType\\AddRequest',
            'DeleteRequest' => '\\StructType\\DeleteRequest',
            'SearchRequest' => '\\StructType\\SearchRequest',
            'SearchMoreWithIdRequest' => '\\StructType\\SearchMoreWithIdRequest',
            'UpdateRequest' => '\\StructType\\UpdateRequest',
            'UpsertRequest' => '\\StructType\\UpsertRequest',
            'AddListRequest' => '\\StructType\\AddListRequest',
            'DeleteListRequest' => '\\StructType\\DeleteListRequest',
            'UpdateListRequest' => '\\StructType\\UpdateListRequest',
            'UpsertListRequest' => '\\StructType\\UpsertListRequest',
            'GetRequest' => '\\StructType\\GetRequest',
            'GetListRequest' => '\\StructType\\GetListRequest',
            'GetAllRequest' => '\\StructType\\GetAllRequest',
            'GetSavedSearchRequest' => '\\StructType\\GetSavedSearchRequest',
            'GetCustomizationIdRequest' => '\\StructType\\GetCustomizationIdRequest',
            'InitializeRequest' => '\\StructType\\InitializeRequest',
            'InitializeListRequest' => '\\StructType\\InitializeListRequest',
            'getSelectValueRequest' => '\\StructType\\GetSelectValueRequest',
            'GetItemAvailabilityRequest' => '\\StructType\\GetItemAvailabilityRequest',
            'GetBudgetExchangeRateRequest' => '\\StructType\\GetBudgetExchangeRateRequest',
            'GetCurrencyRateRequest' => '\\StructType\\GetCurrencyRateRequest',
            'GetDataCenterUrlsRequest' => '\\StructType\\GetDataCenterUrlsRequest',
            'GetPostingTransactionSummaryRequest' => '\\StructType\\GetPostingTransactionSummaryRequest',
            'GetServerTimeRequest' => '\\StructType\\GetServerTimeRequest',
            'AttachRequest' => '\\StructType\\AttachRequest',
            'DetachRequest' => '\\StructType\\DetachRequest',
            'AsyncAddListRequest' => '\\StructType\\AsyncAddListRequest',
            'UpdateInviteeStatusRequest' => '\\StructType\\UpdateInviteeStatusRequest',
            'UpdateInviteeStatusListRequest' => '\\StructType\\UpdateInviteeStatusListRequest',
            'AsyncUpdateListRequest' => '\\StructType\\AsyncUpdateListRequest',
            'AsyncUpsertListRequest' => '\\StructType\\AsyncUpsertListRequest',
            'AsyncDeleteListRequest' => '\\StructType\\AsyncDeleteListRequest',
            'AsyncGetListRequest' => '\\StructType\\AsyncGetListRequest',
            'AsyncInitializeListRequest' => '\\StructType\\AsyncInitializeListRequest',
            'AsyncSearchRequest' => '\\StructType\\AsyncSearchRequest',
            'CheckAsyncStatusRequest' => '\\StructType\\CheckAsyncStatusRequest',
            'GetAsyncResultRequest' => '\\StructType\\GetAsyncResultRequest',
            'GetDeletedRequest' => '\\StructType\\GetDeletedRequest',
            'GetAccountGovernanceInfoRequest' => '\\StructType\\GetAccountGovernanceInfoRequest',
            'GetIntegrationGovernanceInfoRequest' => '\\StructType\\GetIntegrationGovernanceInfoRequest',
            'Address' => '\\StructType\\Address',
            'PresentationItem' => '\\StructType\\PresentationItem',
            'Partners' => '\\StructType\\Partners',
            'LandedCost' => '\\StructType\\LandedCost',
            'LandedCostDataList' => '\\StructType\\LandedCostDataList',
            'LandedCostData' => '\\StructType\\LandedCostData',
            'LandedCostSummary' => '\\StructType\\LandedCostSummary',
            'PurchLandedCostList' => '\\StructType\\PurchLandedCostList',
            'CustomerSalesTeam' => '\\StructType\\CustomerSalesTeam',
            'TimeItem' => '\\StructType\\TimeItem',
            'InventoryDetail' => '\\StructType\\InventoryDetail',
            'RecurrenceDowMaskList' => '\\StructType\\RecurrenceDowMaskList',
            'AccountingBookDetail' => '\\StructType\\AccountingBookDetail',
            'AccountingBookDetailList' => '\\StructType\\AccountingBookDetailList',
            'InventoryAssignmentList' => '\\StructType\\InventoryAssignmentList',
            'InventoryAssignment' => '\\StructType\\InventoryAssignment',
            'Promotions' => '\\StructType\\Promotions',
            'PromotionsList' => '\\StructType\\PromotionsList',
            'InventoryDetailSearchBasic' => '\\StructType\\InventoryDetailSearchBasic',
            'Installment' => '\\StructType\\Installment',
            'InstallmentList' => '\\StructType\\InstallmentList',
            'InventoryDetailSearchRowBasic' => '\\StructType\\InventoryDetailSearchRowBasic',
            'EntitySearchBasic' => '\\StructType\\EntitySearchBasic',
            'EntitySearchRowBasic' => '\\StructType\\EntitySearchRowBasic',
            'ContactSearchBasic' => '\\StructType\\ContactSearchBasic',
            'ContactSearchRowBasic' => '\\StructType\\ContactSearchRowBasic',
            'CustomerSearchBasic' => '\\StructType\\CustomerSearchBasic',
            'CustomerSearchRowBasic' => '\\StructType\\CustomerSearchRowBasic',
            'CalendarEventSearchBasic' => '\\StructType\\CalendarEventSearchBasic',
            'CalendarEventSearchRowBasic' => '\\StructType\\CalendarEventSearchRowBasic',
            'TaskSearchBasic' => '\\StructType\\TaskSearchBasic',
            'TaskSearchRowBasic' => '\\StructType\\TaskSearchRowBasic',
            'OpportunitySearchBasic' => '\\StructType\\OpportunitySearchBasic',
            'OpportunitySearchRowBasic' => '\\StructType\\OpportunitySearchRowBasic',
            'EmployeeSearchBasic' => '\\StructType\\EmployeeSearchBasic',
            'EmployeeSearchRowBasic' => '\\StructType\\EmployeeSearchRowBasic',
            'PhoneCallSearchBasic' => '\\StructType\\PhoneCallSearchBasic',
            'PhoneCallSearchRowBasic' => '\\StructType\\PhoneCallSearchRowBasic',
            'SupportCaseSearchBasic' => '\\StructType\\SupportCaseSearchBasic',
            'SupportCaseSearchRowBasic' => '\\StructType\\SupportCaseSearchRowBasic',
            'MessageSearchBasic' => '\\StructType\\MessageSearchBasic',
            'MessageSearchRowBasic' => '\\StructType\\MessageSearchRowBasic',
            'NoteSearchBasic' => '\\StructType\\NoteSearchBasic',
            'NoteSearchRowBasic' => '\\StructType\\NoteSearchRowBasic',
            'CustomRecordSearchBasic' => '\\StructType\\CustomRecordSearchBasic',
            'CustomRecordSearchRowBasic' => '\\StructType\\CustomRecordSearchRowBasic',
            'AccountSearchBasic' => '\\StructType\\AccountSearchBasic',
            'AccountSearchRowBasic' => '\\StructType\\AccountSearchRowBasic',
            'RevRecScheduleSearchBasic' => '\\StructType\\RevRecScheduleSearchBasic',
            'RevRecScheduleSearchRowBasic' => '\\StructType\\RevRecScheduleSearchRowBasic',
            'RevRecTemplateSearchBasic' => '\\StructType\\RevRecTemplateSearchBasic',
            'RevRecTemplateSearchRowBasic' => '\\StructType\\RevRecTemplateSearchRowBasic',
            'BinSearchBasic' => '\\StructType\\BinSearchBasic',
            'BinSearchRowBasic' => '\\StructType\\BinSearchRowBasic',
            'DepartmentSearchBasic' => '\\StructType\\DepartmentSearchBasic',
            'DepartmentSearchRowBasic' => '\\StructType\\DepartmentSearchRowBasic',
            'LocationSearchBasic' => '\\StructType\\LocationSearchBasic',
            'LocationSearchRowBasic' => '\\StructType\\LocationSearchRowBasic',
            'ClassificationSearchBasic' => '\\StructType\\ClassificationSearchBasic',
            'ClassificationSearchRowBasic' => '\\StructType\\ClassificationSearchRowBasic',
            'TransactionSearchBasic' => '\\StructType\\TransactionSearchBasic',
            'TransactionSearchRowBasic' => '\\StructType\\TransactionSearchRowBasic',
            'ItemSearchBasic' => '\\StructType\\ItemSearchBasic',
            'ItemSearchRowBasic' => '\\StructType\\ItemSearchRowBasic',
            'PartnerSearchBasic' => '\\StructType\\PartnerSearchBasic',
            'PartnerSearchRowBasic' => '\\StructType\\PartnerSearchRowBasic',
            'VendorSearchBasic' => '\\StructType\\VendorSearchBasic',
            'VendorSearchRowBasic' => '\\StructType\\VendorSearchRowBasic',
            'SiteCategorySearchBasic' => '\\StructType\\SiteCategorySearchBasic',
            'SiteCategorySearchRowBasic' => '\\StructType\\SiteCategorySearchRowBasic',
            'TimeBillSearchBasic' => '\\StructType\\TimeBillSearchBasic',
            'TimeBillSearchRowBasic' => '\\StructType\\TimeBillSearchRowBasic',
            'SolutionSearchBasic' => '\\StructType\\SolutionSearchBasic',
            'SolutionSearchRowBasic' => '\\StructType\\SolutionSearchRowBasic',
            'TopicSearchBasic' => '\\StructType\\TopicSearchBasic',
            'TopicSearchRowBasic' => '\\StructType\\TopicSearchRowBasic',
            'SubsidiarySearchBasic' => '\\StructType\\SubsidiarySearchBasic',
            'SubsidiarySearchRowBasic' => '\\StructType\\SubsidiarySearchRowBasic',
            'GiftCertificateSearchBasic' => '\\StructType\\GiftCertificateSearchBasic',
            'GiftCertificateSearchRowBasic' => '\\StructType\\GiftCertificateSearchRowBasic',
            'FolderSearchBasic' => '\\StructType\\FolderSearchBasic',
            'FolderSearchRowBasic' => '\\StructType\\FolderSearchRowBasic',
            'FileSearchBasic' => '\\StructType\\FileSearchBasic',
            'FileSearchRowBasic' => '\\StructType\\FileSearchRowBasic',
            'JobSearchBasic' => '\\StructType\\JobSearchBasic',
            'JobSearchRowBasic' => '\\StructType\\JobSearchRowBasic',
            'IssueSearchBasic' => '\\StructType\\IssueSearchBasic',
            'IssueSearchRowBasic' => '\\StructType\\IssueSearchRowBasic',
            'GroupMemberSearchBasic' => '\\StructType\\GroupMemberSearchBasic',
            'CampaignSearchBasic' => '\\StructType\\CampaignSearchBasic',
            'CampaignSearchRowBasic' => '\\StructType\\CampaignSearchRowBasic',
            'EntityGroupSearchBasic' => '\\StructType\\EntityGroupSearchBasic',
            'EntityGroupSearchRowBasic' => '\\StructType\\EntityGroupSearchRowBasic',
            'PromotionCodeSearchBasic' => '\\StructType\\PromotionCodeSearchBasic',
            'PromotionCodeSearchRowBasic' => '\\StructType\\PromotionCodeSearchRowBasic',
            'BudgetSearchBasic' => '\\StructType\\BudgetSearchBasic',
            'BudgetSearchRowBasic' => '\\StructType\\BudgetSearchRowBasic',
            'ProjectTaskSearchBasic' => '\\StructType\\ProjectTaskSearchBasic',
            'ProjectTaskSearchRowBasic' => '\\StructType\\ProjectTaskSearchRowBasic',
            'ProjectTaskAssignmentSearchBasic' => '\\StructType\\ProjectTaskAssignmentSearchBasic',
            'ProjectTaskAssignmentSearchRowBasic' => '\\StructType\\ProjectTaskAssignmentSearchRowBasic',
            'AccountingPeriodSearchBasic' => '\\StructType\\AccountingPeriodSearchBasic',
            'AccountingPeriodSearchRowBasic' => '\\StructType\\AccountingPeriodSearchRowBasic',
            'ContactCategorySearchBasic' => '\\StructType\\ContactCategorySearchBasic',
            'ContactCategorySearchRowBasic' => '\\StructType\\ContactCategorySearchRowBasic',
            'ContactRoleSearchBasic' => '\\StructType\\ContactRoleSearchBasic',
            'ContactRoleSearchRowBasic' => '\\StructType\\ContactRoleSearchRowBasic',
            'CustomerCategorySearchBasic' => '\\StructType\\CustomerCategorySearchBasic',
            'CustomerCategorySearchRowBasic' => '\\StructType\\CustomerCategorySearchRowBasic',
            'CustomerStatusSearchBasic' => '\\StructType\\CustomerStatusSearchBasic',
            'CustomerStatusSearchRowBasic' => '\\StructType\\CustomerStatusSearchRowBasic',
            'ExpenseCategorySearchBasic' => '\\StructType\\ExpenseCategorySearchBasic',
            'ExpenseCategorySearchRowBasic' => '\\StructType\\ExpenseCategorySearchRowBasic',
            'JobStatusSearchBasic' => '\\StructType\\JobStatusSearchBasic',
            'JobStatusSearchRowBasic' => '\\StructType\\JobStatusSearchRowBasic',
            'JobTypeSearchBasic' => '\\StructType\\JobTypeSearchBasic',
            'JobTypeSearchRowBasic' => '\\StructType\\JobTypeSearchRowBasic',
            'NoteTypeSearchBasic' => '\\StructType\\NoteTypeSearchBasic',
            'NoteTypeSearchRowBasic' => '\\StructType\\NoteTypeSearchRowBasic',
            'PartnerCategorySearchBasic' => '\\StructType\\PartnerCategorySearchBasic',
            'PartnerCategorySearchRowBasic' => '\\StructType\\PartnerCategorySearchRowBasic',
            'PaymentMethodSearchBasic' => '\\StructType\\PaymentMethodSearchBasic',
            'PaymentMethodSearchRowBasic' => '\\StructType\\PaymentMethodSearchRowBasic',
            'PriceLevelSearchBasic' => '\\StructType\\PriceLevelSearchBasic',
            'PriceLevelSearchRowBasic' => '\\StructType\\PriceLevelSearchRowBasic',
            'SalesRoleSearchBasic' => '\\StructType\\SalesRoleSearchBasic',
            'SalesRoleSearchRowBasic' => '\\StructType\\SalesRoleSearchRowBasic',
            'TermSearchBasic' => '\\StructType\\TermSearchBasic',
            'TermSearchRowBasic' => '\\StructType\\TermSearchRowBasic',
            'VendorCategorySearchBasic' => '\\StructType\\VendorCategorySearchBasic',
            'VendorCategorySearchRowBasic' => '\\StructType\\VendorCategorySearchRowBasic',
            'WinLossReasonSearchBasic' => '\\StructType\\WinLossReasonSearchBasic',
            'WinLossReasonSearchRowBasic' => '\\StructType\\WinLossReasonSearchRowBasic',
            'OriginatingLeadSearchBasic' => '\\StructType\\OriginatingLeadSearchBasic',
            'OriginatingLeadSearchRowBasic' => '\\StructType\\OriginatingLeadSearchRowBasic',
            'UnitsTypeSearchBasic' => '\\StructType\\UnitsTypeSearchBasic',
            'UnitsTypeSearchRowBasic' => '\\StructType\\UnitsTypeSearchRowBasic',
            'CustomListSearchBasic' => '\\StructType\\CustomListSearchBasic',
            'CustomListSearchRowBasic' => '\\StructType\\CustomListSearchRowBasic',
            'PricingGroupSearchBasic' => '\\StructType\\PricingGroupSearchBasic',
            'PricingGroupSearchRowBasic' => '\\StructType\\PricingGroupSearchRowBasic',
            'InventoryNumberSearchBasic' => '\\StructType\\InventoryNumberSearchBasic',
            'InventoryNumberSearchRowBasic' => '\\StructType\\InventoryNumberSearchRowBasic',
            'InventoryNumberBinSearchBasic' => '\\StructType\\InventoryNumberBinSearchBasic',
            'InventoryNumberBinSearchRowBasic' => '\\StructType\\InventoryNumberBinSearchRowBasic',
            'ItemBinNumberSearchBasic' => '\\StructType\\ItemBinNumberSearchBasic',
            'ItemBinNumberSearchRowBasic' => '\\StructType\\ItemBinNumberSearchRowBasic',
            'PricingSearchBasic' => '\\StructType\\PricingSearchBasic',
            'PricingSearchRowBasic' => '\\StructType\\PricingSearchRowBasic',
            'NexusSearchBasic' => '\\StructType\\NexusSearchBasic',
            'NexusSearchRowBasic' => '\\StructType\\NexusSearchRowBasic',
            'OtherNameCategorySearchBasic' => '\\StructType\\OtherNameCategorySearchBasic',
            'OtherNameCategorySearchRowBasic' => '\\StructType\\OtherNameCategorySearchRowBasic',
            'CustomerMessageSearchBasic' => '\\StructType\\CustomerMessageSearchBasic',
            'CustomerMessageSearchRowBasic' => '\\StructType\\CustomerMessageSearchRowBasic',
            'ItemDemandPlanSearchBasic' => '\\StructType\\ItemDemandPlanSearchBasic',
            'ItemDemandPlanSearchRowBasic' => '\\StructType\\ItemDemandPlanSearchRowBasic',
            'ItemSupplyPlanSearchBasic' => '\\StructType\\ItemSupplyPlanSearchBasic',
            'ItemSupplyPlanSearchRowBasic' => '\\StructType\\ItemSupplyPlanSearchRowBasic',
            'CurrencyRateSearchBasic' => '\\StructType\\CurrencyRateSearchBasic',
            'CurrencyRateSearchRowBasic' => '\\StructType\\CurrencyRateSearchRowBasic',
            'ItemRevisionSearchBasic' => '\\StructType\\ItemRevisionSearchBasic',
            'ItemRevisionSearchRowBasic' => '\\StructType\\ItemRevisionSearchRowBasic',
            'CouponCodeSearchBasic' => '\\StructType\\CouponCodeSearchBasic',
            'CouponCodeSearchRowBasic' => '\\StructType\\CouponCodeSearchRowBasic',
            'PayrollItemSearchBasic' => '\\StructType\\PayrollItemSearchBasic',
            'PayrollItemSearchRowBasic' => '\\StructType\\PayrollItemSearchRowBasic',
            'ManufacturingCostTemplateSearchBasic' => '\\StructType\\ManufacturingCostTemplateSearchBasic',
            'ManufacturingCostTemplateSearchRowBasic' => '\\StructType\\ManufacturingCostTemplateSearchRowBasic',
            'ManufacturingRoutingSearchBasic' => '\\StructType\\ManufacturingRoutingSearchBasic',
            'ManufacturingRoutingSearchRowBasic' => '\\StructType\\ManufacturingRoutingSearchRowBasic',
            'ManufacturingOperationTaskSearchBasic' => '\\StructType\\ManufacturingOperationTaskSearchBasic',
            'ManufacturingOperationTaskSearchRowBasic' => '\\StructType\\ManufacturingOperationTaskSearchRowBasic',
            'ResourceAllocationSearchBasic' => '\\StructType\\ResourceAllocationSearchBasic',
            'ResourceAllocationSearchRowBasic' => '\\StructType\\ResourceAllocationSearchRowBasic',
            'CustomSearchJoin' => '\\StructType\\CustomSearchJoin',
            'CustomSearchRowBasic' => '\\StructType\\CustomSearchRowBasic',
            'ChargeSearchBasic' => '\\StructType\\ChargeSearchBasic',
            'ChargeSearchRowBasic' => '\\StructType\\ChargeSearchRowBasic',
            'BillingScheduleSearchBasic' => '\\StructType\\BillingScheduleSearchBasic',
            'BillingScheduleSearchRowBasic' => '\\StructType\\BillingScheduleSearchRowBasic',
            'GlobalAccountMappingSearchBasic' => '\\StructType\\GlobalAccountMappingSearchBasic',
            'GlobalAccountMappingSearchRowBasic' => '\\StructType\\GlobalAccountMappingSearchRowBasic',
            'ItemAccountMappingSearchBasic' => '\\StructType\\ItemAccountMappingSearchBasic',
            'ItemAccountMappingSearchRowBasic' => '\\StructType\\ItemAccountMappingSearchRowBasic',
            'TimeEntrySearchBasic' => '\\StructType\\TimeEntrySearchBasic',
            'TimeEntrySearchRowBasic' => '\\StructType\\TimeEntrySearchRowBasic',
            'TimeSheetSearchBasic' => '\\StructType\\TimeSheetSearchBasic',
            'TimeSheetSearchRowBasic' => '\\StructType\\TimeSheetSearchRowBasic',
            'AccountingTransactionSearchBasic' => '\\StructType\\AccountingTransactionSearchBasic',
            'AccountingTransactionSearchRowBasic' => '\\StructType\\AccountingTransactionSearchRowBasic',
            'AddressSearchBasic' => '\\StructType\\AddressSearchBasic',
            'AddressSearchRowBasic' => '\\StructType\\AddressSearchRowBasic',
            'BillingAccountSearchBasic' => '\\StructType\\BillingAccountSearchBasic',
            'BillingAccountSearchRowBasic' => '\\StructType\\BillingAccountSearchRowBasic',
            'FairValuePriceSearchBasic' => '\\StructType\\FairValuePriceSearchBasic',
            'FairValuePriceSearchRowBasic' => '\\StructType\\FairValuePriceSearchRowBasic',
            'UsageSearchBasic' => '\\StructType\\UsageSearchBasic',
            'UsageSearchRowBasic' => '\\StructType\\UsageSearchRowBasic',
            'CostCategorySearchBasic' => '\\StructType\\CostCategorySearchBasic',
            'CostCategorySearchRowBasic' => '\\StructType\\CostCategorySearchRowBasic',
            'ConsolidatedExchangeRateSearchBasic' => '\\StructType\\ConsolidatedExchangeRateSearchBasic',
            'ConsolidatedExchangeRateSearchRowBasic' => '\\StructType\\ConsolidatedExchangeRateSearchRowBasic',
            'TaxDetails' => '\\StructType\\TaxDetails',
            'TaxDetailsList' => '\\StructType\\TaxDetailsList',
            'TaxDetailSearchBasic' => '\\StructType\\TaxDetailSearchBasic',
            'TaxDetailSearchRowBasic' => '\\StructType\\TaxDetailSearchRowBasic',
            'TaxGroupSearchBasic' => '\\StructType\\TaxGroupSearchBasic',
            'TaxGroupSearchRowBasic' => '\\StructType\\TaxGroupSearchRowBasic',
            'SalesTaxItemSearchBasic' => '\\StructType\\SalesTaxItemSearchBasic',
            'SalesTaxItemSearchRowBasic' => '\\StructType\\SalesTaxItemSearchRowBasic',
            'TaxTypeSearchBasic' => '\\StructType\\TaxTypeSearchBasic',
            'TaxTypeSearchRowBasic' => '\\StructType\\TaxTypeSearchRowBasic',
            'PaycheckSearchBasic' => '\\StructType\\PaycheckSearchBasic',
            'PaycheckSearchRowBasic' => '\\StructType\\PaycheckSearchRowBasic',
            'HcmJobSearchBasic' => '\\StructType\\HcmJobSearchBasic',
            'HcmJobSearchRowBasic' => '\\StructType\\HcmJobSearchRowBasic',
            'BomSearchBasic' => '\\StructType\\BomSearchBasic',
            'BomSearchRowBasic' => '\\StructType\\BomSearchRowBasic',
            'BomRevisionSearchBasic' => '\\StructType\\BomRevisionSearchBasic',
            'BomRevisionSearchRowBasic' => '\\StructType\\BomRevisionSearchRowBasic',
            'BomRevisionComponentSearchBasic' => '\\StructType\\BomRevisionComponentSearchBasic',
            'BomRevisionComponentSearchRowBasic' => '\\StructType\\BomRevisionComponentSearchRowBasic',
            'InboundShipmentSearchBasic' => '\\StructType\\InboundShipmentSearchBasic',
            'InboundShipmentSearchRowBasic' => '\\StructType\\InboundShipmentSearchRowBasic',
            'AssemblyItemBomSearchBasic' => '\\StructType\\AssemblyItemBomSearchBasic',
            'AssemblyItemBomSearchRowBasic' => '\\StructType\\AssemblyItemBomSearchRowBasic',
            'MseSubsidiarySearchBasic' => '\\StructType\\MseSubsidiarySearchBasic',
            'MseSubsidiarySearchRowBasic' => '\\StructType\\MseSubsidiarySearchRowBasic',
            'EntityTaxRegistrationSearchBasic' => '\\StructType\\EntityTaxRegistrationSearchBasic',
            'EntityTaxRegistrationSearchRowBasic' => '\\StructType\\EntityTaxRegistrationSearchRowBasic',
            'MerchandiseHierarchyNodeSearchBasic' => '\\StructType\\MerchandiseHierarchyNodeSearchBasic',
            'MerchandiseHierarchyNodeSearchRowBasic' => '\\StructType\\MerchandiseHierarchyNodeSearchRowBasic',
            'CustomerSubsidiaryRelationshipSearchBasic' => '\\StructType\\CustomerSubsidiaryRelationshipSearchBasic',
            'CustomerSubsidiaryRelationshipSearchRowBasic' => '\\StructType\\CustomerSubsidiaryRelationshipSearchRowBasic',
            'VendorSubsidiaryRelationshipSearchBasic' => '\\StructType\\VendorSubsidiaryRelationshipSearchBasic',
            'VendorSubsidiaryRelationshipSearchRowBasic' => '\\StructType\\VendorSubsidiaryRelationshipSearchRowBasic',
            'GiftCertRedemption' => '\\StructType\\GiftCertRedemption',
            'GiftCertRedemptionList' => '\\StructType\\GiftCertRedemptionList',
            'InstallmentSearchBasic' => '\\StructType\\InstallmentSearchBasic',
            'InstallmentSearchRowBasic' => '\\StructType\\InstallmentSearchRowBasic',
            'PaymentInstrumentSearchBasic' => '\\StructType\\PaymentInstrumentSearchBasic',
            'PaymentInstrumentSearchRowBasic' => '\\StructType\\PaymentInstrumentSearchRowBasic',
            'PaymentOptionSearchBasic' => '\\StructType\\PaymentOptionSearchBasic',
            'PaymentOptionSearchRowBasic' => '\\StructType\\PaymentOptionSearchRowBasic',
            'CalendarEvent' => '\\StructType\\CalendarEvent',
            'ExclusionDateList' => '\\StructType\\ExclusionDateList',
            'CalendarEventAttendee' => '\\StructType\\CalendarEventAttendee',
            'CalendarEventAttendeeList' => '\\StructType\\CalendarEventAttendeeList',
            'CalendarEventResource' => '\\StructType\\CalendarEventResource',
            'CalendarEventResourceList' => '\\StructType\\CalendarEventResourceList',
            'CalendarEventSearch' => '\\StructType\\CalendarEventSearch',
            'CalendarEventSearchAdvanced' => '\\StructType\\CalendarEventSearchAdvanced',
            'CalendarEventSearchRow' => '\\StructType\\CalendarEventSearchRow',
            'Task' => '\\StructType\\Task',
            'TaskContact' => '\\StructType\\TaskContact',
            'TaskContactList' => '\\StructType\\TaskContactList',
            'TaskSearch' => '\\StructType\\TaskSearch',
            'TaskSearchAdvanced' => '\\StructType\\TaskSearchAdvanced',
            'TaskSearchRow' => '\\StructType\\TaskSearchRow',
            'PhoneCall' => '\\StructType\\PhoneCall',
            'PhoneCallContact' => '\\StructType\\PhoneCallContact',
            'PhoneCallContactList' => '\\StructType\\PhoneCallContactList',
            'PhoneCallSearch' => '\\StructType\\PhoneCallSearch',
            'PhoneCallSearchAdvanced' => '\\StructType\\PhoneCallSearchAdvanced',
            'PhoneCallSearchRow' => '\\StructType\\PhoneCallSearchRow',
            'ProjectTask' => '\\StructType\\ProjectTask',
            'ProjectTaskPredecessor' => '\\StructType\\ProjectTaskPredecessor',
            'ProjectTaskPredecessorList' => '\\StructType\\ProjectTaskPredecessorList',
            'ProjectTaskAssignee' => '\\StructType\\ProjectTaskAssignee',
            'ProjectTaskAssigneeList' => '\\StructType\\ProjectTaskAssigneeList',
            'ProjectTaskSearch' => '\\StructType\\ProjectTaskSearch',
            'ProjectTaskSearchAdvanced' => '\\StructType\\ProjectTaskSearchAdvanced',
            'ProjectTaskSearchRow' => '\\StructType\\ProjectTaskSearchRow',
            'PhoneCallTimeItemList' => '\\StructType\\PhoneCallTimeItemList',
            'CalendarEventTimeItemList' => '\\StructType\\CalendarEventTimeItemList',
            'TaskTimeItemList' => '\\StructType\\TaskTimeItemList',
            'ProjectTaskTimeItemList' => '\\StructType\\ProjectTaskTimeItemList',
            'ResourceAllocation' => '\\StructType\\ResourceAllocation',
            'ResourceAllocationSearch' => '\\StructType\\ResourceAllocationSearch',
            'ResourceAllocationSearchAdvanced' => '\\StructType\\ResourceAllocationSearchAdvanced',
            'ResourceAllocationSearchRow' => '\\StructType\\ResourceAllocationSearchRow',
            'File' => '\\StructType\\File',
            'FileSiteCategory' => '\\StructType\\FileSiteCategory',
            'FileSiteCategoryList' => '\\StructType\\FileSiteCategoryList',
            'FileSearch' => '\\StructType\\FileSearch',
            'FileSearchAdvanced' => '\\StructType\\FileSearchAdvanced',
            'FileSearchRow' => '\\StructType\\FileSearchRow',
            'Folder' => '\\StructType\\Folder',
            'FolderSearch' => '\\StructType\\FolderSearch',
            'FolderSearchAdvanced' => '\\StructType\\FolderSearchAdvanced',
            'FolderSearchRow' => '\\StructType\\FolderSearchRow',
            'Note' => '\\StructType\\Note',
            'NoteSearch' => '\\StructType\\NoteSearch',
            'NoteSearchAdvanced' => '\\StructType\\NoteSearchAdvanced',
            'NoteSearchRow' => '\\StructType\\NoteSearchRow',
            'Message' => '\\StructType\\Message',
            'MessageMediaItemList' => '\\StructType\\MessageMediaItemList',
            'MessageSearch' => '\\StructType\\MessageSearch',
            'MessageSearchAdvanced' => '\\StructType\\MessageSearchAdvanced',
            'MessageSearchRow' => '\\StructType\\MessageSearchRow',
            'Subscriptions' => '\\StructType\\Subscriptions',
            'SubscriptionsList' => '\\StructType\\SubscriptionsList',
            'Contact' => '\\StructType\\Contact',
            'CategoryList' => '\\StructType\\CategoryList',
            'ContactAddressbook' => '\\StructType\\ContactAddressbook',
            'ContactAddressbookList' => '\\StructType\\ContactAddressbookList',
            'ContactSearch' => '\\StructType\\ContactSearch',
            'ContactSearchAdvanced' => '\\StructType\\ContactSearchAdvanced',
            'ContactSearchRow' => '\\StructType\\ContactSearchRow',
            'Customer' => '\\StructType\\Customer',
            'CustomerDownload' => '\\StructType\\CustomerDownload',
            'CustomerDownloadList' => '\\StructType\\CustomerDownloadList',
            'ContactAccessRoles' => '\\StructType\\ContactAccessRoles',
            'ContactAccessRolesList' => '\\StructType\\ContactAccessRolesList',
            'CustomerSalesTeamList' => '\\StructType\\CustomerSalesTeamList',
            'CustomerAddressbook' => '\\StructType\\CustomerAddressbook',
            'CustomerAddressbookList' => '\\StructType\\CustomerAddressbookList',
            'CustomerCreditCards' => '\\StructType\\CustomerCreditCards',
            'CustomerCreditCardsList' => '\\StructType\\CustomerCreditCardsList',
            'CustomerGroupPricing' => '\\StructType\\CustomerGroupPricing',
            'CustomerGroupPricingList' => '\\StructType\\CustomerGroupPricingList',
            'CustomerItemPricing' => '\\StructType\\CustomerItemPricing',
            'CustomerItemPricingList' => '\\StructType\\CustomerItemPricingList',
            'CustomerPartnersList' => '\\StructType\\CustomerPartnersList',
            'CustomerSearch' => '\\StructType\\CustomerSearch',
            'CustomerSearchAdvanced' => '\\StructType\\CustomerSearchAdvanced',
            'CustomerSearchRow' => '\\StructType\\CustomerSearchRow',
            'CustomerStatus' => '\\StructType\\CustomerStatus',
            'Partner' => '\\StructType\\Partner',
            'PartnerPromoCode' => '\\StructType\\PartnerPromoCode',
            'PartnerPromoCodeList' => '\\StructType\\PartnerPromoCodeList',
            'PartnerAddressbook' => '\\StructType\\PartnerAddressbook',
            'PartnerAddressbookList' => '\\StructType\\PartnerAddressbookList',
            'PartnerSearch' => '\\StructType\\PartnerSearch',
            'PartnerSearchAdvanced' => '\\StructType\\PartnerSearchAdvanced',
            'PartnerSearchRow' => '\\StructType\\PartnerSearchRow',
            'Vendor' => '\\StructType\\Vendor',
            'VendorPricingSchedule' => '\\StructType\\VendorPricingSchedule',
            'VendorPricingScheduleList' => '\\StructType\\VendorPricingScheduleList',
            'VendorAddressbook' => '\\StructType\\VendorAddressbook',
            'VendorAddressbookList' => '\\StructType\\VendorAddressbookList',
            'VendorRoles' => '\\StructType\\VendorRoles',
            'VendorRolesList' => '\\StructType\\VendorRolesList',
            'VendorSearch' => '\\StructType\\VendorSearch',
            'VendorSearchAdvanced' => '\\StructType\\VendorSearchAdvanced',
            'VendorSearchRow' => '\\StructType\\VendorSearchRow',
            'EntityGroup' => '\\StructType\\EntityGroup',
            'EntityGroupSearch' => '\\StructType\\EntityGroupSearch',
            'EntityGroupSearchAdvanced' => '\\StructType\\EntityGroupSearchAdvanced',
            'EntityGroupSearchRow' => '\\StructType\\EntityGroupSearchRow',
            'Job' => '\\StructType\\Job',
            'JobAddressbook' => '\\StructType\\JobAddressbook',
            'JobAddressbookList' => '\\StructType\\JobAddressbookList',
            'JobResources' => '\\StructType\\JobResources',
            'JobResourcesList' => '\\StructType\\JobResourcesList',
            'JobMilestones' => '\\StructType\\JobMilestones',
            'JobMilestonesList' => '\\StructType\\JobMilestonesList',
            'JobCreditCards' => '\\StructType\\JobCreditCards',
            'JobCreditCardsList' => '\\StructType\\JobCreditCardsList',
            'JobSearch' => '\\StructType\\JobSearch',
            'JobSearchAdvanced' => '\\StructType\\JobSearchAdvanced',
            'JobSearchRow' => '\\StructType\\JobSearchRow',
            'JobType' => '\\StructType\\JobType',
            'JobStatus' => '\\StructType\\JobStatus',
            'CustomerStatusSearch' => '\\StructType\\CustomerStatusSearch',
            'CustomerStatusSearchAdvanced' => '\\StructType\\CustomerStatusSearchAdvanced',
            'CustomerStatusSearchRow' => '\\StructType\\CustomerStatusSearchRow',
            'JobStatusSearch' => '\\StructType\\JobStatusSearch',
            'JobStatusSearchAdvanced' => '\\StructType\\JobStatusSearchAdvanced',
            'JobStatusSearchRow' => '\\StructType\\JobStatusSearchRow',
            'JobTypeSearch' => '\\StructType\\JobTypeSearch',
            'JobTypeSearchAdvanced' => '\\StructType\\JobTypeSearchAdvanced',
            'JobTypeSearchRow' => '\\StructType\\JobTypeSearchRow',
            'OriginatingLeadSearch' => '\\StructType\\OriginatingLeadSearch',
            'OriginatingLeadSearchRow' => '\\StructType\\OriginatingLeadSearchRow',
            'CustomerCurrency' => '\\StructType\\CustomerCurrency',
            'CustomerCurrencyList' => '\\StructType\\CustomerCurrencyList',
            'VendorCurrency' => '\\StructType\\VendorCurrency',
            'VendorCurrencyList' => '\\StructType\\VendorCurrencyList',
            'JobPlStatement' => '\\StructType\\JobPlStatement',
            'JobPlStatementList' => '\\StructType\\JobPlStatementList',
            'BillingAccount' => '\\StructType\\BillingAccount',
            'BillingAccountSearch' => '\\StructType\\BillingAccountSearch',
            'BillingAccountSearchAdvanced' => '\\StructType\\BillingAccountSearchAdvanced',
            'BillingAccountSearchRow' => '\\StructType\\BillingAccountSearchRow',
            'JobPercentCompleteOverride' => '\\StructType\\JobPercentCompleteOverride',
            'JobPercentCompleteOverrideList' => '\\StructType\\JobPercentCompleteOverrideList',
            'CustomerTaxRegistration' => '\\StructType\\CustomerTaxRegistration',
            'CustomerTaxRegistrationList' => '\\StructType\\CustomerTaxRegistrationList',
            'PartnerTaxRegistration' => '\\StructType\\PartnerTaxRegistration',
            'PartnerTaxRegistrationList' => '\\StructType\\PartnerTaxRegistrationList',
            'VendorTaxRegistration' => '\\StructType\\VendorTaxRegistration',
            'VendorTaxRegistrationList' => '\\StructType\\VendorTaxRegistrationList',
            'CustomerSubsidiaryRelationship' => '\\StructType\\CustomerSubsidiaryRelationship',
            'CustomerSubsidiaryRelationshipSearch' => '\\StructType\\CustomerSubsidiaryRelationshipSearch',
            'CustomerSubsidiaryRelationshipSearchAdvanced' => '\\StructType\\CustomerSubsidiaryRelationshipSearchAdvanced',
            'CustomerSubsidiaryRelationshipSearchRow' => '\\StructType\\CustomerSubsidiaryRelationshipSearchRow',
            'VendorSubsidiaryRelationship' => '\\StructType\\VendorSubsidiaryRelationship',
            'VendorSubsidiaryRelationshipSearch' => '\\StructType\\VendorSubsidiaryRelationshipSearch',
            'VendorSubsidiaryRelationshipSearchAdvanced' => '\\StructType\\VendorSubsidiaryRelationshipSearchAdvanced',
            'VendorSubsidiaryRelationshipSearchRow' => '\\StructType\\VendorSubsidiaryRelationshipSearchRow',
            'SupportCase' => '\\StructType\\SupportCase',
            'EmailEmployeesList' => '\\StructType\\EmailEmployeesList',
            'SupportCaseEscalateTo' => '\\StructType\\SupportCaseEscalateTo',
            'SupportCaseEscalateToList' => '\\StructType\\SupportCaseEscalateToList',
            'SupportCaseSolutions' => '\\StructType\\SupportCaseSolutions',
            'SupportCaseSolutionsList' => '\\StructType\\SupportCaseSolutionsList',
            'SupportCaseTimeItemList' => '\\StructType\\SupportCaseTimeItemList',
            'SupportCaseSearch' => '\\StructType\\SupportCaseSearch',
            'SupportCaseSearchAdvanced' => '\\StructType\\SupportCaseSearchAdvanced',
            'SupportCaseSearchRow' => '\\StructType\\SupportCaseSearchRow',
            'SupportCaseStatus' => '\\StructType\\SupportCaseStatus',
            'SupportCaseType' => '\\StructType\\SupportCaseType',
            'SupportCaseOrigin' => '\\StructType\\SupportCaseOrigin',
            'SupportCaseIssue' => '\\StructType\\SupportCaseIssue',
            'SupportCasePriority' => '\\StructType\\SupportCasePriority',
            'Solution' => '\\StructType\\Solution',
            'SolutionTopics' => '\\StructType\\SolutionTopics',
            'SolutionTopicsList' => '\\StructType\\SolutionTopicsList',
            'Solutions' => '\\StructType\\Solutions',
            'SolutionsList' => '\\StructType\\SolutionsList',
            'SolutionSearch' => '\\StructType\\SolutionSearch',
            'SolutionSearchAdvanced' => '\\StructType\\SolutionSearchAdvanced',
            'SolutionSearchRow' => '\\StructType\\SolutionSearchRow',
            'Topic' => '\\StructType\\Topic',
            'TopicSolution' => '\\StructType\\TopicSolution',
            'TopicSolutionList' => '\\StructType\\TopicSolutionList',
            'TopicSearch' => '\\StructType\\TopicSearch',
            'TopicSearchAdvanced' => '\\StructType\\TopicSearchAdvanced',
            'TopicSearchRow' => '\\StructType\\TopicSearchRow',
            'Issue' => '\\StructType\\Issue',
            'IssueVersion' => '\\StructType\\IssueVersion',
            'IssueVersionList' => '\\StructType\\IssueVersionList',
            'IssueSearch' => '\\StructType\\IssueSearch',
            'IssueSearchAdvanced' => '\\StructType\\IssueSearchAdvanced',
            'IssueSearchRow' => '\\StructType\\IssueSearchRow',
            'IssueRelatedIssues' => '\\StructType\\IssueRelatedIssues',
            'IssueRelatedIssuesList' => '\\StructType\\IssueRelatedIssuesList',
            'ClassTranslation' => '\\StructType\\ClassTranslation',
            'ClassTranslationList' => '\\StructType\\ClassTranslationList',
            'ContactCategory' => '\\StructType\\ContactCategory',
            'CustomerCategory' => '\\StructType\\CustomerCategory',
            'SalesRole' => '\\StructType\\SalesRole',
            'PriceLevel' => '\\StructType\\PriceLevel',
            'WinLossReason' => '\\StructType\\WinLossReason',
            'Term' => '\\StructType\\Term',
            'NoteType' => '\\StructType\\NoteType',
            'PaymentMethod' => '\\StructType\\PaymentMethod',
            'LeadSource' => '\\StructType\\LeadSource',
            'Price' => '\\StructType\\Price',
            'PriceList' => '\\StructType\\PriceList',
            'Pricing' => '\\StructType\\Pricing',
            'PricingMatrix' => '\\StructType\\PricingMatrix',
            'Rate' => '\\StructType\\Rate',
            'RateList' => '\\StructType\\RateList',
            'BillingRates' => '\\StructType\\BillingRates',
            'BillingRatesMatrix' => '\\StructType\\BillingRatesMatrix',
            'Translation' => '\\StructType\\Translation',
            'TranslationList' => '\\StructType\\TranslationList',
            'ItemOptionsList' => '\\StructType\\ItemOptionsList',
            'ItemVendor' => '\\StructType\\ItemVendor',
            'ItemVendorList' => '\\StructType\\ItemVendorList',
            'SiteCategory' => '\\StructType\\SiteCategory',
            'SiteCategoryList' => '\\StructType\\SiteCategoryList',
            'ProductFeedList' => '\\StructType\\ProductFeedList',
            'ItemMember' => '\\StructType\\ItemMember',
            'ItemMemberList' => '\\StructType\\ItemMemberList',
            'InventoryItem' => '\\StructType\\InventoryItem',
            'MatrixOptionList' => '\\StructType\\MatrixOptionList',
            'InventoryItemBinNumber' => '\\StructType\\InventoryItemBinNumber',
            'InventoryItemBinNumberList' => '\\StructType\\InventoryItemBinNumberList',
            'InventoryItemLocations' => '\\StructType\\InventoryItemLocations',
            'InventoryItemLocationsList' => '\\StructType\\InventoryItemLocationsList',
            'PresentationItemList' => '\\StructType\\PresentationItemList',
            'DescriptionItem' => '\\StructType\\DescriptionItem',
            'DiscountItem' => '\\StructType\\DiscountItem',
            'DownloadItem' => '\\StructType\\DownloadItem',
            'MarkupItem' => '\\StructType\\MarkupItem',
            'PaymentItem' => '\\StructType\\PaymentItem',
            'SubtotalItem' => '\\StructType\\SubtotalItem',
            'NonInventoryPurchaseItem' => '\\StructType\\NonInventoryPurchaseItem',
            'NonInventorySaleItem' => '\\StructType\\NonInventorySaleItem',
            'NonInventoryResaleItem' => '\\StructType\\NonInventoryResaleItem',
            'OtherChargeResaleItem' => '\\StructType\\OtherChargeResaleItem',
            'OtherChargePurchaseItem' => '\\StructType\\OtherChargePurchaseItem',
            'ServiceResaleItem' => '\\StructType\\ServiceResaleItem',
            'ServicePurchaseItem' => '\\StructType\\ServicePurchaseItem',
            'ServiceSaleItem' => '\\StructType\\ServiceSaleItem',
            'OtherChargeSaleItem' => '\\StructType\\OtherChargeSaleItem',
            'Currency' => '\\StructType\\Currency',
            'ExpenseCategory' => '\\StructType\\ExpenseCategory',
            'Account' => '\\StructType\\Account',
            'AccountSearch' => '\\StructType\\AccountSearch',
            'AccountSearchAdvanced' => '\\StructType\\AccountSearchAdvanced',
            'AccountSearchRow' => '\\StructType\\AccountSearchRow',
            'Department' => '\\StructType\\Department',
            'DepartmentSearch' => '\\StructType\\DepartmentSearch',
            'DepartmentSearchAdvanced' => '\\StructType\\DepartmentSearchAdvanced',
            'DepartmentSearchRow' => '\\StructType\\DepartmentSearchRow',
            'Classification' => '\\StructType\\Classification',
            'ClassificationSearch' => '\\StructType\\ClassificationSearch',
            'ClassificationSearchAdvanced' => '\\StructType\\ClassificationSearchAdvanced',
            'ClassificationSearchRow' => '\\StructType\\ClassificationSearchRow',
            'Location' => '\\StructType\\Location',
            'LocationSearch' => '\\StructType\\LocationSearch',
            'LocationSearchAdvanced' => '\\StructType\\LocationSearchAdvanced',
            'LocationSearchRow' => '\\StructType\\LocationSearchRow',
            'UnitsType' => '\\StructType\\UnitsType',
            'UnitsTypeUom' => '\\StructType\\UnitsTypeUom',
            'UnitsTypeUomList' => '\\StructType\\UnitsTypeUomList',
            'ItemSearch' => '\\StructType\\ItemSearch',
            'ItemSearchAdvanced' => '\\StructType\\ItemSearchAdvanced',
            'ItemSearchRow' => '\\StructType\\ItemSearchRow',
            'ContactRole' => '\\StructType\\ContactRole',
            'Bin' => '\\StructType\\Bin',
            'BinSearch' => '\\StructType\\BinSearch',
            'BinSearchAdvanced' => '\\StructType\\BinSearchAdvanced',
            'BinSearchRow' => '\\StructType\\BinSearchRow',
            'SalesTaxItem' => '\\StructType\\SalesTaxItem',
            'TaxGroup' => '\\StructType\\TaxGroup',
            'TaxGroupTaxItem' => '\\StructType\\TaxGroupTaxItem',
            'TaxGroupTaxItemList' => '\\StructType\\TaxGroupTaxItemList',
            'TaxType' => '\\StructType\\TaxType',
            'TaxTypeNexusesTax' => '\\StructType\\TaxTypeNexusesTax',
            'TaxTypeNexusesTaxList' => '\\StructType\\TaxTypeNexusesTaxList',
            'SerializedInventoryItem' => '\\StructType\\SerializedInventoryItem',
            'SerializedInventoryItemLocations' => '\\StructType\\SerializedInventoryItemLocations',
            'SerializedInventoryItemLocationsList' => '\\StructType\\SerializedInventoryItemLocationsList',
            'SerializedInventoryItemNumbers' => '\\StructType\\SerializedInventoryItemNumbers',
            'SerializedInventoryItemNumbersList' => '\\StructType\\SerializedInventoryItemNumbersList',
            'LotNumberedInventoryItem' => '\\StructType\\LotNumberedInventoryItem',
            'LotNumberedInventoryItemLocations' => '\\StructType\\LotNumberedInventoryItemLocations',
            'LotNumberedInventoryItemLocationsList' => '\\StructType\\LotNumberedInventoryItemLocationsList',
            'LotNumberedInventoryItemNumbers' => '\\StructType\\LotNumberedInventoryItemNumbers',
            'LotNumberedInventoryItemNumbersList' => '\\StructType\\LotNumberedInventoryItemNumbersList',
            'GiftCertificateItem' => '\\StructType\\GiftCertificateItem',
            'GiftCertificateItemAuthCodes' => '\\StructType\\GiftCertificateItemAuthCodes',
            'GiftCertificateItemAuthCodesList' => '\\StructType\\GiftCertificateItemAuthCodesList',
            'Subsidiary' => '\\StructType\\Subsidiary',
            'SubsidiaryNexus' => '\\StructType\\SubsidiaryNexus',
            'SubsidiaryNexusList' => '\\StructType\\SubsidiaryNexusList',
            'SubsidiarySearch' => '\\StructType\\SubsidiarySearch',
            'SubsidiarySearchAdvanced' => '\\StructType\\SubsidiarySearchAdvanced',
            'SubsidiarySearchRow' => '\\StructType\\SubsidiarySearchRow',
            'GiftCertificate' => '\\StructType\\GiftCertificate',
            'GiftCertificateSearch' => '\\StructType\\GiftCertificateSearch',
            'GiftCertificateSearchAdvanced' => '\\StructType\\GiftCertificateSearchAdvanced',
            'GiftCertificateSearchRow' => '\\StructType\\GiftCertificateSearchRow',
            'PartnerCategory' => '\\StructType\\PartnerCategory',
            'VendorCategory' => '\\StructType\\VendorCategory',
            'KitItem' => '\\StructType\\KitItem',
            'AssemblyItem' => '\\StructType\\AssemblyItem',
            'SerializedAssemblyItem' => '\\StructType\\SerializedAssemblyItem',
            'LotNumberedAssemblyItem' => '\\StructType\\LotNumberedAssemblyItem',
            'ServiceItemTaskTemplates' => '\\StructType\\ServiceItemTaskTemplates',
            'ServiceItemTaskTemplatesList' => '\\StructType\\ServiceItemTaskTemplatesList',
            'State' => '\\StructType\\State',
            'AccountingPeriod' => '\\StructType\\AccountingPeriod',
            'BudgetCategory' => '\\StructType\\BudgetCategory',
            'AccountingPeriodSearch' => '\\StructType\\AccountingPeriodSearch',
            'AccountingPeriodSearchAdvanced' => '\\StructType\\AccountingPeriodSearchAdvanced',
            'AccountingPeriodSearchRow' => '\\StructType\\AccountingPeriodSearchRow',
            'ContactCategorySearch' => '\\StructType\\ContactCategorySearch',
            'ContactCategorySearchAdvanced' => '\\StructType\\ContactCategorySearchAdvanced',
            'ContactCategorySearchRow' => '\\StructType\\ContactCategorySearchRow',
            'ContactRoleSearch' => '\\StructType\\ContactRoleSearch',
            'ContactRoleSearchAdvanced' => '\\StructType\\ContactRoleSearchAdvanced',
            'ContactRoleSearchRow' => '\\StructType\\ContactRoleSearchRow',
            'CustomerCategorySearch' => '\\StructType\\CustomerCategorySearch',
            'CustomerCategorySearchAdvanced' => '\\StructType\\CustomerCategorySearchAdvanced',
            'CustomerCategorySearchRow' => '\\StructType\\CustomerCategorySearchRow',
            'ExpenseCategorySearch' => '\\StructType\\ExpenseCategorySearch',
            'ExpenseCategorySearchAdvanced' => '\\StructType\\ExpenseCategorySearchAdvanced',
            'ExpenseCategorySearchRow' => '\\StructType\\ExpenseCategorySearchRow',
            'NoteTypeSearch' => '\\StructType\\NoteTypeSearch',
            'NoteTypeSearchAdvanced' => '\\StructType\\NoteTypeSearchAdvanced',
            'NoteTypeSearchRow' => '\\StructType\\NoteTypeSearchRow',
            'PartnerCategorySearch' => '\\StructType\\PartnerCategorySearch',
            'PartnerCategorySearchAdvanced' => '\\StructType\\PartnerCategorySearchAdvanced',
            'PartnerCategorySearchRow' => '\\StructType\\PartnerCategorySearchRow',
            'PaymentMethodSearch' => '\\StructType\\PaymentMethodSearch',
            'PaymentMethodSearchAdvanced' => '\\StructType\\PaymentMethodSearchAdvanced',
            'PaymentMethodSearchRow' => '\\StructType\\PaymentMethodSearchRow',
            'PriceLevelSearch' => '\\StructType\\PriceLevelSearch',
            'PriceLevelSearchAdvanced' => '\\StructType\\PriceLevelSearchAdvanced',
            'PriceLevelSearchRow' => '\\StructType\\PriceLevelSearchRow',
            'SalesRoleSearch' => '\\StructType\\SalesRoleSearch',
            'SalesRoleSearchAdvanced' => '\\StructType\\SalesRoleSearchAdvanced',
            'SalesRoleSearchRow' => '\\StructType\\SalesRoleSearchRow',
            'TermSearch' => '\\StructType\\TermSearch',
            'TermSearchAdvanced' => '\\StructType\\TermSearchAdvanced',
            'TermSearchRow' => '\\StructType\\TermSearchRow',
            'VendorCategorySearch' => '\\StructType\\VendorCategorySearch',
            'VendorCategorySearchAdvanced' => '\\StructType\\VendorCategorySearchAdvanced',
            'VendorCategorySearchRow' => '\\StructType\\VendorCategorySearchRow',
            'WinLossReasonSearch' => '\\StructType\\WinLossReasonSearch',
            'WinLossReasonSearchAdvanced' => '\\StructType\\WinLossReasonSearchAdvanced',
            'WinLossReasonSearchRow' => '\\StructType\\WinLossReasonSearchRow',
            'UnitsTypeSearch' => '\\StructType\\UnitsTypeSearch',
            'UnitsTypeSearchAdvanced' => '\\StructType\\UnitsTypeSearchAdvanced',
            'UnitsTypeSearchRow' => '\\StructType\\UnitsTypeSearchRow',
            'PricingGroup' => '\\StructType\\PricingGroup',
            'PricingGroupSearch' => '\\StructType\\PricingGroupSearch',
            'PricingGroupSearchAdvanced' => '\\StructType\\PricingGroupSearchAdvanced',
            'PricingGroupSearchRow' => '\\StructType\\PricingGroupSearchRow',
            'InventoryNumber' => '\\StructType\\InventoryNumber',
            'InventoryNumberLocations' => '\\StructType\\InventoryNumberLocations',
            'InventoryNumberLocationsList' => '\\StructType\\InventoryNumberLocationsList',
            'InventoryNumberSearch' => '\\StructType\\InventoryNumberSearch',
            'InventoryNumberSearchAdvanced' => '\\StructType\\InventoryNumberSearchAdvanced',
            'InventoryNumberSearchRow' => '\\StructType\\InventoryNumberSearchRow',
            'RevRecSchedule' => '\\StructType\\RevRecSchedule',
            'RevRecScheduleRecurrence' => '\\StructType\\RevRecScheduleRecurrence',
            'RevRecScheduleRecurrenceList' => '\\StructType\\RevRecScheduleRecurrenceList',
            'RevRecTemplate' => '\\StructType\\RevRecTemplate',
            'RevRecTemplateRecurrence' => '\\StructType\\RevRecTemplateRecurrence',
            'RevRecTemplateRecurrenceList' => '\\StructType\\RevRecTemplateRecurrenceList',
            'RevRecScheduleSearch' => '\\StructType\\RevRecScheduleSearch',
            'RevRecScheduleSearchAdvanced' => '\\StructType\\RevRecScheduleSearchAdvanced',
            'RevRecScheduleSearchRow' => '\\StructType\\RevRecScheduleSearchRow',
            'RevRecTemplateSearch' => '\\StructType\\RevRecTemplateSearch',
            'RevRecTemplateSearchAdvanced' => '\\StructType\\RevRecTemplateSearchAdvanced',
            'RevRecTemplateSearchRow' => '\\StructType\\RevRecTemplateSearchRow',
            'CostCategory' => '\\StructType\\CostCategory',
            'Nexus' => '\\StructType\\Nexus',
            'NexusSearch' => '\\StructType\\NexusSearch',
            'NexusSearchAdvanced' => '\\StructType\\NexusSearchAdvanced',
            'NexusSearchRow' => '\\StructType\\NexusSearchRow',
            'CustomerMessage' => '\\StructType\\CustomerMessage',
            'OtherNameCategory' => '\\StructType\\OtherNameCategory',
            'OtherNameCategorySearch' => '\\StructType\\OtherNameCategorySearch',
            'OtherNameCategorySearchAdvanced' => '\\StructType\\OtherNameCategorySearchAdvanced',
            'OtherNameCategorySearchRow' => '\\StructType\\OtherNameCategorySearchRow',
            'CustomerMessageSearch' => '\\StructType\\CustomerMessageSearch',
            'CustomerMessageSearchAdvanced' => '\\StructType\\CustomerMessageSearchAdvanced',
            'CustomerMessageSearchRow' => '\\StructType\\CustomerMessageSearchRow',
            'ItemGroup' => '\\StructType\\ItemGroup',
            'CurrencyRateSearch' => '\\StructType\\CurrencyRateSearch',
            'CurrencyRateSearchAdvanced' => '\\StructType\\CurrencyRateSearchAdvanced',
            'CurrencyRateSearchRow' => '\\StructType\\CurrencyRateSearchRow',
            'ItemRevision' => '\\StructType\\ItemRevision',
            'ItemRevisionSearch' => '\\StructType\\ItemRevisionSearch',
            'ItemRevisionSearchAdvanced' => '\\StructType\\ItemRevisionSearchAdvanced',
            'ItemRevisionSearchRow' => '\\StructType\\ItemRevisionSearchRow',
            'AccountingPeriodFiscalCalendars' => '\\StructType\\AccountingPeriodFiscalCalendars',
            'AccountingPeriodFiscalCalendarsList' => '\\StructType\\AccountingPeriodFiscalCalendarsList',
            'TaxAcct' => '\\StructType\\TaxAcct',
            'ExpenseCategoryRates' => '\\StructType\\ExpenseCategoryRates',
            'ExpenseCategoryRatesList' => '\\StructType\\ExpenseCategoryRatesList',
            'BillingSchedule' => '\\StructType\\BillingSchedule',
            'BillingScheduleMilestone' => '\\StructType\\BillingScheduleMilestone',
            'BillingScheduleMilestoneList' => '\\StructType\\BillingScheduleMilestoneList',
            'BillingScheduleRecurrence' => '\\StructType\\BillingScheduleRecurrence',
            'BillingScheduleRecurrenceList' => '\\StructType\\BillingScheduleRecurrenceList',
            'BillingScheduleSearch' => '\\StructType\\BillingScheduleSearch',
            'BillingScheduleSearchAdvanced' => '\\StructType\\BillingScheduleSearchAdvanced',
            'BillingScheduleSearchRow' => '\\StructType\\BillingScheduleSearchRow',
            'GlobalAccountMapping' => '\\StructType\\GlobalAccountMapping',
            'GlobalAccountMappingSearch' => '\\StructType\\GlobalAccountMappingSearch',
            'GlobalAccountMappingSearchAdvanced' => '\\StructType\\GlobalAccountMappingSearchAdvanced',
            'GlobalAccountMappingSearchRow' => '\\StructType\\GlobalAccountMappingSearchRow',
            'ItemAccountMapping' => '\\StructType\\ItemAccountMapping',
            'ItemAccountMappingSearch' => '\\StructType\\ItemAccountMappingSearch',
            'ItemAccountMappingSearchAdvanced' => '\\StructType\\ItemAccountMappingSearchAdvanced',
            'ItemAccountMappingSearchRow' => '\\StructType\\ItemAccountMappingSearchRow',
            'ItemAccountingBookDetail' => '\\StructType\\ItemAccountingBookDetail',
            'ItemAccountingBookDetailList' => '\\StructType\\ItemAccountingBookDetailList',
            'SubsidiaryAccountingBookDetail' => '\\StructType\\SubsidiaryAccountingBookDetail',
            'SubsidiaryAccountingBookDetailList' => '\\StructType\\SubsidiaryAccountingBookDetailList',
            'PaymentMethodVisuals' => '\\StructType\\PaymentMethodVisuals',
            'PaymentMethodVisualsList' => '\\StructType\\PaymentMethodVisualsList',
            'FairValuePrice' => '\\StructType\\FairValuePrice',
            'FairValuePriceSearch' => '\\StructType\\FairValuePriceSearch',
            'FairValuePriceSearchAdvanced' => '\\StructType\\FairValuePriceSearchAdvanced',
            'FairValuePriceSearchRow' => '\\StructType\\FairValuePriceSearchRow',
            'LocationRegions' => '\\StructType\\LocationRegions',
            'LocationRegionsList' => '\\StructType\\LocationRegionsList',
            'TaxTypeNexusAccounts' => '\\StructType\\TaxTypeNexusAccounts',
            'TaxTypeNexusAccountsList' => '\\StructType\\TaxTypeNexusAccountsList',
            'SubsidiaryTaxRegistration' => '\\StructType\\SubsidiaryTaxRegistration',
            'SubsidiaryTaxRegistrationList' => '\\StructType\\SubsidiaryTaxRegistrationList',
            'CostCategorySearch' => '\\StructType\\CostCategorySearch',
            'CostCategorySearchAdvanced' => '\\StructType\\CostCategorySearchAdvanced',
            'CostCategorySearchRow' => '\\StructType\\CostCategorySearchRow',
            'AccountLocalizations' => '\\StructType\\AccountLocalizations',
            'AccountLocalizationsList' => '\\StructType\\AccountLocalizationsList',
            'ConsolidatedExchangeRate' => '\\StructType\\ConsolidatedExchangeRate',
            'ConsolidatedExchangeRateSearch' => '\\StructType\\ConsolidatedExchangeRateSearch',
            'ConsolidatedExchangeRateSearchAdvanced' => '\\StructType\\ConsolidatedExchangeRateSearchAdvanced',
            'ConsolidatedExchangeRateSearchRow' => '\\StructType\\ConsolidatedExchangeRateSearchRow',
            'TaxGroupSearch' => '\\StructType\\TaxGroupSearch',
            'TaxGroupSearchAdvanced' => '\\StructType\\TaxGroupSearchAdvanced',
            'TaxGroupSearchRow' => '\\StructType\\TaxGroupSearchRow',
            'SalesTaxItemSearch' => '\\StructType\\SalesTaxItemSearch',
            'SalesTaxItemSearchAdvanced' => '\\StructType\\SalesTaxItemSearchAdvanced',
            'SalesTaxItemSearchRow' => '\\StructType\\SalesTaxItemSearchRow',
            'TaxTypeSearch' => '\\StructType\\TaxTypeSearch',
            'TaxTypeSearchAdvanced' => '\\StructType\\TaxTypeSearchAdvanced',
            'TaxTypeSearchRow' => '\\StructType\\TaxTypeSearchRow',
            'LocationBusinessHours' => '\\StructType\\LocationBusinessHours',
            'LocationBusinessHoursList' => '\\StructType\\LocationBusinessHoursList',
            'Bom' => '\\StructType\\Bom',
            'BomSearch' => '\\StructType\\BomSearch',
            'BomSearchAdvanced' => '\\StructType\\BomSearchAdvanced',
            'BomSearchRow' => '\\StructType\\BomSearchRow',
            'BomRevision' => '\\StructType\\BomRevision',
            'BomRevisionSearch' => '\\StructType\\BomRevisionSearch',
            'BomRevisionSearchAdvanced' => '\\StructType\\BomRevisionSearchAdvanced',
            'BomRevisionSearchRow' => '\\StructType\\BomRevisionSearchRow',
            'BomRevisionComponent' => '\\StructType\\BomRevisionComponent',
            'BomRevisionComponentList' => '\\StructType\\BomRevisionComponentList',
            'AssemblyItemBillOfMaterials' => '\\StructType\\AssemblyItemBillOfMaterials',
            'AssemblyItemBillOfMaterialsList' => '\\StructType\\AssemblyItemBillOfMaterialsList',
            'SerializedAssemblyItemBillOfMaterials' => '\\StructType\\SerializedAssemblyItemBillOfMaterials',
            'SerializedAssemblyItemBillOfMaterialsList' => '\\StructType\\SerializedAssemblyItemBillOfMaterialsList',
            'LotNumberedAssemblyItemBillOfMaterials' => '\\StructType\\LotNumberedAssemblyItemBillOfMaterials',
            'LotNumberedAssemblyItemBillOfMaterialsList' => '\\StructType\\LotNumberedAssemblyItemBillOfMaterialsList',
            'PaymentCard' => '\\StructType\\PaymentCard',
            'GeneralTokenSupportedOperationsListList' => '\\StructType\\GeneralTokenSupportedOperationsListList',
            'GeneralToken' => '\\StructType\\GeneralToken',
            'PaymentCardToken' => '\\StructType\\PaymentCardToken',
            'PaymentInstrumentSearch' => '\\StructType\\PaymentInstrumentSearch',
            'PaymentInstrumentSearchAdvanced' => '\\StructType\\PaymentInstrumentSearchAdvanced',
            'PaymentInstrumentSearchRow' => '\\StructType\\PaymentInstrumentSearchRow',
            'PaymentOptionSearch' => '\\StructType\\PaymentOptionSearch',
            'PaymentOptionSearchAdvanced' => '\\StructType\\PaymentOptionSearchAdvanced',
            'PaymentOptionSearchRow' => '\\StructType\\PaymentOptionSearchRow',
            'InventoryItemHierarchyVersions' => '\\StructType\\InventoryItemHierarchyVersions',
            'InventoryItemHierarchyVersionsList' => '\\StructType\\InventoryItemHierarchyVersionsList',
            'LotNumberedInventoryItemHierarchyVersions' => '\\StructType\\LotNumberedInventoryItemHierarchyVersions',
            'LotNumberedInventoryItemHierarchyVersionsList' => '\\StructType\\LotNumberedInventoryItemHierarchyVersionsList',
            'SerializedInventoryItemHierarchyVersions' => '\\StructType\\SerializedInventoryItemHierarchyVersions',
            'SerializedInventoryItemHierarchyVersionsList' => '\\StructType\\SerializedInventoryItemHierarchyVersionsList',
            'MerchandiseHierarchyNode' => '\\StructType\\MerchandiseHierarchyNode',
            'MerchandiseHierarchyNodeHierarchyVersions' => '\\StructType\\MerchandiseHierarchyNodeHierarchyVersions',
            'MerchandiseHierarchyNodeHierarchyVersionsList' => '\\StructType\\MerchandiseHierarchyNodeHierarchyVersionsList',
            'MerchandiseHierarchyNodeSearch' => '\\StructType\\MerchandiseHierarchyNodeSearch',
            'MerchandiseHierarchyNodeSearchAdvanced' => '\\StructType\\MerchandiseHierarchyNodeSearchAdvanced',
            'MerchandiseHierarchyNodeSearchRow' => '\\StructType\\MerchandiseHierarchyNodeSearchRow',
            'TermPercentages' => '\\StructType\\TermPercentages',
            'TermPercentagesList' => '\\StructType\\TermPercentagesList',
            'AssemblyItemHierarchyVersions' => '\\StructType\\AssemblyItemHierarchyVersions',
            'AssemblyItemHierarchyVersionsList' => '\\StructType\\AssemblyItemHierarchyVersionsList',
            'SerializedAssemblyItemHierarchyVersions' => '\\StructType\\SerializedAssemblyItemHierarchyVersions',
            'SerializedAssemblyItemHierarchyVersionsList' => '\\StructType\\SerializedAssemblyItemHierarchyVersionsList',
            'LotNumberedAssemblyItemHierarchyVersions' => '\\StructType\\LotNumberedAssemblyItemHierarchyVersions',
            'LotNumberedAssemblyItemHierarchyVersionsList' => '\\StructType\\LotNumberedAssemblyItemHierarchyVersionsList',
            'NonInventoryPurchaseItemHierarchyVersions' => '\\StructType\\NonInventoryPurchaseItemHierarchyVersions',
            'NonInventoryPurchaseItemHierarchyVersionsList' => '\\StructType\\NonInventoryPurchaseItemHierarchyVersionsList',
            'NonInventorySaleItemHierarchyVersions' => '\\StructType\\NonInventorySaleItemHierarchyVersions',
            'NonInventorySaleItemHierarchyVersionsList' => '\\StructType\\NonInventorySaleItemHierarchyVersionsList',
            'NonInventoryResaleItemHierarchyVersions' => '\\StructType\\NonInventoryResaleItemHierarchyVersions',
            'NonInventoryResaleItemHierarchyVersionsList' => '\\StructType\\NonInventoryResaleItemHierarchyVersionsList',
            'OtherChargeResaleItemHierarchyVersions' => '\\StructType\\OtherChargeResaleItemHierarchyVersions',
            'OtherChargeResaleItemHierarchyVersionsList' => '\\StructType\\OtherChargeResaleItemHierarchyVersionsList',
            'OtherChargePurchaseItemHierarchyVersions' => '\\StructType\\OtherChargePurchaseItemHierarchyVersions',
            'OtherChargePurchaseItemHierarchyVersionsList' => '\\StructType\\OtherChargePurchaseItemHierarchyVersionsList',
            'ServiceResaleItemHierarchyVersions' => '\\StructType\\ServiceResaleItemHierarchyVersions',
            'ServiceResaleItemHierarchyVersionsList' => '\\StructType\\ServiceResaleItemHierarchyVersionsList',
            'ServicePurchaseItemHierarchyVersions' => '\\StructType\\ServicePurchaseItemHierarchyVersions',
            'ServicePurchaseItemHierarchyVersionsList' => '\\StructType\\ServicePurchaseItemHierarchyVersionsList',
            'ServiceSaleItemHierarchyVersions' => '\\StructType\\ServiceSaleItemHierarchyVersions',
            'ServiceSaleItemHierarchyVersionsList' => '\\StructType\\ServiceSaleItemHierarchyVersionsList',
            'OtherChargeSaleItemHierarchyVersions' => '\\StructType\\OtherChargeSaleItemHierarchyVersions',
            'OtherChargeSaleItemHierarchyVersionsList' => '\\StructType\\OtherChargeSaleItemHierarchyVersionsList',
            'KitItemHierarchyVersions' => '\\StructType\\KitItemHierarchyVersions',
            'KitItemHierarchyVersionsList' => '\\StructType\\KitItemHierarchyVersionsList',
            'ItemGroupHierarchyVersions' => '\\StructType\\ItemGroupHierarchyVersions',
            'ItemGroupHierarchyVersionsList' => '\\StructType\\ItemGroupHierarchyVersionsList',
            'Opportunity' => '\\StructType\\Opportunity',
            'OpportunitySalesTeam' => '\\StructType\\OpportunitySalesTeam',
            'OpportunitySalesTeamList' => '\\StructType\\OpportunitySalesTeamList',
            'OpportunityItem' => '\\StructType\\OpportunityItem',
            'OpportunityItemList' => '\\StructType\\OpportunityItemList',
            'OpportunityCompetitors' => '\\StructType\\OpportunityCompetitors',
            'OpportunityCompetitorsList' => '\\StructType\\OpportunityCompetitorsList',
            'OpportunitySearch' => '\\StructType\\OpportunitySearch',
            'OpportunitySearchAdvanced' => '\\StructType\\OpportunitySearchAdvanced',
            'OpportunitySearchRow' => '\\StructType\\OpportunitySearchRow',
            'OpportunityPartnersList' => '\\StructType\\OpportunityPartnersList',
            'SalesOrder' => '\\StructType\\SalesOrder',
            'SalesOrderSalesTeam' => '\\StructType\\SalesOrderSalesTeam',
            'SalesOrderSalesTeamList' => '\\StructType\\SalesOrderSalesTeamList',
            'SalesOrderItem' => '\\StructType\\SalesOrderItem',
            'SalesOrderItemList' => '\\StructType\\SalesOrderItemList',
            'SalesOrderPartnersList' => '\\StructType\\SalesOrderPartnersList',
            'SalesOrderShipGroupList' => '\\StructType\\SalesOrderShipGroupList',
            'TransactionSearch' => '\\StructType\\TransactionSearch',
            'TransactionSearchAdvanced' => '\\StructType\\TransactionSearchAdvanced',
            'TransactionSearchRow' => '\\StructType\\TransactionSearchRow',
            'ItemFulfillment' => '\\StructType\\ItemFulfillment',
            'ItemFulfillmentItem' => '\\StructType\\ItemFulfillmentItem',
            'ItemFulfillmentItemList' => '\\StructType\\ItemFulfillmentItemList',
            'ItemFulfillmentPackage' => '\\StructType\\ItemFulfillmentPackage',
            'ItemFulfillmentPackageList' => '\\StructType\\ItemFulfillmentPackageList',
            'ItemFulfillmentPackageUps' => '\\StructType\\ItemFulfillmentPackageUps',
            'ItemFulfillmentPackageUpsList' => '\\StructType\\ItemFulfillmentPackageUpsList',
            'ItemFulfillmentPackageUsps' => '\\StructType\\ItemFulfillmentPackageUsps',
            'ItemFulfillmentPackageUspsList' => '\\StructType\\ItemFulfillmentPackageUspsList',
            'ItemFulfillmentPackageFedEx' => '\\StructType\\ItemFulfillmentPackageFedEx',
            'ItemFulfillmentPackageFedExList' => '\\StructType\\ItemFulfillmentPackageFedExList',
            'Invoice' => '\\StructType\\Invoice',
            'InvoiceSalesTeam' => '\\StructType\\InvoiceSalesTeam',
            'InvoiceSalesTeamList' => '\\StructType\\InvoiceSalesTeamList',
            'InvoiceItem' => '\\StructType\\InvoiceItem',
            'InvoiceItemList' => '\\StructType\\InvoiceItemList',
            'InvoiceItemCost' => '\\StructType\\InvoiceItemCost',
            'InvoiceItemCostList' => '\\StructType\\InvoiceItemCostList',
            'InvoiceExpCost' => '\\StructType\\InvoiceExpCost',
            'InvoiceExpCostList' => '\\StructType\\InvoiceExpCostList',
            'InvoiceTime' => '\\StructType\\InvoiceTime',
            'InvoiceTimeList' => '\\StructType\\InvoiceTimeList',
            'InvoicePartnersList' => '\\StructType\\InvoicePartnersList',
            'InvoiceShipGroupList' => '\\StructType\\InvoiceShipGroupList',
            'CashSale' => '\\StructType\\CashSale',
            'CashSaleSalesTeam' => '\\StructType\\CashSaleSalesTeam',
            'CashSaleSalesTeamList' => '\\StructType\\CashSaleSalesTeamList',
            'CashSaleItem' => '\\StructType\\CashSaleItem',
            'CashSaleItemList' => '\\StructType\\CashSaleItemList',
            'CashSaleItemCost' => '\\StructType\\CashSaleItemCost',
            'CashSaleItemCostList' => '\\StructType\\CashSaleItemCostList',
            'CashSaleExpCost' => '\\StructType\\CashSaleExpCost',
            'CashSaleExpCostList' => '\\StructType\\CashSaleExpCostList',
            'CashSaleTime' => '\\StructType\\CashSaleTime',
            'CashSaleTimeList' => '\\StructType\\CashSaleTimeList',
            'CashSalePartnersList' => '\\StructType\\CashSalePartnersList',
            'CashSaleShipGroupList' => '\\StructType\\CashSaleShipGroupList',
            'Estimate' => '\\StructType\\Estimate',
            'EstimateItem' => '\\StructType\\EstimateItem',
            'EstimateItemList' => '\\StructType\\EstimateItemList',
            'EstimateSalesTeam' => '\\StructType\\EstimateSalesTeam',
            'EstimateSalesTeamList' => '\\StructType\\EstimateSalesTeamList',
            'EstimatePartnersList' => '\\StructType\\EstimatePartnersList',
            'EstimateShipGroupList' => '\\StructType\\EstimateShipGroupList',
            'TransactionShipGroup' => '\\StructType\\TransactionShipGroup',
            'AccountingTransactionSearch' => '\\StructType\\AccountingTransactionSearch',
            'AccountingTransactionSearchAdvanced' => '\\StructType\\AccountingTransactionSearchAdvanced',
            'AccountingTransactionSearchRow' => '\\StructType\\AccountingTransactionSearchRow',
            'Usage' => '\\StructType\\Usage',
            'UsageSearch' => '\\StructType\\UsageSearch',
            'UsageSearchAdvanced' => '\\StructType\\UsageSearchAdvanced',
            'UsageSearchRow' => '\\StructType\\UsageSearchRow',
            'VendorBill' => '\\StructType\\VendorBill',
            'VendorBillExpense' => '\\StructType\\VendorBillExpense',
            'VendorBillExpenseList' => '\\StructType\\VendorBillExpenseList',
            'VendorBillItem' => '\\StructType\\VendorBillItem',
            'VendorBillItemList' => '\\StructType\\VendorBillItemList',
            'PurchaseOrder' => '\\StructType\\PurchaseOrder',
            'PurchaseOrderExpense' => '\\StructType\\PurchaseOrderExpense',
            'PurchaseOrderExpenseList' => '\\StructType\\PurchaseOrderExpenseList',
            'PurchaseOrderItem' => '\\StructType\\PurchaseOrderItem',
            'PurchaseOrderItemList' => '\\StructType\\PurchaseOrderItemList',
            'ItemReceipt' => '\\StructType\\ItemReceipt',
            'ItemReceiptItem' => '\\StructType\\ItemReceiptItem',
            'ItemReceiptItemList' => '\\StructType\\ItemReceiptItemList',
            'ItemReceiptExpense' => '\\StructType\\ItemReceiptExpense',
            'ItemReceiptExpenseList' => '\\StructType\\ItemReceiptExpenseList',
            'VendorPayment' => '\\StructType\\VendorPayment',
            'VendorPaymentApply' => '\\StructType\\VendorPaymentApply',
            'VendorPaymentApplyList' => '\\StructType\\VendorPaymentApplyList',
            'VendorPaymentCredit' => '\\StructType\\VendorPaymentCredit',
            'VendorPaymentCreditList' => '\\StructType\\VendorPaymentCreditList',
            'VendorCredit' => '\\StructType\\VendorCredit',
            'VendorCreditExpense' => '\\StructType\\VendorCreditExpense',
            'VendorCreditExpenseList' => '\\StructType\\VendorCreditExpenseList',
            'VendorCreditItem' => '\\StructType\\VendorCreditItem',
            'VendorCreditItemList' => '\\StructType\\VendorCreditItemList',
            'VendorCreditApply' => '\\StructType\\VendorCreditApply',
            'VendorCreditApplyList' => '\\StructType\\VendorCreditApplyList',
            'VendorReturnAuthorization' => '\\StructType\\VendorReturnAuthorization',
            'VendorReturnAuthorizationExpense' => '\\StructType\\VendorReturnAuthorizationExpense',
            'VendorReturnAuthorizationExpenseList' => '\\StructType\\VendorReturnAuthorizationExpenseList',
            'VendorReturnAuthorizationItem' => '\\StructType\\VendorReturnAuthorizationItem',
            'VendorReturnAuthorizationItemList' => '\\StructType\\VendorReturnAuthorizationItemList',
            'PurchaseRequisition' => '\\StructType\\PurchaseRequisition',
            'PurchaseRequisitionExpense' => '\\StructType\\PurchaseRequisitionExpense',
            'PurchaseRequisitionExpenseList' => '\\StructType\\PurchaseRequisitionExpenseList',
            'PurchaseRequisitionItem' => '\\StructType\\PurchaseRequisitionItem',
            'PurchaseRequisitionItemList' => '\\StructType\\PurchaseRequisitionItemList',
            'InboundShipment' => '\\StructType\\InboundShipment',
            'InboundShipmentItems' => '\\StructType\\InboundShipmentItems',
            'InboundShipmentItemsList' => '\\StructType\\InboundShipmentItemsList',
            'InboundShipmentSearch' => '\\StructType\\InboundShipmentSearch',
            'InboundShipmentSearchAdvanced' => '\\StructType\\InboundShipmentSearchAdvanced',
            'InboundShipmentSearchRow' => '\\StructType\\InboundShipmentSearchRow',
            'InboundShipmentLandedCost' => '\\StructType\\InboundShipmentLandedCost',
            'InboundShipmentLandedCostList' => '\\StructType\\InboundShipmentLandedCostList',
            'CashRefund' => '\\StructType\\CashRefund',
            'CashRefundItem' => '\\StructType\\CashRefundItem',
            'CashRefundItemList' => '\\StructType\\CashRefundItemList',
            'CashRefundSalesTeam' => '\\StructType\\CashRefundSalesTeam',
            'CashRefundSalesTeamList' => '\\StructType\\CashRefundSalesTeamList',
            'CashRefundPartnersList' => '\\StructType\\CashRefundPartnersList',
            'CustomerPayment' => '\\StructType\\CustomerPayment',
            'CustomerPaymentApply' => '\\StructType\\CustomerPaymentApply',
            'CustomerPaymentApplyList' => '\\StructType\\CustomerPaymentApplyList',
            'CustomerPaymentCredit' => '\\StructType\\CustomerPaymentCredit',
            'CustomerPaymentCreditList' => '\\StructType\\CustomerPaymentCreditList',
            'CustomerPaymentDeposit' => '\\StructType\\CustomerPaymentDeposit',
            'CustomerPaymentDepositList' => '\\StructType\\CustomerPaymentDepositList',
            'ReturnAuthorization' => '\\StructType\\ReturnAuthorization',
            'ReturnAuthorizationItem' => '\\StructType\\ReturnAuthorizationItem',
            'ReturnAuthorizationItemList' => '\\StructType\\ReturnAuthorizationItemList',
            'ReturnAuthorizationSalesTeam' => '\\StructType\\ReturnAuthorizationSalesTeam',
            'ReturnAuthorizationSalesTeamList' => '\\StructType\\ReturnAuthorizationSalesTeamList',
            'ReturnAuthorizationPartnersList' => '\\StructType\\ReturnAuthorizationPartnersList',
            'CreditMemo' => '\\StructType\\CreditMemo',
            'CreditMemoSalesTeam' => '\\StructType\\CreditMemoSalesTeam',
            'CreditMemoSalesTeamList' => '\\StructType\\CreditMemoSalesTeamList',
            'CreditMemoItem' => '\\StructType\\CreditMemoItem',
            'CreditMemoItemList' => '\\StructType\\CreditMemoItemList',
            'CreditMemoApply' => '\\StructType\\CreditMemoApply',
            'CreditMemoApplyList' => '\\StructType\\CreditMemoApplyList',
            'CreditMemoPartnersList' => '\\StructType\\CreditMemoPartnersList',
            'CustomerRefund' => '\\StructType\\CustomerRefund',
            'CustomerRefundApply' => '\\StructType\\CustomerRefundApply',
            'CustomerRefundApplyList' => '\\StructType\\CustomerRefundApplyList',
            'CustomerRefundDeposit' => '\\StructType\\CustomerRefundDeposit',
            'CustomerRefundDepositList' => '\\StructType\\CustomerRefundDepositList',
            'CustomerDeposit' => '\\StructType\\CustomerDeposit',
            'CustomerDepositApply' => '\\StructType\\CustomerDepositApply',
            'CustomerDepositApplyList' => '\\StructType\\CustomerDepositApplyList',
            'DepositApplication' => '\\StructType\\DepositApplication',
            'DepositApplicationApply' => '\\StructType\\DepositApplicationApply',
            'DepositApplicationApplyList' => '\\StructType\\DepositApplicationApplyList',
            'Charge' => '\\StructType\\Charge',
            'ChargeSearch' => '\\StructType\\ChargeSearch',
            'ChargeSearchAdvanced' => '\\StructType\\ChargeSearchAdvanced',
            'ChargeSearchRow' => '\\StructType\\ChargeSearchRow',
            'Budget' => '\\StructType\\Budget',
            'BudgetSearch' => '\\StructType\\BudgetSearch',
            'BudgetSearchAdvanced' => '\\StructType\\BudgetSearchAdvanced',
            'BudgetSearchRow' => '\\StructType\\BudgetSearchRow',
            'CheckLandedCostList' => '\\StructType\\CheckLandedCostList',
            'Check' => '\\StructType\\Check',
            'CheckExpense' => '\\StructType\\CheckExpense',
            'CheckExpenseList' => '\\StructType\\CheckExpenseList',
            'CheckItem' => '\\StructType\\CheckItem',
            'CheckItemList' => '\\StructType\\CheckItemList',
            'Deposit' => '\\StructType\\Deposit',
            'DepositPayment' => '\\StructType\\DepositPayment',
            'DepositPaymentList' => '\\StructType\\DepositPaymentList',
            'DepositCashBack' => '\\StructType\\DepositCashBack',
            'DepositCashBackList' => '\\StructType\\DepositCashBackList',
            'DepositOther' => '\\StructType\\DepositOther',
            'DepositOtherList' => '\\StructType\\DepositOtherList',
            'InventoryAdjustment' => '\\StructType\\InventoryAdjustment',
            'InventoryAdjustmentInventory' => '\\StructType\\InventoryAdjustmentInventory',
            'InventoryAdjustmentInventoryList' => '\\StructType\\InventoryAdjustmentInventoryList',
            'AssemblyBuild' => '\\StructType\\AssemblyBuild',
            'AssemblyUnbuild' => '\\StructType\\AssemblyUnbuild',
            'AssemblyComponent' => '\\StructType\\AssemblyComponent',
            'AssemblyComponentList' => '\\StructType\\AssemblyComponentList',
            'TransferOrder' => '\\StructType\\TransferOrder',
            'TransferOrderItem' => '\\StructType\\TransferOrderItem',
            'TransferOrderItemList' => '\\StructType\\TransferOrderItemList',
            'InterCompanyTransferOrder' => '\\StructType\\InterCompanyTransferOrder',
            'InterCompanyTransferOrderItem' => '\\StructType\\InterCompanyTransferOrderItem',
            'InterCompanyTransferOrderItemList' => '\\StructType\\InterCompanyTransferOrderItemList',
            'WorkOrder' => '\\StructType\\WorkOrder',
            'WorkOrderItem' => '\\StructType\\WorkOrderItem',
            'WorkOrderItemList' => '\\StructType\\WorkOrderItemList',
            'SalesTeamList' => '\\StructType\\SalesTeamList',
            'PartnersList' => '\\StructType\\PartnersList',
            'InventoryTransfer' => '\\StructType\\InventoryTransfer',
            'InventoryTransferInventory' => '\\StructType\\InventoryTransferInventory',
            'InventoryTransferInventoryList' => '\\StructType\\InventoryTransferInventoryList',
            'BinTransfer' => '\\StructType\\BinTransfer',
            'BinTransferInventory' => '\\StructType\\BinTransferInventory',
            'BinTransferInventoryList' => '\\StructType\\BinTransferInventoryList',
            'BinWorksheet' => '\\StructType\\BinWorksheet',
            'BinWorksheetItem' => '\\StructType\\BinWorksheetItem',
            'BinWorksheetItemList' => '\\StructType\\BinWorksheetItemList',
            'WorkOrderIssue' => '\\StructType\\WorkOrderIssue',
            'WorkOrderIssueComponent' => '\\StructType\\WorkOrderIssueComponent',
            'WorkOrderIssueComponentList' => '\\StructType\\WorkOrderIssueComponentList',
            'WorkOrderCompletion' => '\\StructType\\WorkOrderCompletion',
            'WorkOrderCompletionComponent' => '\\StructType\\WorkOrderCompletionComponent',
            'WorkOrderCompletionComponentList' => '\\StructType\\WorkOrderCompletionComponentList',
            'WorkOrderClose' => '\\StructType\\WorkOrderClose',
            'WorkOrderCompletionOperation' => '\\StructType\\WorkOrderCompletionOperation',
            'WorkOrderCompletionOperationList' => '\\StructType\\WorkOrderCompletionOperationList',
            'InventoryCostRevaluation' => '\\StructType\\InventoryCostRevaluation',
            'InventoryCostRevaluationCostComponent' => '\\StructType\\InventoryCostRevaluationCostComponent',
            'InventoryCostRevaluationCostComponentList' => '\\StructType\\InventoryCostRevaluationCostComponentList',
            'JournalEntry' => '\\StructType\\JournalEntry',
            'JournalEntryLine' => '\\StructType\\JournalEntryLine',
            'JournalEntryLineList' => '\\StructType\\JournalEntryLineList',
            'InterCompanyJournalEntry' => '\\StructType\\InterCompanyJournalEntry',
            'InterCompanyJournalEntryLine' => '\\StructType\\InterCompanyJournalEntryLine',
            'InterCompanyJournalEntryLineList' => '\\StructType\\InterCompanyJournalEntryLineList',
            'StatisticalJournalEntry' => '\\StructType\\StatisticalJournalEntry',
            'StatisticalJournalEntryLine' => '\\StructType\\StatisticalJournalEntryLine',
            'StatisticalJournalEntryLineList' => '\\StructType\\StatisticalJournalEntryLineList',
            'InterCompanyJournalEntryAccountingBookDetail' => '\\StructType\\InterCompanyJournalEntryAccountingBookDetail',
            'InterCompanyJournalEntryAccountingBookDetailList' => '\\StructType\\InterCompanyJournalEntryAccountingBookDetailList',
            'AdvInterCompanyJournalEntry' => '\\StructType\\AdvInterCompanyJournalEntry',
            'AdvInterCompanyJournalEntryLine' => '\\StructType\\AdvInterCompanyJournalEntryLine',
            'AdvInterCompanyJournalEntryLineList' => '\\StructType\\AdvInterCompanyJournalEntryLineList',
            'AdvInterCompanyJournalEntryAccountingBookDetail' => '\\StructType\\AdvInterCompanyJournalEntryAccountingBookDetail',
            'AdvInterCompanyJournalEntryAccountingBookDetailList' => '\\StructType\\AdvInterCompanyJournalEntryAccountingBookDetailList',
            'PeriodEndJournal' => '\\StructType\\PeriodEndJournal',
            'PeriodEndJournalLine' => '\\StructType\\PeriodEndJournalLine',
            'PeriodEndJournalLineList' => '\\StructType\\PeriodEndJournalLineList',
            'CustomRecord' => '\\StructType\\CustomRecord',
            'CustomRecordSearch' => '\\StructType\\CustomRecordSearch',
            'CustomRecordSearchAdvanced' => '\\StructType\\CustomRecordSearchAdvanced',
            'CustomRecordSearchRow' => '\\StructType\\CustomRecordSearchRow',
            'CustomList' => '\\StructType\\CustomList',
            'CustomListCustomValue' => '\\StructType\\CustomListCustomValue',
            'CustomListCustomValueList' => '\\StructType\\CustomListCustomValueList',
            'CustomListTranslations' => '\\StructType\\CustomListTranslations',
            'CustomListTranslationsList' => '\\StructType\\CustomListTranslationsList',
            'CustomRecordType' => '\\StructType\\CustomRecordType',
            'CustomRecordTypeFieldList' => '\\StructType\\CustomRecordTypeFieldList',
            'CustomRecordTypeTabs' => '\\StructType\\CustomRecordTypeTabs',
            'CustomRecordTypeTabsList' => '\\StructType\\CustomRecordTypeTabsList',
            'CustomRecordTypeForms' => '\\StructType\\CustomRecordTypeForms',
            'CustomRecordTypeFormsList' => '\\StructType\\CustomRecordTypeFormsList',
            'CustomRecordTypeOnlineForms' => '\\StructType\\CustomRecordTypeOnlineForms',
            'CustomRecordTypeOnlineFormsList' => '\\StructType\\CustomRecordTypeOnlineFormsList',
            'CustomRecordTypePermissions' => '\\StructType\\CustomRecordTypePermissions',
            'CustomRecordTypePermissionsList' => '\\StructType\\CustomRecordTypePermissionsList',
            'CustomRecordTypeLinks' => '\\StructType\\CustomRecordTypeLinks',
            'CustomRecordTypeLinksList' => '\\StructType\\CustomRecordTypeLinksList',
            'CustomRecordTypeManagers' => '\\StructType\\CustomRecordTypeManagers',
            'CustomRecordTypeManagersList' => '\\StructType\\CustomRecordTypeManagersList',
            'CustomRecordTypeChildren' => '\\StructType\\CustomRecordTypeChildren',
            'CustomRecordTypeChildrenList' => '\\StructType\\CustomRecordTypeChildrenList',
            'CustomRecordTypeParents' => '\\StructType\\CustomRecordTypeParents',
            'CustomRecordTypeParentsList' => '\\StructType\\CustomRecordTypeParentsList',
            'CustomRecordTypeTranslations' => '\\StructType\\CustomRecordTypeTranslations',
            'CustomRecordTypeTranslationsList' => '\\StructType\\CustomRecordTypeTranslationsList',
            'CustomRecordTypeSublists' => '\\StructType\\CustomRecordTypeSublists',
            'CustomRecordTypeSublistsList' => '\\StructType\\CustomRecordTypeSublistsList',
            'CustomFieldType' => '\\StructType\\CustomFieldType',
            'EntityCustomField' => '\\StructType\\EntityCustomField',
            'EntityCustomFieldFilter' => '\\StructType\\EntityCustomFieldFilter',
            'EntityCustomFieldFilterList' => '\\StructType\\EntityCustomFieldFilterList',
            'FldFilterSelList' => '\\StructType\\FldFilterSelList',
            'CrmCustomField' => '\\StructType\\CrmCustomField',
            'CrmCustomFieldFilter' => '\\StructType\\CrmCustomFieldFilter',
            'CrmCustomFieldFilterList' => '\\StructType\\CrmCustomFieldFilterList',
            'OtherCustomField' => '\\StructType\\OtherCustomField',
            'OtherCustomFieldFilter' => '\\StructType\\OtherCustomFieldFilter',
            'OtherCustomFieldFilterList' => '\\StructType\\OtherCustomFieldFilterList',
            'ItemCustomField' => '\\StructType\\ItemCustomField',
            'ItemCustomFieldFilter' => '\\StructType\\ItemCustomFieldFilter',
            'ItemCustomFieldFilterList' => '\\StructType\\ItemCustomFieldFilterList',
            'TransactionBodyCustomField' => '\\StructType\\TransactionBodyCustomField',
            'TransactionBodyCustomFieldFilter' => '\\StructType\\TransactionBodyCustomFieldFilter',
            'TransactionBodyCustomFieldFilterList' => '\\StructType\\TransactionBodyCustomFieldFilterList',
            'TransactionColumnCustomField' => '\\StructType\\TransactionColumnCustomField',
            'TransactionColumnCustomFieldFilter' => '\\StructType\\TransactionColumnCustomFieldFilter',
            'TransactionColumnCustomFieldFilterList' => '\\StructType\\TransactionColumnCustomFieldFilterList',
            'ItemOptionCustomField' => '\\StructType\\ItemOptionCustomField',
            'ItemsList' => '\\StructType\\ItemsList',
            'ItemOptionCustomFieldFilter' => '\\StructType\\ItemOptionCustomFieldFilter',
            'ItemOptionCustomFieldFilterList' => '\\StructType\\ItemOptionCustomFieldFilterList',
            'CustomRecordCustomField' => '\\StructType\\CustomRecordCustomField',
            'CustomRecordCustomFieldFilter' => '\\StructType\\CustomRecordCustomFieldFilter',
            'CustomRecordCustomFieldFilterList' => '\\StructType\\CustomRecordCustomFieldFilterList',
            'CustomFieldRoleAccess' => '\\StructType\\CustomFieldRoleAccess',
            'CustomFieldRoleAccessList' => '\\StructType\\CustomFieldRoleAccessList',
            'CustomFieldDepartmentAccess' => '\\StructType\\CustomFieldDepartmentAccess',
            'CustomFieldDepartmentAccessList' => '\\StructType\\CustomFieldDepartmentAccessList',
            'CustomFieldSubAccess' => '\\StructType\\CustomFieldSubAccess',
            'CustomFieldSubAccessList' => '\\StructType\\CustomFieldSubAccessList',
            'LanguageValue' => '\\StructType\\LanguageValue',
            'LanguageValueList' => '\\StructType\\LanguageValueList',
            'CustomFieldTranslations' => '\\StructType\\CustomFieldTranslations',
            'CustomFieldTranslationsList' => '\\StructType\\CustomFieldTranslationsList',
            'ItemNumberCustomField' => '\\StructType\\ItemNumberCustomField',
            'ItemNumberCustomFieldFilter' => '\\StructType\\ItemNumberCustomFieldFilter',
            'ItemNumberCustomFieldFilterList' => '\\StructType\\ItemNumberCustomFieldFilterList',
            'CustomListSearch' => '\\StructType\\CustomListSearch',
            'CustomListSearchAdvanced' => '\\StructType\\CustomListSearchAdvanced',
            'CustomListSearchRow' => '\\StructType\\CustomListSearchRow',
            'CustomRecordTranslations' => '\\StructType\\CustomRecordTranslations',
            'CustomRecordTranslationsList' => '\\StructType\\CustomRecordTranslationsList',
            'CustomTransaction' => '\\StructType\\CustomTransaction',
            'CustomTransactionLine' => '\\StructType\\CustomTransactionLine',
            'CustomTransactionLineList' => '\\StructType\\CustomTransactionLineList',
            'CustomSegment' => '\\StructType\\CustomSegment',
            'CustomSale' => '\\StructType\\CustomSale',
            'CustomSaleItem' => '\\StructType\\CustomSaleItem',
            'CustomSaleItemList' => '\\StructType\\CustomSaleItemList',
            'CustomSaleShipGroup' => '\\StructType\\CustomSaleShipGroup',
            'CustomSaleShipGroupList' => '\\StructType\\CustomSaleShipGroupList',
            'CustomSalePartnersList' => '\\StructType\\CustomSalePartnersList',
            'CustomSaleSalesTeam' => '\\StructType\\CustomSaleSalesTeam',
            'CustomSaleSalesTeamList' => '\\StructType\\CustomSaleSalesTeamList',
            'CustomPurchase' => '\\StructType\\CustomPurchase',
            'CustomPurchaseExpense' => '\\StructType\\CustomPurchaseExpense',
            'CustomPurchaseExpenseList' => '\\StructType\\CustomPurchaseExpenseList',
            'CustomPurchaseItem' => '\\StructType\\CustomPurchaseItem',
            'CustomPurchaseItemList' => '\\StructType\\CustomPurchaseItemList',
            'Employee' => '\\StructType\\Employee',
            'EmployeeSubscriptions' => '\\StructType\\EmployeeSubscriptions',
            'EmployeeSubscriptionsList' => '\\StructType\\EmployeeSubscriptionsList',
            'EmployeeAddressbook' => '\\StructType\\EmployeeAddressbook',
            'EmployeeAddressbookList' => '\\StructType\\EmployeeAddressbookList',
            'EmployeeRoles' => '\\StructType\\EmployeeRoles',
            'EmployeeRolesList' => '\\StructType\\EmployeeRolesList',
            'EmployeeSearch' => '\\StructType\\EmployeeSearch',
            'EmployeeSearchAdvanced' => '\\StructType\\EmployeeSearchAdvanced',
            'EmployeeSearchRow' => '\\StructType\\EmployeeSearchRow',
            'EmployeeEmergencyContact' => '\\StructType\\EmployeeEmergencyContact',
            'EmployeeEmergencyContactList' => '\\StructType\\EmployeeEmergencyContactList',
            'EmployeeHrEducation' => '\\StructType\\EmployeeHrEducation',
            'EmployeeHrEducationList' => '\\StructType\\EmployeeHrEducationList',
            'EmployeeAccruedTime' => '\\StructType\\EmployeeAccruedTime',
            'EmployeeAccruedTimeList' => '\\StructType\\EmployeeAccruedTimeList',
            'EmployeeDeduction' => '\\StructType\\EmployeeDeduction',
            'EmployeeDeductionList' => '\\StructType\\EmployeeDeductionList',
            'EmployeeCompanyContribution' => '\\StructType\\EmployeeCompanyContribution',
            'EmployeeCompanyContributionList' => '\\StructType\\EmployeeCompanyContributionList',
            'EmployeeEarning' => '\\StructType\\EmployeeEarning',
            'EmployeeEarningList' => '\\StructType\\EmployeeEarningList',
            'EmployeeDirectDeposit' => '\\StructType\\EmployeeDirectDeposit',
            'EmployeeDirectDepositList' => '\\StructType\\EmployeeDirectDepositList',
            'PayrollItem' => '\\StructType\\PayrollItem',
            'PayrollItemSearch' => '\\StructType\\PayrollItemSearch',
            'PayrollItemSearchAdvanced' => '\\StructType\\PayrollItemSearchAdvanced',
            'PayrollItemSearchRow' => '\\StructType\\PayrollItemSearchRow',
            'EmployeeRates' => '\\StructType\\EmployeeRates',
            'EmployeeRatesList' => '\\StructType\\EmployeeRatesList',
            'HcmJob' => '\\StructType\\HcmJob',
            'HcmJobSearch' => '\\StructType\\HcmJobSearch',
            'HcmJobSearchAdvanced' => '\\StructType\\HcmJobSearchAdvanced',
            'HcmJobSearchRow' => '\\StructType\\HcmJobSearchRow',
            'EmployeeHcmPosition' => '\\StructType\\EmployeeHcmPosition',
            'EmployeeHcmPositionList' => '\\StructType\\EmployeeHcmPositionList',
            'EmployeeCurrency' => '\\StructType\\EmployeeCurrency',
            'EmployeeCurrencyList' => '\\StructType\\EmployeeCurrencyList',
            'SiteCategoryTranslation' => '\\StructType\\SiteCategoryTranslation',
            'SiteCategoryTranslationList' => '\\StructType\\SiteCategoryTranslationList',
            'SiteCategoryPresentationItemList' => '\\StructType\\SiteCategoryPresentationItemList',
            'SiteCategorySearch' => '\\StructType\\SiteCategorySearch',
            'SiteCategorySearchAdvanced' => '\\StructType\\SiteCategorySearchAdvanced',
            'SiteCategorySearchRow' => '\\StructType\\SiteCategorySearchRow',
            'TimeBill' => '\\StructType\\TimeBill',
            'TimeBillSearch' => '\\StructType\\TimeBillSearch',
            'TimeBillSearchAdvanced' => '\\StructType\\TimeBillSearchAdvanced',
            'TimeBillSearchRow' => '\\StructType\\TimeBillSearchRow',
            'ExpenseReport' => '\\StructType\\ExpenseReport',
            'ExpenseReportExpense' => '\\StructType\\ExpenseReportExpense',
            'ExpenseReportExpenseList' => '\\StructType\\ExpenseReportExpenseList',
            'PaycheckJournal' => '\\StructType\\PaycheckJournal',
            'PaycheckJournalCompanyTax' => '\\StructType\\PaycheckJournalCompanyTax',
            'PaycheckJournalCompanyTaxList' => '\\StructType\\PaycheckJournalCompanyTaxList',
            'PaycheckJournalDeduction' => '\\StructType\\PaycheckJournalDeduction',
            'PaycheckJournalDeductionList' => '\\StructType\\PaycheckJournalDeductionList',
            'PaycheckJournalCompanyContribution' => '\\StructType\\PaycheckJournalCompanyContribution',
            'PaycheckJournalCompanyContributionList' => '\\StructType\\PaycheckJournalCompanyContributionList',
            'PaycheckJournalEarning' => '\\StructType\\PaycheckJournalEarning',
            'PaycheckJournalEarningList' => '\\StructType\\PaycheckJournalEarningList',
            'PaycheckJournalEmployeeTax' => '\\StructType\\PaycheckJournalEmployeeTax',
            'PaycheckJournalEmployeeTaxList' => '\\StructType\\PaycheckJournalEmployeeTaxList',
            'TimeEntry' => '\\StructType\\TimeEntry',
            'TimeSheet' => '\\StructType\\TimeSheet',
            'TimeSheetTimeGrid' => '\\StructType\\TimeSheetTimeGrid',
            'TimeSheetTimeGridList' => '\\StructType\\TimeSheetTimeGridList',
            'TimeEntrySearch' => '\\StructType\\TimeEntrySearch',
            'TimeEntrySearchAdvanced' => '\\StructType\\TimeEntrySearchAdvanced',
            'TimeEntrySearchRow' => '\\StructType\\TimeEntrySearchRow',
            'TimeSheetSearch' => '\\StructType\\TimeSheetSearch',
            'TimeSheetSearchAdvanced' => '\\StructType\\TimeSheetSearchAdvanced',
            'TimeSheetSearchRow' => '\\StructType\\TimeSheetSearchRow',
            'Paycheck' => '\\StructType\\Paycheck',
            'PaycheckPayTime' => '\\StructType\\PaycheckPayTime',
            'PaycheckPayTimeList' => '\\StructType\\PaycheckPayTimeList',
            'PaycheckPayExp' => '\\StructType\\PaycheckPayExp',
            'PaycheckPayExpList' => '\\StructType\\PaycheckPayExpList',
            'PaycheckPayDisburse' => '\\StructType\\PaycheckPayDisburse',
            'PaycheckPayDisburseList' => '\\StructType\\PaycheckPayDisburseList',
            'PaycheckPaySummary' => '\\StructType\\PaycheckPaySummary',
            'PaycheckPaySummaryList' => '\\StructType\\PaycheckPaySummaryList',
            'PaycheckPayDeduct' => '\\StructType\\PaycheckPayDeduct',
            'PaycheckPayDeductList' => '\\StructType\\PaycheckPayDeductList',
            'PaycheckPayPto' => '\\StructType\\PaycheckPayPto',
            'PaycheckPayPtoList' => '\\StructType\\PaycheckPayPtoList',
            'PaycheckPayTax' => '\\StructType\\PaycheckPayTax',
            'PaycheckPayTaxList' => '\\StructType\\PaycheckPayTaxList',
            'PaycheckPayEarn' => '\\StructType\\PaycheckPayEarn',
            'PaycheckPayEarnList' => '\\StructType\\PaycheckPayEarnList',
            'PaycheckPayContrib' => '\\StructType\\PaycheckPayContrib',
            'PaycheckPayContribList' => '\\StructType\\PaycheckPayContribList',
            'PaycheckSearch' => '\\StructType\\PaycheckSearch',
            'PaycheckSearchAdvanced' => '\\StructType\\PaycheckSearchAdvanced',
            'PaycheckSearchRow' => '\\StructType\\PaycheckSearchRow',
            'Campaign' => '\\StructType\\Campaign',
            'CampaignEmail' => '\\StructType\\CampaignEmail',
            'CampaignEmailList' => '\\StructType\\CampaignEmailList',
            'CampaignDirectMail' => '\\StructType\\CampaignDirectMail',
            'CampaignDirectMailList' => '\\StructType\\CampaignDirectMailList',
            'CampaignEvent' => '\\StructType\\CampaignEvent',
            'CampaignEventList' => '\\StructType\\CampaignEventList',
            'CampaignEventResponse' => '\\StructType\\CampaignEventResponse',
            'CampaignEventResponseList' => '\\StructType\\CampaignEventResponseList',
            'CampaignSearch' => '\\StructType\\CampaignSearch',
            'CampaignSearchAdvanced' => '\\StructType\\CampaignSearchAdvanced',
            'CampaignSearchRow' => '\\StructType\\CampaignSearchRow',
            'CampaignCategory' => '\\StructType\\CampaignCategory',
            'CampaignAudience' => '\\StructType\\CampaignAudience',
            'CampaignFamily' => '\\StructType\\CampaignFamily',
            'CampaignSearchEngine' => '\\StructType\\CampaignSearchEngine',
            'CampaignChannel' => '\\StructType\\CampaignChannel',
            'CampaignOffer' => '\\StructType\\CampaignOffer',
            'CampaignResponse' => '\\StructType\\CampaignResponse',
            'CampaignResponseResponses' => '\\StructType\\CampaignResponseResponses',
            'CampaignResponseResponsesList' => '\\StructType\\CampaignResponseResponsesList',
            'CampaignVertical' => '\\StructType\\CampaignVertical',
            'CampaignSubscription' => '\\StructType\\CampaignSubscription',
            'PromotionCode' => '\\StructType\\PromotionCode',
            'PromotionCodePartners' => '\\StructType\\PromotionCodePartners',
            'PromotionCodePartnersList' => '\\StructType\\PromotionCodePartnersList',
            'PromotionCodeItems' => '\\StructType\\PromotionCodeItems',
            'PromotionCodeItemsList' => '\\StructType\\PromotionCodeItemsList',
            'PromotionCodeSearch' => '\\StructType\\PromotionCodeSearch',
            'PromotionCodeSearchAdvanced' => '\\StructType\\PromotionCodeSearchAdvanced',
            'PromotionCodeSearchRow' => '\\StructType\\PromotionCodeSearchRow',
            'PromotionCodeCurrency' => '\\StructType\\PromotionCodeCurrency',
            'PromotionCodeCurrencyList' => '\\StructType\\PromotionCodeCurrencyList',
            'CouponCode' => '\\StructType\\CouponCode',
            'CouponCodeSearch' => '\\StructType\\CouponCodeSearch',
            'CouponCodeSearchAdvanced' => '\\StructType\\CouponCodeSearchAdvanced',
            'CouponCodeSearchRow' => '\\StructType\\CouponCodeSearchRow',
            'ItemDemandPlan' => '\\StructType\\ItemDemandPlan',
            'DemandPlan' => '\\StructType\\DemandPlan',
            'DemandPlanMatrix' => '\\StructType\\DemandPlanMatrix',
            'PeriodDemandPlanList' => '\\StructType\\PeriodDemandPlanList',
            'PeriodDemandPlan' => '\\StructType\\PeriodDemandPlan',
            'ItemDemandPlanSearch' => '\\StructType\\ItemDemandPlanSearch',
            'ItemDemandPlanSearchAdvanced' => '\\StructType\\ItemDemandPlanSearchAdvanced',
            'ItemDemandPlanSearchRow' => '\\StructType\\ItemDemandPlanSearchRow',
            'ItemSupplyPlan' => '\\StructType\\ItemSupplyPlan',
            'ItemSupplyPlanOrder' => '\\StructType\\ItemSupplyPlanOrder',
            'ItemSupplyPlanOrderList' => '\\StructType\\ItemSupplyPlanOrderList',
            'ItemSupplyPlanSearch' => '\\StructType\\ItemSupplyPlanSearch',
            'ItemSupplyPlanSearchAdvanced' => '\\StructType\\ItemSupplyPlanSearchAdvanced',
            'ItemSupplyPlanSearchRow' => '\\StructType\\ItemSupplyPlanSearchRow',
            'ManufacturingCostTemplate' => '\\StructType\\ManufacturingCostTemplate',
            'ManufacturingCostDetail' => '\\StructType\\ManufacturingCostDetail',
            'ManufacturingCostDetailList' => '\\StructType\\ManufacturingCostDetailList',
            'ManufacturingCostTemplateSearch' => '\\StructType\\ManufacturingCostTemplateSearch',
            'ManufacturingCostTemplateSearchAdvanced' => '\\StructType\\ManufacturingCostTemplateSearchAdvanced',
            'ManufacturingCostTemplateSearchRow' => '\\StructType\\ManufacturingCostTemplateSearchRow',
            'ManufacturingRouting' => '\\StructType\\ManufacturingRouting',
            'ManufacturingRoutingRoutingStep' => '\\StructType\\ManufacturingRoutingRoutingStep',
            'ManufacturingRoutingRoutingStepList' => '\\StructType\\ManufacturingRoutingRoutingStepList',
            'ManufacturingRoutingSearch' => '\\StructType\\ManufacturingRoutingSearch',
            'ManufacturingRoutingSearchAdvanced' => '\\StructType\\ManufacturingRoutingSearchAdvanced',
            'ManufacturingRoutingSearchRow' => '\\StructType\\ManufacturingRoutingSearchRow',
            'ManufacturingOperationTask' => '\\StructType\\ManufacturingOperationTask',
            'ManufacturingOperationTaskSearch' => '\\StructType\\ManufacturingOperationTaskSearch',
            'ManufacturingOperationTaskSearchAdvanced' => '\\StructType\\ManufacturingOperationTaskSearchAdvanced',
            'ManufacturingOperationTaskSearchRow' => '\\StructType\\ManufacturingOperationTaskSearchRow',
            'ManufacturingOperationTaskPredecessor' => '\\StructType\\ManufacturingOperationTaskPredecessor',
            'ManufacturingOperationTaskPredecessorList' => '\\StructType\\ManufacturingOperationTaskPredecessorList',
            'ManufacturingRoutingRoutingComponent' => '\\StructType\\ManufacturingRoutingRoutingComponent',
            'ManufacturingRoutingRoutingComponentList' => '\\StructType\\ManufacturingRoutingRoutingComponentList',
        );
    }
}
