<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for CustomizationDynamicDefault EnumType
 * @subpackage Enumerations
 */
class CustomizationDynamicDefault extends AbstractStructEnumBase
{
    /**
     * Constant for value '_currentDateTime'
     * @return string '_currentDateTime'
     */
    const VALUE_CURRENT_DATE_TIME = '_currentDateTime';
    /**
     * Constant for value '_currentUser'
     * @return string '_currentUser'
     */
    const VALUE_CURRENT_USER = '_currentUser';
    /**
     * Constant for value '_currentUsersDepartment'
     * @return string '_currentUsersDepartment'
     */
    const VALUE_CURRENT_USERS_DEPARTMENT = '_currentUsersDepartment';
    /**
     * Constant for value '_currentUsersLocation'
     * @return string '_currentUsersLocation'
     */
    const VALUE_CURRENT_USERS_LOCATION = '_currentUsersLocation';
    /**
     * Constant for value '_currentUsersSupervisor'
     * @return string '_currentUsersSupervisor'
     */
    const VALUE_CURRENT_USERS_SUPERVISOR = '_currentUsersSupervisor';
    /**
     * Constant for value '_currentUsersSubsidiary'
     * @return string '_currentUsersSubsidiary'
     */
    const VALUE_CURRENT_USERS_SUBSIDIARY = '_currentUsersSubsidiary';
    /**
     * Return allowed values
     * @uses self::VALUE_CURRENT_DATE_TIME
     * @uses self::VALUE_CURRENT_USER
     * @uses self::VALUE_CURRENT_USERS_DEPARTMENT
     * @uses self::VALUE_CURRENT_USERS_LOCATION
     * @uses self::VALUE_CURRENT_USERS_SUPERVISOR
     * @uses self::VALUE_CURRENT_USERS_SUBSIDIARY
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_CURRENT_DATE_TIME,
            self::VALUE_CURRENT_USER,
            self::VALUE_CURRENT_USERS_DEPARTMENT,
            self::VALUE_CURRENT_USERS_LOCATION,
            self::VALUE_CURRENT_USERS_SUPERVISOR,
            self::VALUE_CURRENT_USERS_SUBSIDIARY,
        );
    }
}
