<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for InitializeRefType EnumType
 * @subpackage Enumerations
 */
class InitializeRefType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'assemblyItem'
     * @return string 'assemblyItem'
     */
    const VALUE_ASSEMBLY_ITEM = 'assemblyItem';
    /**
     * Constant for value 'assemblyBuild'
     * @return string 'assemblyBuild'
     */
    const VALUE_ASSEMBLY_BUILD = 'assemblyBuild';
    /**
     * Constant for value 'cashSale'
     * @return string 'cashSale'
     */
    const VALUE_CASH_SALE = 'cashSale';
    /**
     * Constant for value 'creditMemo'
     * @return string 'creditMemo'
     */
    const VALUE_CREDIT_MEMO = 'creditMemo';
    /**
     * Constant for value 'customer'
     * @return string 'customer'
     */
    const VALUE_CUSTOMER = 'customer';
    /**
     * Constant for value 'customerDeposit'
     * @return string 'customerDeposit'
     */
    const VALUE_CUSTOMER_DEPOSIT = 'customerDeposit';
    /**
     * Constant for value 'customPurchase'
     * @return string 'customPurchase'
     */
    const VALUE_CUSTOM_PURCHASE = 'customPurchase';
    /**
     * Constant for value 'customSale'
     * @return string 'customSale'
     */
    const VALUE_CUSTOM_SALE = 'customSale';
    /**
     * Constant for value 'employee'
     * @return string 'employee'
     */
    const VALUE_EMPLOYEE = 'employee';
    /**
     * Constant for value 'estimate'
     * @return string 'estimate'
     */
    const VALUE_ESTIMATE = 'estimate';
    /**
     * Constant for value 'interCompanyTransferOrder'
     * @return string 'interCompanyTransferOrder'
     */
    const VALUE_INTER_COMPANY_TRANSFER_ORDER = 'interCompanyTransferOrder';
    /**
     * Constant for value 'invoice'
     * @return string 'invoice'
     */
    const VALUE_INVOICE = 'invoice';
    /**
     * Constant for value 'location'
     * @return string 'location'
     */
    const VALUE_LOCATION = 'location';
    /**
     * Constant for value 'lotNumberedAssemblyItem'
     * @return string 'lotNumberedAssemblyItem'
     */
    const VALUE_LOT_NUMBERED_ASSEMBLY_ITEM = 'lotNumberedAssemblyItem';
    /**
     * Constant for value 'opportunity'
     * @return string 'opportunity'
     */
    const VALUE_OPPORTUNITY = 'opportunity';
    /**
     * Constant for value 'purchaseOrder'
     * @return string 'purchaseOrder'
     */
    const VALUE_PURCHASE_ORDER = 'purchaseOrder';
    /**
     * Constant for value 'purchaseRequisition'
     * @return string 'purchaseRequisition'
     */
    const VALUE_PURCHASE_REQUISITION = 'purchaseRequisition';
    /**
     * Constant for value 'returnAuthorization'
     * @return string 'returnAuthorization'
     */
    const VALUE_RETURN_AUTHORIZATION = 'returnAuthorization';
    /**
     * Constant for value 'salesOrder'
     * @return string 'salesOrder'
     */
    const VALUE_SALES_ORDER = 'salesOrder';
    /**
     * Constant for value 'serializedAssemblyItem'
     * @return string 'serializedAssemblyItem'
     */
    const VALUE_SERIALIZED_ASSEMBLY_ITEM = 'serializedAssemblyItem';
    /**
     * Constant for value 'transferOrder'
     * @return string 'transferOrder'
     */
    const VALUE_TRANSFER_ORDER = 'transferOrder';
    /**
     * Constant for value 'vendor'
     * @return string 'vendor'
     */
    const VALUE_VENDOR = 'vendor';
    /**
     * Constant for value 'vendorBill'
     * @return string 'vendorBill'
     */
    const VALUE_VENDOR_BILL = 'vendorBill';
    /**
     * Constant for value 'vendorReturnAuthorization'
     * @return string 'vendorReturnAuthorization'
     */
    const VALUE_VENDOR_RETURN_AUTHORIZATION = 'vendorReturnAuthorization';
    /**
     * Constant for value 'workOrder'
     * @return string 'workOrder'
     */
    const VALUE_WORK_ORDER = 'workOrder';
    /**
     * Return allowed values
     * @uses self::VALUE_ASSEMBLY_ITEM
     * @uses self::VALUE_ASSEMBLY_BUILD
     * @uses self::VALUE_CASH_SALE
     * @uses self::VALUE_CREDIT_MEMO
     * @uses self::VALUE_CUSTOMER
     * @uses self::VALUE_CUSTOMER_DEPOSIT
     * @uses self::VALUE_CUSTOM_PURCHASE
     * @uses self::VALUE_CUSTOM_SALE
     * @uses self::VALUE_EMPLOYEE
     * @uses self::VALUE_ESTIMATE
     * @uses self::VALUE_INTER_COMPANY_TRANSFER_ORDER
     * @uses self::VALUE_INVOICE
     * @uses self::VALUE_LOCATION
     * @uses self::VALUE_LOT_NUMBERED_ASSEMBLY_ITEM
     * @uses self::VALUE_OPPORTUNITY
     * @uses self::VALUE_PURCHASE_ORDER
     * @uses self::VALUE_PURCHASE_REQUISITION
     * @uses self::VALUE_RETURN_AUTHORIZATION
     * @uses self::VALUE_SALES_ORDER
     * @uses self::VALUE_SERIALIZED_ASSEMBLY_ITEM
     * @uses self::VALUE_TRANSFER_ORDER
     * @uses self::VALUE_VENDOR
     * @uses self::VALUE_VENDOR_BILL
     * @uses self::VALUE_VENDOR_RETURN_AUTHORIZATION
     * @uses self::VALUE_WORK_ORDER
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ASSEMBLY_ITEM,
            self::VALUE_ASSEMBLY_BUILD,
            self::VALUE_CASH_SALE,
            self::VALUE_CREDIT_MEMO,
            self::VALUE_CUSTOMER,
            self::VALUE_CUSTOMER_DEPOSIT,
            self::VALUE_CUSTOM_PURCHASE,
            self::VALUE_CUSTOM_SALE,
            self::VALUE_EMPLOYEE,
            self::VALUE_ESTIMATE,
            self::VALUE_INTER_COMPANY_TRANSFER_ORDER,
            self::VALUE_INVOICE,
            self::VALUE_LOCATION,
            self::VALUE_LOT_NUMBERED_ASSEMBLY_ITEM,
            self::VALUE_OPPORTUNITY,
            self::VALUE_PURCHASE_ORDER,
            self::VALUE_PURCHASE_REQUISITION,
            self::VALUE_RETURN_AUTHORIZATION,
            self::VALUE_SALES_ORDER,
            self::VALUE_SERIALIZED_ASSEMBLY_ITEM,
            self::VALUE_TRANSFER_ORDER,
            self::VALUE_VENDOR,
            self::VALUE_VENDOR_BILL,
            self::VALUE_VENDOR_RETURN_AUTHORIZATION,
            self::VALUE_WORK_ORDER,
        );
    }
}
