<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for ItemEbayRelistingOption EnumType
 * @subpackage Enumerations
 */
class ItemEbayRelistingOption extends AbstractStructEnumBase
{
    /**
     * Constant for value '_doNotRelist'
     * @return string '_doNotRelist'
     */
    const VALUE_DO_NOT_RELIST = '_doNotRelist';
    /**
     * Constant for value '_relistWhenItemExpires'
     * @return string '_relistWhenItemExpires'
     */
    const VALUE_RELIST_WHEN_ITEM_EXPIRES = '_relistWhenItemExpires';
    /**
     * Constant for value '_relistWhenItemIsSold'
     * @return string '_relistWhenItemIsSold'
     */
    const VALUE_RELIST_WHEN_ITEM_IS_SOLD = '_relistWhenItemIsSold';
    /**
     * Constant for value '_relistWhenItemIsSoldExpires'
     * @return string '_relistWhenItemIsSoldExpires'
     */
    const VALUE_RELIST_WHEN_ITEM_IS_SOLD_EXPIRES = '_relistWhenItemIsSoldExpires';
    /**
     * Return allowed values
     * @uses self::VALUE_DO_NOT_RELIST
     * @uses self::VALUE_RELIST_WHEN_ITEM_EXPIRES
     * @uses self::VALUE_RELIST_WHEN_ITEM_IS_SOLD
     * @uses self::VALUE_RELIST_WHEN_ITEM_IS_SOLD_EXPIRES
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_DO_NOT_RELIST,
            self::VALUE_RELIST_WHEN_ITEM_EXPIRES,
            self::VALUE_RELIST_WHEN_ITEM_IS_SOLD,
            self::VALUE_RELIST_WHEN_ITEM_IS_SOLD_EXPIRES,
        );
    }
}
