<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for ItemType EnumType
 * @subpackage Enumerations
 */
class ItemType extends AbstractStructEnumBase
{
    /**
     * Constant for value '_assembly'
     * @return string '_assembly'
     */
    const VALUE_ASSEMBLY = '_assembly';
    /**
     * Constant for value '_description'
     * @return string '_description'
     */
    const VALUE_DESCRIPTION = '_description';
    /**
     * Constant for value '_discount'
     * @return string '_discount'
     */
    const VALUE_DISCOUNT = '_discount';
    /**
     * Constant for value '_downloadItem'
     * @return string '_downloadItem'
     */
    const VALUE_DOWNLOAD_ITEM = '_downloadItem';
    /**
     * Constant for value '_giftCertificateItem'
     * @return string '_giftCertificateItem'
     */
    const VALUE_GIFT_CERTIFICATE_ITEM = '_giftCertificateItem';
    /**
     * Constant for value '_inventoryItem'
     * @return string '_inventoryItem'
     */
    const VALUE_INVENTORY_ITEM = '_inventoryItem';
    /**
     * Constant for value '_itemGroup'
     * @return string '_itemGroup'
     */
    const VALUE_ITEM_GROUP = '_itemGroup';
    /**
     * Constant for value '_kit'
     * @return string '_kit'
     */
    const VALUE_KIT = '_kit';
    /**
     * Constant for value '_markup'
     * @return string '_markup'
     */
    const VALUE_MARKUP = '_markup';
    /**
     * Constant for value '_nonInventoryItem'
     * @return string '_nonInventoryItem'
     */
    const VALUE_NON_INVENTORY_ITEM = '_nonInventoryItem';
    /**
     * Constant for value '_otherCharge'
     * @return string '_otherCharge'
     */
    const VALUE_OTHER_CHARGE = '_otherCharge';
    /**
     * Constant for value '_payment'
     * @return string '_payment'
     */
    const VALUE_PAYMENT = '_payment';
    /**
     * Constant for value '_service'
     * @return string '_service'
     */
    const VALUE_SERVICE = '_service';
    /**
     * Constant for value '_subtotal'
     * @return string '_subtotal'
     */
    const VALUE_SUBTOTAL = '_subtotal';
    /**
     * Return allowed values
     * @uses self::VALUE_ASSEMBLY
     * @uses self::VALUE_DESCRIPTION
     * @uses self::VALUE_DISCOUNT
     * @uses self::VALUE_DOWNLOAD_ITEM
     * @uses self::VALUE_GIFT_CERTIFICATE_ITEM
     * @uses self::VALUE_INVENTORY_ITEM
     * @uses self::VALUE_ITEM_GROUP
     * @uses self::VALUE_KIT
     * @uses self::VALUE_MARKUP
     * @uses self::VALUE_NON_INVENTORY_ITEM
     * @uses self::VALUE_OTHER_CHARGE
     * @uses self::VALUE_PAYMENT
     * @uses self::VALUE_SERVICE
     * @uses self::VALUE_SUBTOTAL
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ASSEMBLY,
            self::VALUE_DESCRIPTION,
            self::VALUE_DISCOUNT,
            self::VALUE_DOWNLOAD_ITEM,
            self::VALUE_GIFT_CERTIFICATE_ITEM,
            self::VALUE_INVENTORY_ITEM,
            self::VALUE_ITEM_GROUP,
            self::VALUE_KIT,
            self::VALUE_MARKUP,
            self::VALUE_NON_INVENTORY_ITEM,
            self::VALUE_OTHER_CHARGE,
            self::VALUE_PAYMENT,
            self::VALUE_SERVICE,
            self::VALUE_SUBTOTAL,
        );
    }
}
