<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AssemblyItemBillOfMaterials StructType
 * @subpackage Structs
 */
class AssemblyItemBillOfMaterials extends AbstractStructBase
{
    /**
     * The billOfMaterials
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $billOfMaterials;
    /**
     * The currentRevision
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $currentRevision;
    /**
     * The masterDefault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $masterDefault;
    /**
     * The defaultForLocationList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $defaultForLocationList;
    /**
     * The inactive
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $inactive;
    /**
     * The memo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $memo;
    /**
     * Constructor method for AssemblyItemBillOfMaterials
     * @uses AssemblyItemBillOfMaterials::setBillOfMaterials()
     * @uses AssemblyItemBillOfMaterials::setCurrentRevision()
     * @uses AssemblyItemBillOfMaterials::setMasterDefault()
     * @uses AssemblyItemBillOfMaterials::setDefaultForLocationList()
     * @uses AssemblyItemBillOfMaterials::setInactive()
     * @uses AssemblyItemBillOfMaterials::setMemo()
     * @param \StructType\RecordRef $billOfMaterials
     * @param string $currentRevision
     * @param bool $masterDefault
     * @param \StructType\RecordRefList $defaultForLocationList
     * @param string $inactive
     * @param string $memo
     */
    public function __construct(\StructType\RecordRef $billOfMaterials = null, $currentRevision = null, $masterDefault = null, \StructType\RecordRefList $defaultForLocationList = null, $inactive = null, $memo = null)
    {
        $this
            ->setBillOfMaterials($billOfMaterials)
            ->setCurrentRevision($currentRevision)
            ->setMasterDefault($masterDefault)
            ->setDefaultForLocationList($defaultForLocationList)
            ->setInactive($inactive)
            ->setMemo($memo);
    }
    /**
     * Get billOfMaterials value
     * @return \StructType\RecordRef|null
     */
    public function getBillOfMaterials()
    {
        return $this->billOfMaterials;
    }
    /**
     * Set billOfMaterials value
     * @param \StructType\RecordRef $billOfMaterials
     * @return \StructType\AssemblyItemBillOfMaterials
     */
    public function setBillOfMaterials(\StructType\RecordRef $billOfMaterials = null)
    {
        $this->billOfMaterials = $billOfMaterials;
        return $this;
    }
    /**
     * Get currentRevision value
     * @return string|null
     */
    public function getCurrentRevision()
    {
        return $this->currentRevision;
    }
    /**
     * Set currentRevision value
     * @param string $currentRevision
     * @return \StructType\AssemblyItemBillOfMaterials
     */
    public function setCurrentRevision($currentRevision = null)
    {
        // validation for constraint: string
        if (!is_null($currentRevision) && !is_string($currentRevision)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currentRevision, true), gettype($currentRevision)), __LINE__);
        }
        $this->currentRevision = $currentRevision;
        return $this;
    }
    /**
     * Get masterDefault value
     * @return bool|null
     */
    public function getMasterDefault()
    {
        return $this->masterDefault;
    }
    /**
     * Set masterDefault value
     * @param bool $masterDefault
     * @return \StructType\AssemblyItemBillOfMaterials
     */
    public function setMasterDefault($masterDefault = null)
    {
        // validation for constraint: boolean
        if (!is_null($masterDefault) && !is_bool($masterDefault)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($masterDefault, true), gettype($masterDefault)), __LINE__);
        }
        $this->masterDefault = $masterDefault;
        return $this;
    }
    /**
     * Get defaultForLocationList value
     * @return \StructType\RecordRefList|null
     */
    public function getDefaultForLocationList()
    {
        return $this->defaultForLocationList;
    }
    /**
     * Set defaultForLocationList value
     * @param \StructType\RecordRefList $defaultForLocationList
     * @return \StructType\AssemblyItemBillOfMaterials
     */
    public function setDefaultForLocationList(\StructType\RecordRefList $defaultForLocationList = null)
    {
        $this->defaultForLocationList = $defaultForLocationList;
        return $this;
    }
    /**
     * Get inactive value
     * @return string|null
     */
    public function getInactive()
    {
        return $this->inactive;
    }
    /**
     * Set inactive value
     * @param string $inactive
     * @return \StructType\AssemblyItemBillOfMaterials
     */
    public function setInactive($inactive = null)
    {
        // validation for constraint: string
        if (!is_null($inactive) && !is_string($inactive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inactive, true), gettype($inactive)), __LINE__);
        }
        $this->inactive = $inactive;
        return $this;
    }
    /**
     * Get memo value
     * @return string|null
     */
    public function getMemo()
    {
        return $this->memo;
    }
    /**
     * Set memo value
     * @param string $memo
     * @return \StructType\AssemblyItemBillOfMaterials
     */
    public function setMemo($memo = null)
    {
        // validation for constraint: string
        if (!is_null($memo) && !is_string($memo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($memo, true), gettype($memo)), __LINE__);
        }
        $this->memo = $memo;
        return $this;
    }
}
