<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BillingScheduleMilestoneList StructType
 * @subpackage Structs
 */
class BillingScheduleMilestoneList extends AbstractStructBase
{
    /**
     * The billingScheduleMilestone
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BillingScheduleMilestone[]
     */
    public $billingScheduleMilestone;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for BillingScheduleMilestoneList
     * @uses BillingScheduleMilestoneList::setBillingScheduleMilestone()
     * @uses BillingScheduleMilestoneList::setReplaceAll()
     * @param \StructType\BillingScheduleMilestone[] $billingScheduleMilestone
     * @param bool $replaceAll
     */
    public function __construct(array $billingScheduleMilestone = array(), $replaceAll = true)
    {
        $this
            ->setBillingScheduleMilestone($billingScheduleMilestone)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get billingScheduleMilestone value
     * @return \StructType\BillingScheduleMilestone[]|null
     */
    public function getBillingScheduleMilestone()
    {
        return $this->billingScheduleMilestone;
    }
    /**
     * This method is responsible for validating the values passed to the setBillingScheduleMilestone method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBillingScheduleMilestone method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBillingScheduleMilestoneForArrayConstraintsFromSetBillingScheduleMilestone(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $billingScheduleMilestoneListBillingScheduleMilestoneItem) {
            // validation for constraint: itemType
            if (!$billingScheduleMilestoneListBillingScheduleMilestoneItem instanceof \StructType\BillingScheduleMilestone) {
                $invalidValues[] = is_object($billingScheduleMilestoneListBillingScheduleMilestoneItem) ? get_class($billingScheduleMilestoneListBillingScheduleMilestoneItem) : sprintf('%s(%s)', gettype($billingScheduleMilestoneListBillingScheduleMilestoneItem), var_export($billingScheduleMilestoneListBillingScheduleMilestoneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The billingScheduleMilestone property can only contain items of type \StructType\BillingScheduleMilestone, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set billingScheduleMilestone value
     * @throws \InvalidArgumentException
     * @param \StructType\BillingScheduleMilestone[] $billingScheduleMilestone
     * @return \StructType\BillingScheduleMilestoneList
     */
    public function setBillingScheduleMilestone(array $billingScheduleMilestone = array())
    {
        // validation for constraint: array
        if ('' !== ($billingScheduleMilestoneArrayErrorMessage = self::validateBillingScheduleMilestoneForArrayConstraintsFromSetBillingScheduleMilestone($billingScheduleMilestone))) {
            throw new \InvalidArgumentException($billingScheduleMilestoneArrayErrorMessage, __LINE__);
        }
        $this->billingScheduleMilestone = $billingScheduleMilestone;
        return $this;
    }
    /**
     * Add item to billingScheduleMilestone value
     * @throws \InvalidArgumentException
     * @param \StructType\BillingScheduleMilestone $item
     * @return \StructType\BillingScheduleMilestoneList
     */
    public function addToBillingScheduleMilestone(\StructType\BillingScheduleMilestone $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BillingScheduleMilestone) {
            throw new \InvalidArgumentException(sprintf('The billingScheduleMilestone property can only contain items of type \StructType\BillingScheduleMilestone, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->billingScheduleMilestone[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\BillingScheduleMilestoneList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
