<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BillingScheduleRecurrenceList StructType
 * @subpackage Structs
 */
class BillingScheduleRecurrenceList extends AbstractStructBase
{
    /**
     * The billingScheduleRecurrence
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BillingScheduleRecurrence[]
     */
    public $billingScheduleRecurrence;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for BillingScheduleRecurrenceList
     * @uses BillingScheduleRecurrenceList::setBillingScheduleRecurrence()
     * @uses BillingScheduleRecurrenceList::setReplaceAll()
     * @param \StructType\BillingScheduleRecurrence[] $billingScheduleRecurrence
     * @param bool $replaceAll
     */
    public function __construct(array $billingScheduleRecurrence = array(), $replaceAll = true)
    {
        $this
            ->setBillingScheduleRecurrence($billingScheduleRecurrence)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get billingScheduleRecurrence value
     * @return \StructType\BillingScheduleRecurrence[]|null
     */
    public function getBillingScheduleRecurrence()
    {
        return $this->billingScheduleRecurrence;
    }
    /**
     * This method is responsible for validating the values passed to the setBillingScheduleRecurrence method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBillingScheduleRecurrence method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBillingScheduleRecurrenceForArrayConstraintsFromSetBillingScheduleRecurrence(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $billingScheduleRecurrenceListBillingScheduleRecurrenceItem) {
            // validation for constraint: itemType
            if (!$billingScheduleRecurrenceListBillingScheduleRecurrenceItem instanceof \StructType\BillingScheduleRecurrence) {
                $invalidValues[] = is_object($billingScheduleRecurrenceListBillingScheduleRecurrenceItem) ? get_class($billingScheduleRecurrenceListBillingScheduleRecurrenceItem) : sprintf('%s(%s)', gettype($billingScheduleRecurrenceListBillingScheduleRecurrenceItem), var_export($billingScheduleRecurrenceListBillingScheduleRecurrenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The billingScheduleRecurrence property can only contain items of type \StructType\BillingScheduleRecurrence, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set billingScheduleRecurrence value
     * @throws \InvalidArgumentException
     * @param \StructType\BillingScheduleRecurrence[] $billingScheduleRecurrence
     * @return \StructType\BillingScheduleRecurrenceList
     */
    public function setBillingScheduleRecurrence(array $billingScheduleRecurrence = array())
    {
        // validation for constraint: array
        if ('' !== ($billingScheduleRecurrenceArrayErrorMessage = self::validateBillingScheduleRecurrenceForArrayConstraintsFromSetBillingScheduleRecurrence($billingScheduleRecurrence))) {
            throw new \InvalidArgumentException($billingScheduleRecurrenceArrayErrorMessage, __LINE__);
        }
        $this->billingScheduleRecurrence = $billingScheduleRecurrence;
        return $this;
    }
    /**
     * Add item to billingScheduleRecurrence value
     * @throws \InvalidArgumentException
     * @param \StructType\BillingScheduleRecurrence $item
     * @return \StructType\BillingScheduleRecurrenceList
     */
    public function addToBillingScheduleRecurrence(\StructType\BillingScheduleRecurrence $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BillingScheduleRecurrence) {
            throw new \InvalidArgumentException(sprintf('The billingScheduleRecurrence property can only contain items of type \StructType\BillingScheduleRecurrence, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->billingScheduleRecurrence[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\BillingScheduleRecurrenceList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
