<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BomSearchRow StructType
 * @subpackage Structs
 */
class BomSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomSearchRowBasic
     */
    public $basic;
    /**
     * The assemblyItemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AssemblyItemBomSearchRowBasic
     */
    public $assemblyItemJoin;
    /**
     * The revisionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomRevisionSearchRowBasic
     */
    public $revisionJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for BomSearchRow
     * @uses BomSearchRow::setBasic()
     * @uses BomSearchRow::setAssemblyItemJoin()
     * @uses BomSearchRow::setRevisionJoin()
     * @uses BomSearchRow::setTransactionJoin()
     * @uses BomSearchRow::setCustomSearchJoin()
     * @param \StructType\BomSearchRowBasic $basic
     * @param \StructType\AssemblyItemBomSearchRowBasic $assemblyItemJoin
     * @param \StructType\BomRevisionSearchRowBasic $revisionJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\BomSearchRowBasic $basic = null, \StructType\AssemblyItemBomSearchRowBasic $assemblyItemJoin = null, \StructType\BomRevisionSearchRowBasic $revisionJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setAssemblyItemJoin($assemblyItemJoin)
            ->setRevisionJoin($revisionJoin)
            ->setTransactionJoin($transactionJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\BomSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\BomSearchRowBasic $basic
     * @return \StructType\BomSearchRow
     */
    public function setBasic(\StructType\BomSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get assemblyItemJoin value
     * @return \StructType\AssemblyItemBomSearchRowBasic|null
     */
    public function getAssemblyItemJoin()
    {
        return $this->assemblyItemJoin;
    }
    /**
     * Set assemblyItemJoin value
     * @param \StructType\AssemblyItemBomSearchRowBasic $assemblyItemJoin
     * @return \StructType\BomSearchRow
     */
    public function setAssemblyItemJoin(\StructType\AssemblyItemBomSearchRowBasic $assemblyItemJoin = null)
    {
        $this->assemblyItemJoin = $assemblyItemJoin;
        return $this;
    }
    /**
     * Get revisionJoin value
     * @return \StructType\BomRevisionSearchRowBasic|null
     */
    public function getRevisionJoin()
    {
        return $this->revisionJoin;
    }
    /**
     * Set revisionJoin value
     * @param \StructType\BomRevisionSearchRowBasic $revisionJoin
     * @return \StructType\BomSearchRow
     */
    public function setRevisionJoin(\StructType\BomRevisionSearchRowBasic $revisionJoin = null)
    {
        $this->revisionJoin = $revisionJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\BomSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $bomSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$bomSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($bomSearchRowCustomSearchJoinItem) ? get_class($bomSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($bomSearchRowCustomSearchJoinItem), var_export($bomSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\BomSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\BomSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
