<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CashRefundItemList StructType
 * @subpackage Structs
 */
class CashRefundItemList extends AbstractStructBase
{
    /**
     * The item
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CashRefundItem[]
     */
    public $item;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for CashRefundItemList
     * @uses CashRefundItemList::setItem()
     * @uses CashRefundItemList::setReplaceAll()
     * @param \StructType\CashRefundItem[] $item
     * @param bool $replaceAll
     */
    public function __construct(array $item = array(), $replaceAll = true)
    {
        $this
            ->setItem($item)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get item value
     * @return \StructType\CashRefundItem[]|null
     */
    public function getItem()
    {
        return $this->item;
    }
    /**
     * This method is responsible for validating the values passed to the setItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemForArrayConstraintsFromSetItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cashRefundItemListItemItem) {
            // validation for constraint: itemType
            if (!$cashRefundItemListItemItem instanceof \StructType\CashRefundItem) {
                $invalidValues[] = is_object($cashRefundItemListItemItem) ? get_class($cashRefundItemListItemItem) : sprintf('%s(%s)', gettype($cashRefundItemListItemItem), var_export($cashRefundItemListItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The item property can only contain items of type \StructType\CashRefundItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set item value
     * @throws \InvalidArgumentException
     * @param \StructType\CashRefundItem[] $item
     * @return \StructType\CashRefundItemList
     */
    public function setItem(array $item = array())
    {
        // validation for constraint: array
        if ('' !== ($itemArrayErrorMessage = self::validateItemForArrayConstraintsFromSetItem($item))) {
            throw new \InvalidArgumentException($itemArrayErrorMessage, __LINE__);
        }
        $this->item = $item;
        return $this;
    }
    /**
     * Add item to item value
     * @throws \InvalidArgumentException
     * @param \StructType\CashRefundItem $item
     * @return \StructType\CashRefundItemList
     */
    public function addToItem(\StructType\CashRefundItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CashRefundItem) {
            throw new \InvalidArgumentException(sprintf('The item property can only contain items of type \StructType\CashRefundItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->item[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\CashRefundItemList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
