<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomRecordSearchRow StructType
 * @subpackage Structs
 */
class CustomRecordSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomRecordSearchRowBasic
     */
    public $basic;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchRowBasic
     */
    public $fileJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesJoin;
    /**
     * The ownerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $ownerJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for CustomRecordSearchRow
     * @uses CustomRecordSearchRow::setBasic()
     * @uses CustomRecordSearchRow::setFileJoin()
     * @uses CustomRecordSearchRow::setMessagesJoin()
     * @uses CustomRecordSearchRow::setOwnerJoin()
     * @uses CustomRecordSearchRow::setUserJoin()
     * @uses CustomRecordSearchRow::setUserNotesJoin()
     * @uses CustomRecordSearchRow::setCustomSearchJoin()
     * @param \StructType\CustomRecordSearchRowBasic $basic
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @param \StructType\EmployeeSearchRowBasic $ownerJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\CustomRecordSearchRowBasic $basic = null, \StructType\FileSearchRowBasic $fileJoin = null, \StructType\MessageSearchRowBasic $messagesJoin = null, \StructType\EmployeeSearchRowBasic $ownerJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setFileJoin($fileJoin)
            ->setMessagesJoin($messagesJoin)
            ->setOwnerJoin($ownerJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\CustomRecordSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\CustomRecordSearchRowBasic $basic
     * @return \StructType\CustomRecordSearchRow
     */
    public function setBasic(\StructType\CustomRecordSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchRowBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @return \StructType\CustomRecordSearchRow
     */
    public function setFileJoin(\StructType\FileSearchRowBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @return \StructType\CustomRecordSearchRow
     */
    public function setMessagesJoin(\StructType\MessageSearchRowBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get ownerJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getOwnerJoin()
    {
        return $this->ownerJoin;
    }
    /**
     * Set ownerJoin value
     * @param \StructType\EmployeeSearchRowBasic $ownerJoin
     * @return \StructType\CustomRecordSearchRow
     */
    public function setOwnerJoin(\StructType\EmployeeSearchRowBasic $ownerJoin = null)
    {
        $this->ownerJoin = $ownerJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\CustomRecordSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\CustomRecordSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customRecordSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$customRecordSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($customRecordSearchRowCustomSearchJoinItem) ? get_class($customRecordSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($customRecordSearchRowCustomSearchJoinItem), var_export($customRecordSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\CustomRecordSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\CustomRecordSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
