<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomRecordTranslationsList StructType
 * @subpackage Structs
 */
class CustomRecordTranslationsList extends AbstractStructBase
{
    /**
     * The customRecordTranslations
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomRecordTranslations[]
     */
    public $customRecordTranslations;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for CustomRecordTranslationsList
     * @uses CustomRecordTranslationsList::setCustomRecordTranslations()
     * @uses CustomRecordTranslationsList::setReplaceAll()
     * @param \StructType\CustomRecordTranslations[] $customRecordTranslations
     * @param bool $replaceAll
     */
    public function __construct(array $customRecordTranslations = array(), $replaceAll = true)
    {
        $this
            ->setCustomRecordTranslations($customRecordTranslations)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get customRecordTranslations value
     * @return \StructType\CustomRecordTranslations[]|null
     */
    public function getCustomRecordTranslations()
    {
        return $this->customRecordTranslations;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomRecordTranslations method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomRecordTranslations method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomRecordTranslationsForArrayConstraintsFromSetCustomRecordTranslations(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customRecordTranslationsListCustomRecordTranslationsItem) {
            // validation for constraint: itemType
            if (!$customRecordTranslationsListCustomRecordTranslationsItem instanceof \StructType\CustomRecordTranslations) {
                $invalidValues[] = is_object($customRecordTranslationsListCustomRecordTranslationsItem) ? get_class($customRecordTranslationsListCustomRecordTranslationsItem) : sprintf('%s(%s)', gettype($customRecordTranslationsListCustomRecordTranslationsItem), var_export($customRecordTranslationsListCustomRecordTranslationsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customRecordTranslations property can only contain items of type \StructType\CustomRecordTranslations, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customRecordTranslations value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomRecordTranslations[] $customRecordTranslations
     * @return \StructType\CustomRecordTranslationsList
     */
    public function setCustomRecordTranslations(array $customRecordTranslations = array())
    {
        // validation for constraint: array
        if ('' !== ($customRecordTranslationsArrayErrorMessage = self::validateCustomRecordTranslationsForArrayConstraintsFromSetCustomRecordTranslations($customRecordTranslations))) {
            throw new \InvalidArgumentException($customRecordTranslationsArrayErrorMessage, __LINE__);
        }
        $this->customRecordTranslations = $customRecordTranslations;
        return $this;
    }
    /**
     * Add item to customRecordTranslations value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomRecordTranslations $item
     * @return \StructType\CustomRecordTranslationsList
     */
    public function addToCustomRecordTranslations(\StructType\CustomRecordTranslations $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomRecordTranslations) {
            throw new \InvalidArgumentException(sprintf('The customRecordTranslations property can only contain items of type \StructType\CustomRecordTranslations, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customRecordTranslations[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\CustomRecordTranslationsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
