<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomRecordTypeOnlineFormsList StructType
 * @subpackage Structs
 */
class CustomRecordTypeOnlineFormsList extends AbstractStructBase
{
    /**
     * The onlineForms
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomRecordTypeOnlineForms[]
     */
    public $onlineForms;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for CustomRecordTypeOnlineFormsList
     * @uses CustomRecordTypeOnlineFormsList::setOnlineForms()
     * @uses CustomRecordTypeOnlineFormsList::setReplaceAll()
     * @param \StructType\CustomRecordTypeOnlineForms[] $onlineForms
     * @param bool $replaceAll
     */
    public function __construct(array $onlineForms = array(), $replaceAll = true)
    {
        $this
            ->setOnlineForms($onlineForms)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get onlineForms value
     * @return \StructType\CustomRecordTypeOnlineForms[]|null
     */
    public function getOnlineForms()
    {
        return $this->onlineForms;
    }
    /**
     * This method is responsible for validating the values passed to the setOnlineForms method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOnlineForms method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOnlineFormsForArrayConstraintsFromSetOnlineForms(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customRecordTypeOnlineFormsListOnlineFormsItem) {
            // validation for constraint: itemType
            if (!$customRecordTypeOnlineFormsListOnlineFormsItem instanceof \StructType\CustomRecordTypeOnlineForms) {
                $invalidValues[] = is_object($customRecordTypeOnlineFormsListOnlineFormsItem) ? get_class($customRecordTypeOnlineFormsListOnlineFormsItem) : sprintf('%s(%s)', gettype($customRecordTypeOnlineFormsListOnlineFormsItem), var_export($customRecordTypeOnlineFormsListOnlineFormsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The onlineForms property can only contain items of type \StructType\CustomRecordTypeOnlineForms, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set onlineForms value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomRecordTypeOnlineForms[] $onlineForms
     * @return \StructType\CustomRecordTypeOnlineFormsList
     */
    public function setOnlineForms(array $onlineForms = array())
    {
        // validation for constraint: array
        if ('' !== ($onlineFormsArrayErrorMessage = self::validateOnlineFormsForArrayConstraintsFromSetOnlineForms($onlineForms))) {
            throw new \InvalidArgumentException($onlineFormsArrayErrorMessage, __LINE__);
        }
        $this->onlineForms = $onlineForms;
        return $this;
    }
    /**
     * Add item to onlineForms value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomRecordTypeOnlineForms $item
     * @return \StructType\CustomRecordTypeOnlineFormsList
     */
    public function addToOnlineForms(\StructType\CustomRecordTypeOnlineForms $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomRecordTypeOnlineForms) {
            throw new \InvalidArgumentException(sprintf('The onlineForms property can only contain items of type \StructType\CustomRecordTypeOnlineForms, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->onlineForms[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\CustomRecordTypeOnlineFormsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
