<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomRecordTypeTabs StructType
 * @subpackage Structs
 */
class CustomRecordTypeTabs extends AbstractStructBase
{
    /**
     * The tabTitle
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tabTitle;
    /**
     * The tabParent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $tabParent;
    /**
     * The tabTitleLanguageValueList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\LanguageValueList
     */
    public $tabTitleLanguageValueList;
    /**
     * Constructor method for CustomRecordTypeTabs
     * @uses CustomRecordTypeTabs::setTabTitle()
     * @uses CustomRecordTypeTabs::setTabParent()
     * @uses CustomRecordTypeTabs::setTabTitleLanguageValueList()
     * @param string $tabTitle
     * @param \StructType\RecordRef $tabParent
     * @param \StructType\LanguageValueList $tabTitleLanguageValueList
     */
    public function __construct($tabTitle = null, \StructType\RecordRef $tabParent = null, \StructType\LanguageValueList $tabTitleLanguageValueList = null)
    {
        $this
            ->setTabTitle($tabTitle)
            ->setTabParent($tabParent)
            ->setTabTitleLanguageValueList($tabTitleLanguageValueList);
    }
    /**
     * Get tabTitle value
     * @return string|null
     */
    public function getTabTitle()
    {
        return $this->tabTitle;
    }
    /**
     * Set tabTitle value
     * @param string $tabTitle
     * @return \StructType\CustomRecordTypeTabs
     */
    public function setTabTitle($tabTitle = null)
    {
        // validation for constraint: string
        if (!is_null($tabTitle) && !is_string($tabTitle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tabTitle, true), gettype($tabTitle)), __LINE__);
        }
        $this->tabTitle = $tabTitle;
        return $this;
    }
    /**
     * Get tabParent value
     * @return \StructType\RecordRef|null
     */
    public function getTabParent()
    {
        return $this->tabParent;
    }
    /**
     * Set tabParent value
     * @param \StructType\RecordRef $tabParent
     * @return \StructType\CustomRecordTypeTabs
     */
    public function setTabParent(\StructType\RecordRef $tabParent = null)
    {
        $this->tabParent = $tabParent;
        return $this;
    }
    /**
     * Get tabTitleLanguageValueList value
     * @return \StructType\LanguageValueList|null
     */
    public function getTabTitleLanguageValueList()
    {
        return $this->tabTitleLanguageValueList;
    }
    /**
     * Set tabTitleLanguageValueList value
     * @param \StructType\LanguageValueList $tabTitleLanguageValueList
     * @return \StructType\CustomRecordTypeTabs
     */
    public function setTabTitleLanguageValueList(\StructType\LanguageValueList $tabTitleLanguageValueList = null)
    {
        $this->tabTitleLanguageValueList = $tabTitleLanguageValueList;
        return $this;
    }
}
