<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerSubsidiaryRelationshipSearch StructType
 * @subpackage Structs
 */
class CustomerSubsidiaryRelationshipSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSubsidiaryRelationshipSearchBasic
     */
    public $basic;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchBasic
     */
    public $customerJoin;
    /**
     * The subsidiaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubsidiarySearchBasic
     */
    public $subsidiaryJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for CustomerSubsidiaryRelationshipSearch
     * @uses CustomerSubsidiaryRelationshipSearch::setBasic()
     * @uses CustomerSubsidiaryRelationshipSearch::setCustomerJoin()
     * @uses CustomerSubsidiaryRelationshipSearch::setSubsidiaryJoin()
     * @uses CustomerSubsidiaryRelationshipSearch::setCustomSearchJoin()
     * @param \StructType\CustomerSubsidiaryRelationshipSearchBasic $basic
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @param \StructType\SubsidiarySearchBasic $subsidiaryJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\CustomerSubsidiaryRelationshipSearchBasic $basic = null, \StructType\CustomerSearchBasic $customerJoin = null, \StructType\SubsidiarySearchBasic $subsidiaryJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCustomerJoin($customerJoin)
            ->setSubsidiaryJoin($subsidiaryJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\CustomerSubsidiaryRelationshipSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\CustomerSubsidiaryRelationshipSearchBasic $basic
     * @return \StructType\CustomerSubsidiaryRelationshipSearch
     */
    public function setBasic(\StructType\CustomerSubsidiaryRelationshipSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @return \StructType\CustomerSubsidiaryRelationshipSearch
     */
    public function setCustomerJoin(\StructType\CustomerSearchBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get subsidiaryJoin value
     * @return \StructType\SubsidiarySearchBasic|null
     */
    public function getSubsidiaryJoin()
    {
        return $this->subsidiaryJoin;
    }
    /**
     * Set subsidiaryJoin value
     * @param \StructType\SubsidiarySearchBasic $subsidiaryJoin
     * @return \StructType\CustomerSubsidiaryRelationshipSearch
     */
    public function setSubsidiaryJoin(\StructType\SubsidiarySearchBasic $subsidiaryJoin = null)
    {
        $this->subsidiaryJoin = $subsidiaryJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSubsidiaryRelationshipSearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$customerSubsidiaryRelationshipSearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($customerSubsidiaryRelationshipSearchCustomSearchJoinItem) ? get_class($customerSubsidiaryRelationshipSearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($customerSubsidiaryRelationshipSearchCustomSearchJoinItem), var_export($customerSubsidiaryRelationshipSearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\CustomerSubsidiaryRelationshipSearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\CustomerSubsidiaryRelationshipSearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
