<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerSubsidiaryRelationshipSearchRow StructType
 * @subpackage Structs
 */
class CustomerSubsidiaryRelationshipSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSubsidiaryRelationshipSearchRowBasic
     */
    public $basic;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $customerJoin;
    /**
     * The subsidiaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubsidiarySearchRowBasic
     */
    public $subsidiaryJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for CustomerSubsidiaryRelationshipSearchRow
     * @uses CustomerSubsidiaryRelationshipSearchRow::setBasic()
     * @uses CustomerSubsidiaryRelationshipSearchRow::setCustomerJoin()
     * @uses CustomerSubsidiaryRelationshipSearchRow::setSubsidiaryJoin()
     * @uses CustomerSubsidiaryRelationshipSearchRow::setCustomSearchJoin()
     * @param \StructType\CustomerSubsidiaryRelationshipSearchRowBasic $basic
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @param \StructType\SubsidiarySearchRowBasic $subsidiaryJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\CustomerSubsidiaryRelationshipSearchRowBasic $basic = null, \StructType\CustomerSearchRowBasic $customerJoin = null, \StructType\SubsidiarySearchRowBasic $subsidiaryJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCustomerJoin($customerJoin)
            ->setSubsidiaryJoin($subsidiaryJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\CustomerSubsidiaryRelationshipSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\CustomerSubsidiaryRelationshipSearchRowBasic $basic
     * @return \StructType\CustomerSubsidiaryRelationshipSearchRow
     */
    public function setBasic(\StructType\CustomerSubsidiaryRelationshipSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @return \StructType\CustomerSubsidiaryRelationshipSearchRow
     */
    public function setCustomerJoin(\StructType\CustomerSearchRowBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get subsidiaryJoin value
     * @return \StructType\SubsidiarySearchRowBasic|null
     */
    public function getSubsidiaryJoin()
    {
        return $this->subsidiaryJoin;
    }
    /**
     * Set subsidiaryJoin value
     * @param \StructType\SubsidiarySearchRowBasic $subsidiaryJoin
     * @return \StructType\CustomerSubsidiaryRelationshipSearchRow
     */
    public function setSubsidiaryJoin(\StructType\SubsidiarySearchRowBasic $subsidiaryJoin = null)
    {
        $this->subsidiaryJoin = $subsidiaryJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customerSubsidiaryRelationshipSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$customerSubsidiaryRelationshipSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($customerSubsidiaryRelationshipSearchRowCustomSearchJoinItem) ? get_class($customerSubsidiaryRelationshipSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($customerSubsidiaryRelationshipSearchRowCustomSearchJoinItem), var_export($customerSubsidiaryRelationshipSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\CustomerSubsidiaryRelationshipSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\CustomerSubsidiaryRelationshipSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
