<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeleteRequest StructType
 * @subpackage Structs
 */
class DeleteRequest extends AbstractStructBase
{
    /**
     * The baseRef
     * @var \StructType\BaseRef
     */
    public $baseRef;
    /**
     * The deletionReason
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DeletionReason
     */
    public $deletionReason;
    /**
     * Constructor method for DeleteRequest
     * @uses DeleteRequest::setBaseRef()
     * @uses DeleteRequest::setDeletionReason()
     * @param \StructType\BaseRef $baseRef
     * @param \StructType\DeletionReason $deletionReason
     */
    public function __construct(\StructType\BaseRef $baseRef = null, \StructType\DeletionReason $deletionReason = null)
    {
        $this
            ->setBaseRef($baseRef)
            ->setDeletionReason($deletionReason);
    }
    /**
     * Get baseRef value
     * @return \StructType\BaseRef|null
     */
    public function getBaseRef()
    {
        return $this->baseRef;
    }
    /**
     * Set baseRef value
     * @param \StructType\BaseRef $baseRef
     * @return \StructType\DeleteRequest
     */
    public function setBaseRef(\StructType\BaseRef $baseRef = null)
    {
        $this->baseRef = $baseRef;
        return $this;
    }
    /**
     * Get deletionReason value
     * @return \StructType\DeletionReason|null
     */
    public function getDeletionReason()
    {
        return $this->deletionReason;
    }
    /**
     * Set deletionReason value
     * @param \StructType\DeletionReason $deletionReason
     * @return \StructType\DeleteRequest
     */
    public function setDeletionReason(\StructType\DeletionReason $deletionReason = null)
    {
        $this->deletionReason = $deletionReason;
        return $this;
    }
}
