<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeAccruedTimeList StructType
 * @subpackage Structs
 */
class EmployeeAccruedTimeList extends AbstractStructBase
{
    /**
     * The employeeAccruedTime
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EmployeeAccruedTime[]
     */
    public $employeeAccruedTime;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for EmployeeAccruedTimeList
     * @uses EmployeeAccruedTimeList::setEmployeeAccruedTime()
     * @uses EmployeeAccruedTimeList::setReplaceAll()
     * @param \StructType\EmployeeAccruedTime[] $employeeAccruedTime
     * @param bool $replaceAll
     */
    public function __construct(array $employeeAccruedTime = array(), $replaceAll = true)
    {
        $this
            ->setEmployeeAccruedTime($employeeAccruedTime)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get employeeAccruedTime value
     * @return \StructType\EmployeeAccruedTime[]|null
     */
    public function getEmployeeAccruedTime()
    {
        return $this->employeeAccruedTime;
    }
    /**
     * This method is responsible for validating the values passed to the setEmployeeAccruedTime method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEmployeeAccruedTime method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEmployeeAccruedTimeForArrayConstraintsFromSetEmployeeAccruedTime(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $employeeAccruedTimeListEmployeeAccruedTimeItem) {
            // validation for constraint: itemType
            if (!$employeeAccruedTimeListEmployeeAccruedTimeItem instanceof \StructType\EmployeeAccruedTime) {
                $invalidValues[] = is_object($employeeAccruedTimeListEmployeeAccruedTimeItem) ? get_class($employeeAccruedTimeListEmployeeAccruedTimeItem) : sprintf('%s(%s)', gettype($employeeAccruedTimeListEmployeeAccruedTimeItem), var_export($employeeAccruedTimeListEmployeeAccruedTimeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The employeeAccruedTime property can only contain items of type \StructType\EmployeeAccruedTime, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set employeeAccruedTime value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeAccruedTime[] $employeeAccruedTime
     * @return \StructType\EmployeeAccruedTimeList
     */
    public function setEmployeeAccruedTime(array $employeeAccruedTime = array())
    {
        // validation for constraint: array
        if ('' !== ($employeeAccruedTimeArrayErrorMessage = self::validateEmployeeAccruedTimeForArrayConstraintsFromSetEmployeeAccruedTime($employeeAccruedTime))) {
            throw new \InvalidArgumentException($employeeAccruedTimeArrayErrorMessage, __LINE__);
        }
        $this->employeeAccruedTime = $employeeAccruedTime;
        return $this;
    }
    /**
     * Add item to employeeAccruedTime value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeAccruedTime $item
     * @return \StructType\EmployeeAccruedTimeList
     */
    public function addToEmployeeAccruedTime(\StructType\EmployeeAccruedTime $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EmployeeAccruedTime) {
            throw new \InvalidArgumentException(sprintf('The employeeAccruedTime property can only contain items of type \StructType\EmployeeAccruedTime, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->employeeAccruedTime[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\EmployeeAccruedTimeList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
