<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeCompanyContributionList StructType
 * @subpackage Structs
 */
class EmployeeCompanyContributionList extends AbstractStructBase
{
    /**
     * The employeeCompanyContribution
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EmployeeCompanyContribution[]
     */
    public $employeeCompanyContribution;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for EmployeeCompanyContributionList
     * @uses EmployeeCompanyContributionList::setEmployeeCompanyContribution()
     * @uses EmployeeCompanyContributionList::setReplaceAll()
     * @param \StructType\EmployeeCompanyContribution[] $employeeCompanyContribution
     * @param bool $replaceAll
     */
    public function __construct(array $employeeCompanyContribution = array(), $replaceAll = true)
    {
        $this
            ->setEmployeeCompanyContribution($employeeCompanyContribution)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get employeeCompanyContribution value
     * @return \StructType\EmployeeCompanyContribution[]|null
     */
    public function getEmployeeCompanyContribution()
    {
        return $this->employeeCompanyContribution;
    }
    /**
     * This method is responsible for validating the values passed to the setEmployeeCompanyContribution method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEmployeeCompanyContribution method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEmployeeCompanyContributionForArrayConstraintsFromSetEmployeeCompanyContribution(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $employeeCompanyContributionListEmployeeCompanyContributionItem) {
            // validation for constraint: itemType
            if (!$employeeCompanyContributionListEmployeeCompanyContributionItem instanceof \StructType\EmployeeCompanyContribution) {
                $invalidValues[] = is_object($employeeCompanyContributionListEmployeeCompanyContributionItem) ? get_class($employeeCompanyContributionListEmployeeCompanyContributionItem) : sprintf('%s(%s)', gettype($employeeCompanyContributionListEmployeeCompanyContributionItem), var_export($employeeCompanyContributionListEmployeeCompanyContributionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The employeeCompanyContribution property can only contain items of type \StructType\EmployeeCompanyContribution, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set employeeCompanyContribution value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeCompanyContribution[] $employeeCompanyContribution
     * @return \StructType\EmployeeCompanyContributionList
     */
    public function setEmployeeCompanyContribution(array $employeeCompanyContribution = array())
    {
        // validation for constraint: array
        if ('' !== ($employeeCompanyContributionArrayErrorMessage = self::validateEmployeeCompanyContributionForArrayConstraintsFromSetEmployeeCompanyContribution($employeeCompanyContribution))) {
            throw new \InvalidArgumentException($employeeCompanyContributionArrayErrorMessage, __LINE__);
        }
        $this->employeeCompanyContribution = $employeeCompanyContribution;
        return $this;
    }
    /**
     * Add item to employeeCompanyContribution value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeCompanyContribution $item
     * @return \StructType\EmployeeCompanyContributionList
     */
    public function addToEmployeeCompanyContribution(\StructType\EmployeeCompanyContribution $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EmployeeCompanyContribution) {
            throw new \InvalidArgumentException(sprintf('The employeeCompanyContribution property can only contain items of type \StructType\EmployeeCompanyContribution, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->employeeCompanyContribution[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\EmployeeCompanyContributionList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
