<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeHcmPositionList StructType
 * @subpackage Structs
 */
class EmployeeHcmPositionList extends AbstractStructBase
{
    /**
     * The employeeHcmPosition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EmployeeHcmPosition[]
     */
    public $employeeHcmPosition;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for EmployeeHcmPositionList
     * @uses EmployeeHcmPositionList::setEmployeeHcmPosition()
     * @uses EmployeeHcmPositionList::setReplaceAll()
     * @param \StructType\EmployeeHcmPosition[] $employeeHcmPosition
     * @param bool $replaceAll
     */
    public function __construct(array $employeeHcmPosition = array(), $replaceAll = true)
    {
        $this
            ->setEmployeeHcmPosition($employeeHcmPosition)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get employeeHcmPosition value
     * @return \StructType\EmployeeHcmPosition[]|null
     */
    public function getEmployeeHcmPosition()
    {
        return $this->employeeHcmPosition;
    }
    /**
     * This method is responsible for validating the values passed to the setEmployeeHcmPosition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEmployeeHcmPosition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEmployeeHcmPositionForArrayConstraintsFromSetEmployeeHcmPosition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $employeeHcmPositionListEmployeeHcmPositionItem) {
            // validation for constraint: itemType
            if (!$employeeHcmPositionListEmployeeHcmPositionItem instanceof \StructType\EmployeeHcmPosition) {
                $invalidValues[] = is_object($employeeHcmPositionListEmployeeHcmPositionItem) ? get_class($employeeHcmPositionListEmployeeHcmPositionItem) : sprintf('%s(%s)', gettype($employeeHcmPositionListEmployeeHcmPositionItem), var_export($employeeHcmPositionListEmployeeHcmPositionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The employeeHcmPosition property can only contain items of type \StructType\EmployeeHcmPosition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set employeeHcmPosition value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeHcmPosition[] $employeeHcmPosition
     * @return \StructType\EmployeeHcmPositionList
     */
    public function setEmployeeHcmPosition(array $employeeHcmPosition = array())
    {
        // validation for constraint: array
        if ('' !== ($employeeHcmPositionArrayErrorMessage = self::validateEmployeeHcmPositionForArrayConstraintsFromSetEmployeeHcmPosition($employeeHcmPosition))) {
            throw new \InvalidArgumentException($employeeHcmPositionArrayErrorMessage, __LINE__);
        }
        $this->employeeHcmPosition = $employeeHcmPosition;
        return $this;
    }
    /**
     * Add item to employeeHcmPosition value
     * @throws \InvalidArgumentException
     * @param \StructType\EmployeeHcmPosition $item
     * @return \StructType\EmployeeHcmPositionList
     */
    public function addToEmployeeHcmPosition(\StructType\EmployeeHcmPosition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EmployeeHcmPosition) {
            throw new \InvalidArgumentException(sprintf('The employeeHcmPosition property can only contain items of type \StructType\EmployeeHcmPosition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->employeeHcmPosition[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\EmployeeHcmPositionList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
