<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeSearch StructType
 * @subpackage Structs
 */
class EmployeeSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $basic;
    /**
     * The campaignResponseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchBasic
     */
    public $campaignResponseJoin;
    /**
     * The chargeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ChargeSearchBasic
     */
    public $chargeJoin;
    /**
     * The departmentJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DepartmentSearchBasic
     */
    public $departmentJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchBasic
     */
    public $fileJoin;
    /**
     * The hcmJobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\HcmJobSearchBasic
     */
    public $hcmJobJoin;
    /**
     * The locationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\LocationSearchBasic
     */
    public $locationJoin;
    /**
     * The managedJobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchBasic
     */
    public $managedJobJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $messagesJoin;
    /**
     * The messagesFromJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $messagesFromJoin;
    /**
     * The messagesToJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $messagesToJoin;
    /**
     * The resourceAllocationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ResourceAllocationSearchBasic
     */
    public $resourceAllocationJoin;
    /**
     * The subsidiaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubsidiarySearchBasic
     */
    public $subsidiaryJoin;
    /**
     * The timeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TimeBillSearchBasic
     */
    public $timeJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for EmployeeSearch
     * @uses EmployeeSearch::setBasic()
     * @uses EmployeeSearch::setCampaignResponseJoin()
     * @uses EmployeeSearch::setChargeJoin()
     * @uses EmployeeSearch::setDepartmentJoin()
     * @uses EmployeeSearch::setFileJoin()
     * @uses EmployeeSearch::setHcmJobJoin()
     * @uses EmployeeSearch::setLocationJoin()
     * @uses EmployeeSearch::setManagedJobJoin()
     * @uses EmployeeSearch::setMessagesJoin()
     * @uses EmployeeSearch::setMessagesFromJoin()
     * @uses EmployeeSearch::setMessagesToJoin()
     * @uses EmployeeSearch::setResourceAllocationJoin()
     * @uses EmployeeSearch::setSubsidiaryJoin()
     * @uses EmployeeSearch::setTimeJoin()
     * @uses EmployeeSearch::setTransactionJoin()
     * @uses EmployeeSearch::setUserJoin()
     * @uses EmployeeSearch::setUserNotesJoin()
     * @uses EmployeeSearch::setCustomSearchJoin()
     * @param \StructType\EmployeeSearchBasic $basic
     * @param \StructType\CampaignSearchBasic $campaignResponseJoin
     * @param \StructType\ChargeSearchBasic $chargeJoin
     * @param \StructType\DepartmentSearchBasic $departmentJoin
     * @param \StructType\FileSearchBasic $fileJoin
     * @param \StructType\HcmJobSearchBasic $hcmJobJoin
     * @param \StructType\LocationSearchBasic $locationJoin
     * @param \StructType\JobSearchBasic $managedJobJoin
     * @param \StructType\MessageSearchBasic $messagesJoin
     * @param \StructType\MessageSearchBasic $messagesFromJoin
     * @param \StructType\MessageSearchBasic $messagesToJoin
     * @param \StructType\ResourceAllocationSearchBasic $resourceAllocationJoin
     * @param \StructType\SubsidiarySearchBasic $subsidiaryJoin
     * @param \StructType\TimeBillSearchBasic $timeJoin
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @param \StructType\NoteSearchBasic $userNotesJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\EmployeeSearchBasic $basic = null, \StructType\CampaignSearchBasic $campaignResponseJoin = null, \StructType\ChargeSearchBasic $chargeJoin = null, \StructType\DepartmentSearchBasic $departmentJoin = null, \StructType\FileSearchBasic $fileJoin = null, \StructType\HcmJobSearchBasic $hcmJobJoin = null, \StructType\LocationSearchBasic $locationJoin = null, \StructType\JobSearchBasic $managedJobJoin = null, \StructType\MessageSearchBasic $messagesJoin = null, \StructType\MessageSearchBasic $messagesFromJoin = null, \StructType\MessageSearchBasic $messagesToJoin = null, \StructType\ResourceAllocationSearchBasic $resourceAllocationJoin = null, \StructType\SubsidiarySearchBasic $subsidiaryJoin = null, \StructType\TimeBillSearchBasic $timeJoin = null, \StructType\TransactionSearchBasic $transactionJoin = null, \StructType\EmployeeSearchBasic $userJoin = null, \StructType\NoteSearchBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCampaignResponseJoin($campaignResponseJoin)
            ->setChargeJoin($chargeJoin)
            ->setDepartmentJoin($departmentJoin)
            ->setFileJoin($fileJoin)
            ->setHcmJobJoin($hcmJobJoin)
            ->setLocationJoin($locationJoin)
            ->setManagedJobJoin($managedJobJoin)
            ->setMessagesJoin($messagesJoin)
            ->setMessagesFromJoin($messagesFromJoin)
            ->setMessagesToJoin($messagesToJoin)
            ->setResourceAllocationJoin($resourceAllocationJoin)
            ->setSubsidiaryJoin($subsidiaryJoin)
            ->setTimeJoin($timeJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\EmployeeSearchBasic $basic
     * @return \StructType\EmployeeSearch
     */
    public function setBasic(\StructType\EmployeeSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get campaignResponseJoin value
     * @return \StructType\CampaignSearchBasic|null
     */
    public function getCampaignResponseJoin()
    {
        return $this->campaignResponseJoin;
    }
    /**
     * Set campaignResponseJoin value
     * @param \StructType\CampaignSearchBasic $campaignResponseJoin
     * @return \StructType\EmployeeSearch
     */
    public function setCampaignResponseJoin(\StructType\CampaignSearchBasic $campaignResponseJoin = null)
    {
        $this->campaignResponseJoin = $campaignResponseJoin;
        return $this;
    }
    /**
     * Get chargeJoin value
     * @return \StructType\ChargeSearchBasic|null
     */
    public function getChargeJoin()
    {
        return $this->chargeJoin;
    }
    /**
     * Set chargeJoin value
     * @param \StructType\ChargeSearchBasic $chargeJoin
     * @return \StructType\EmployeeSearch
     */
    public function setChargeJoin(\StructType\ChargeSearchBasic $chargeJoin = null)
    {
        $this->chargeJoin = $chargeJoin;
        return $this;
    }
    /**
     * Get departmentJoin value
     * @return \StructType\DepartmentSearchBasic|null
     */
    public function getDepartmentJoin()
    {
        return $this->departmentJoin;
    }
    /**
     * Set departmentJoin value
     * @param \StructType\DepartmentSearchBasic $departmentJoin
     * @return \StructType\EmployeeSearch
     */
    public function setDepartmentJoin(\StructType\DepartmentSearchBasic $departmentJoin = null)
    {
        $this->departmentJoin = $departmentJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchBasic $fileJoin
     * @return \StructType\EmployeeSearch
     */
    public function setFileJoin(\StructType\FileSearchBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get hcmJobJoin value
     * @return \StructType\HcmJobSearchBasic|null
     */
    public function getHcmJobJoin()
    {
        return $this->hcmJobJoin;
    }
    /**
     * Set hcmJobJoin value
     * @param \StructType\HcmJobSearchBasic $hcmJobJoin
     * @return \StructType\EmployeeSearch
     */
    public function setHcmJobJoin(\StructType\HcmJobSearchBasic $hcmJobJoin = null)
    {
        $this->hcmJobJoin = $hcmJobJoin;
        return $this;
    }
    /**
     * Get locationJoin value
     * @return \StructType\LocationSearchBasic|null
     */
    public function getLocationJoin()
    {
        return $this->locationJoin;
    }
    /**
     * Set locationJoin value
     * @param \StructType\LocationSearchBasic $locationJoin
     * @return \StructType\EmployeeSearch
     */
    public function setLocationJoin(\StructType\LocationSearchBasic $locationJoin = null)
    {
        $this->locationJoin = $locationJoin;
        return $this;
    }
    /**
     * Get managedJobJoin value
     * @return \StructType\JobSearchBasic|null
     */
    public function getManagedJobJoin()
    {
        return $this->managedJobJoin;
    }
    /**
     * Set managedJobJoin value
     * @param \StructType\JobSearchBasic $managedJobJoin
     * @return \StructType\EmployeeSearch
     */
    public function setManagedJobJoin(\StructType\JobSearchBasic $managedJobJoin = null)
    {
        $this->managedJobJoin = $managedJobJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchBasic $messagesJoin
     * @return \StructType\EmployeeSearch
     */
    public function setMessagesJoin(\StructType\MessageSearchBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get messagesFromJoin value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getMessagesFromJoin()
    {
        return $this->messagesFromJoin;
    }
    /**
     * Set messagesFromJoin value
     * @param \StructType\MessageSearchBasic $messagesFromJoin
     * @return \StructType\EmployeeSearch
     */
    public function setMessagesFromJoin(\StructType\MessageSearchBasic $messagesFromJoin = null)
    {
        $this->messagesFromJoin = $messagesFromJoin;
        return $this;
    }
    /**
     * Get messagesToJoin value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getMessagesToJoin()
    {
        return $this->messagesToJoin;
    }
    /**
     * Set messagesToJoin value
     * @param \StructType\MessageSearchBasic $messagesToJoin
     * @return \StructType\EmployeeSearch
     */
    public function setMessagesToJoin(\StructType\MessageSearchBasic $messagesToJoin = null)
    {
        $this->messagesToJoin = $messagesToJoin;
        return $this;
    }
    /**
     * Get resourceAllocationJoin value
     * @return \StructType\ResourceAllocationSearchBasic|null
     */
    public function getResourceAllocationJoin()
    {
        return $this->resourceAllocationJoin;
    }
    /**
     * Set resourceAllocationJoin value
     * @param \StructType\ResourceAllocationSearchBasic $resourceAllocationJoin
     * @return \StructType\EmployeeSearch
     */
    public function setResourceAllocationJoin(\StructType\ResourceAllocationSearchBasic $resourceAllocationJoin = null)
    {
        $this->resourceAllocationJoin = $resourceAllocationJoin;
        return $this;
    }
    /**
     * Get subsidiaryJoin value
     * @return \StructType\SubsidiarySearchBasic|null
     */
    public function getSubsidiaryJoin()
    {
        return $this->subsidiaryJoin;
    }
    /**
     * Set subsidiaryJoin value
     * @param \StructType\SubsidiarySearchBasic $subsidiaryJoin
     * @return \StructType\EmployeeSearch
     */
    public function setSubsidiaryJoin(\StructType\SubsidiarySearchBasic $subsidiaryJoin = null)
    {
        $this->subsidiaryJoin = $subsidiaryJoin;
        return $this;
    }
    /**
     * Get timeJoin value
     * @return \StructType\TimeBillSearchBasic|null
     */
    public function getTimeJoin()
    {
        return $this->timeJoin;
    }
    /**
     * Set timeJoin value
     * @param \StructType\TimeBillSearchBasic $timeJoin
     * @return \StructType\EmployeeSearch
     */
    public function setTimeJoin(\StructType\TimeBillSearchBasic $timeJoin = null)
    {
        $this->timeJoin = $timeJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @return \StructType\EmployeeSearch
     */
    public function setTransactionJoin(\StructType\TransactionSearchBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\EmployeeSearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchBasic $userNotesJoin
     * @return \StructType\EmployeeSearch
     */
    public function setUserNotesJoin(\StructType\NoteSearchBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $employeeSearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$employeeSearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($employeeSearchCustomSearchJoinItem) ? get_class($employeeSearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($employeeSearchCustomSearchJoinItem), var_export($employeeSearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\EmployeeSearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\EmployeeSearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
