<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InboundShipmentLandedCostList StructType
 * @subpackage Structs
 */
class InboundShipmentLandedCostList extends AbstractStructBase
{
    /**
     * The inboundShipmentLandedCost
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InboundShipmentLandedCost[]
     */
    public $inboundShipmentLandedCost;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for InboundShipmentLandedCostList
     * @uses InboundShipmentLandedCostList::setInboundShipmentLandedCost()
     * @uses InboundShipmentLandedCostList::setReplaceAll()
     * @param \StructType\InboundShipmentLandedCost[] $inboundShipmentLandedCost
     * @param bool $replaceAll
     */
    public function __construct(array $inboundShipmentLandedCost = array(), $replaceAll = true)
    {
        $this
            ->setInboundShipmentLandedCost($inboundShipmentLandedCost)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get inboundShipmentLandedCost value
     * @return \StructType\InboundShipmentLandedCost[]|null
     */
    public function getInboundShipmentLandedCost()
    {
        return $this->inboundShipmentLandedCost;
    }
    /**
     * This method is responsible for validating the values passed to the setInboundShipmentLandedCost method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInboundShipmentLandedCost method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInboundShipmentLandedCostForArrayConstraintsFromSetInboundShipmentLandedCost(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $inboundShipmentLandedCostListInboundShipmentLandedCostItem) {
            // validation for constraint: itemType
            if (!$inboundShipmentLandedCostListInboundShipmentLandedCostItem instanceof \StructType\InboundShipmentLandedCost) {
                $invalidValues[] = is_object($inboundShipmentLandedCostListInboundShipmentLandedCostItem) ? get_class($inboundShipmentLandedCostListInboundShipmentLandedCostItem) : sprintf('%s(%s)', gettype($inboundShipmentLandedCostListInboundShipmentLandedCostItem), var_export($inboundShipmentLandedCostListInboundShipmentLandedCostItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The inboundShipmentLandedCost property can only contain items of type \StructType\InboundShipmentLandedCost, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set inboundShipmentLandedCost value
     * @throws \InvalidArgumentException
     * @param \StructType\InboundShipmentLandedCost[] $inboundShipmentLandedCost
     * @return \StructType\InboundShipmentLandedCostList
     */
    public function setInboundShipmentLandedCost(array $inboundShipmentLandedCost = array())
    {
        // validation for constraint: array
        if ('' !== ($inboundShipmentLandedCostArrayErrorMessage = self::validateInboundShipmentLandedCostForArrayConstraintsFromSetInboundShipmentLandedCost($inboundShipmentLandedCost))) {
            throw new \InvalidArgumentException($inboundShipmentLandedCostArrayErrorMessage, __LINE__);
        }
        $this->inboundShipmentLandedCost = $inboundShipmentLandedCost;
        return $this;
    }
    /**
     * Add item to inboundShipmentLandedCost value
     * @throws \InvalidArgumentException
     * @param \StructType\InboundShipmentLandedCost $item
     * @return \StructType\InboundShipmentLandedCostList
     */
    public function addToInboundShipmentLandedCost(\StructType\InboundShipmentLandedCost $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InboundShipmentLandedCost) {
            throw new \InvalidArgumentException(sprintf('The inboundShipmentLandedCost property can only contain items of type \StructType\InboundShipmentLandedCost, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->inboundShipmentLandedCost[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\InboundShipmentLandedCostList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
