<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InterCompanyJournalEntryAccountingBookDetailList
 * StructType
 * @subpackage Structs
 */
class InterCompanyJournalEntryAccountingBookDetailList extends AbstractStructBase
{
    /**
     * The interCompanyJournalEntryAccountingBookDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InterCompanyJournalEntryAccountingBookDetail[]
     */
    public $interCompanyJournalEntryAccountingBookDetail;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for InterCompanyJournalEntryAccountingBookDetailList
     * @uses InterCompanyJournalEntryAccountingBookDetailList::setInterCompanyJournalEntryAccountingBookDetail()
     * @uses InterCompanyJournalEntryAccountingBookDetailList::setReplaceAll()
     * @param \StructType\InterCompanyJournalEntryAccountingBookDetail[] $interCompanyJournalEntryAccountingBookDetail
     * @param bool $replaceAll
     */
    public function __construct(array $interCompanyJournalEntryAccountingBookDetail = array(), $replaceAll = true)
    {
        $this
            ->setInterCompanyJournalEntryAccountingBookDetail($interCompanyJournalEntryAccountingBookDetail)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get interCompanyJournalEntryAccountingBookDetail value
     * @return \StructType\InterCompanyJournalEntryAccountingBookDetail[]|null
     */
    public function getInterCompanyJournalEntryAccountingBookDetail()
    {
        return $this->interCompanyJournalEntryAccountingBookDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setInterCompanyJournalEntryAccountingBookDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterCompanyJournalEntryAccountingBookDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterCompanyJournalEntryAccountingBookDetailForArrayConstraintsFromSetInterCompanyJournalEntryAccountingBookDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $interCompanyJournalEntryAccountingBookDetailListInterCompanyJournalEntryAccountingBookDetailItem) {
            // validation for constraint: itemType
            if (!$interCompanyJournalEntryAccountingBookDetailListInterCompanyJournalEntryAccountingBookDetailItem instanceof \StructType\InterCompanyJournalEntryAccountingBookDetail) {
                $invalidValues[] = is_object($interCompanyJournalEntryAccountingBookDetailListInterCompanyJournalEntryAccountingBookDetailItem) ? get_class($interCompanyJournalEntryAccountingBookDetailListInterCompanyJournalEntryAccountingBookDetailItem) : sprintf('%s(%s)', gettype($interCompanyJournalEntryAccountingBookDetailListInterCompanyJournalEntryAccountingBookDetailItem), var_export($interCompanyJournalEntryAccountingBookDetailListInterCompanyJournalEntryAccountingBookDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The interCompanyJournalEntryAccountingBookDetail property can only contain items of type \StructType\InterCompanyJournalEntryAccountingBookDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set interCompanyJournalEntryAccountingBookDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\InterCompanyJournalEntryAccountingBookDetail[] $interCompanyJournalEntryAccountingBookDetail
     * @return \StructType\InterCompanyJournalEntryAccountingBookDetailList
     */
    public function setInterCompanyJournalEntryAccountingBookDetail(array $interCompanyJournalEntryAccountingBookDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($interCompanyJournalEntryAccountingBookDetailArrayErrorMessage = self::validateInterCompanyJournalEntryAccountingBookDetailForArrayConstraintsFromSetInterCompanyJournalEntryAccountingBookDetail($interCompanyJournalEntryAccountingBookDetail))) {
            throw new \InvalidArgumentException($interCompanyJournalEntryAccountingBookDetailArrayErrorMessage, __LINE__);
        }
        $this->interCompanyJournalEntryAccountingBookDetail = $interCompanyJournalEntryAccountingBookDetail;
        return $this;
    }
    /**
     * Add item to interCompanyJournalEntryAccountingBookDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\InterCompanyJournalEntryAccountingBookDetail $item
     * @return \StructType\InterCompanyJournalEntryAccountingBookDetailList
     */
    public function addToInterCompanyJournalEntryAccountingBookDetail(\StructType\InterCompanyJournalEntryAccountingBookDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterCompanyJournalEntryAccountingBookDetail) {
            throw new \InvalidArgumentException(sprintf('The interCompanyJournalEntryAccountingBookDetail property can only contain items of type \StructType\InterCompanyJournalEntryAccountingBookDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->interCompanyJournalEntryAccountingBookDetail[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\InterCompanyJournalEntryAccountingBookDetailList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
