<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InventoryAdjustmentInventoryList StructType
 * @subpackage Structs
 */
class InventoryAdjustmentInventoryList extends AbstractStructBase
{
    /**
     * The inventory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InventoryAdjustmentInventory[]
     */
    public $inventory;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for InventoryAdjustmentInventoryList
     * @uses InventoryAdjustmentInventoryList::setInventory()
     * @uses InventoryAdjustmentInventoryList::setReplaceAll()
     * @param \StructType\InventoryAdjustmentInventory[] $inventory
     * @param bool $replaceAll
     */
    public function __construct(array $inventory = array(), $replaceAll = true)
    {
        $this
            ->setInventory($inventory)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get inventory value
     * @return \StructType\InventoryAdjustmentInventory[]|null
     */
    public function getInventory()
    {
        return $this->inventory;
    }
    /**
     * This method is responsible for validating the values passed to the setInventory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInventory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInventoryForArrayConstraintsFromSetInventory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $inventoryAdjustmentInventoryListInventoryItem) {
            // validation for constraint: itemType
            if (!$inventoryAdjustmentInventoryListInventoryItem instanceof \StructType\InventoryAdjustmentInventory) {
                $invalidValues[] = is_object($inventoryAdjustmentInventoryListInventoryItem) ? get_class($inventoryAdjustmentInventoryListInventoryItem) : sprintf('%s(%s)', gettype($inventoryAdjustmentInventoryListInventoryItem), var_export($inventoryAdjustmentInventoryListInventoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The inventory property can only contain items of type \StructType\InventoryAdjustmentInventory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set inventory value
     * @throws \InvalidArgumentException
     * @param \StructType\InventoryAdjustmentInventory[] $inventory
     * @return \StructType\InventoryAdjustmentInventoryList
     */
    public function setInventory(array $inventory = array())
    {
        // validation for constraint: array
        if ('' !== ($inventoryArrayErrorMessage = self::validateInventoryForArrayConstraintsFromSetInventory($inventory))) {
            throw new \InvalidArgumentException($inventoryArrayErrorMessage, __LINE__);
        }
        $this->inventory = $inventory;
        return $this;
    }
    /**
     * Add item to inventory value
     * @throws \InvalidArgumentException
     * @param \StructType\InventoryAdjustmentInventory $item
     * @return \StructType\InventoryAdjustmentInventoryList
     */
    public function addToInventory(\StructType\InventoryAdjustmentInventory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InventoryAdjustmentInventory) {
            throw new \InvalidArgumentException(sprintf('The inventory property can only contain items of type \StructType\InventoryAdjustmentInventory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->inventory[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\InventoryAdjustmentInventoryList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
