<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItemDemandPlanSearchRow StructType
 * @subpackage Structs
 */
class ItemDemandPlanSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemDemandPlanSearchRowBasic
     */
    public $basic;
    /**
     * The itemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $itemJoin;
    /**
     * The lastAlternateSourceItemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $lastAlternateSourceItemJoin;
    /**
     * The locationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\LocationSearchRowBasic
     */
    public $locationJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for ItemDemandPlanSearchRow
     * @uses ItemDemandPlanSearchRow::setBasic()
     * @uses ItemDemandPlanSearchRow::setItemJoin()
     * @uses ItemDemandPlanSearchRow::setLastAlternateSourceItemJoin()
     * @uses ItemDemandPlanSearchRow::setLocationJoin()
     * @uses ItemDemandPlanSearchRow::setUserJoin()
     * @uses ItemDemandPlanSearchRow::setCustomSearchJoin()
     * @param \StructType\ItemDemandPlanSearchRowBasic $basic
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @param \StructType\ItemSearchRowBasic $lastAlternateSourceItemJoin
     * @param \StructType\LocationSearchRowBasic $locationJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\ItemDemandPlanSearchRowBasic $basic = null, \StructType\ItemSearchRowBasic $itemJoin = null, \StructType\ItemSearchRowBasic $lastAlternateSourceItemJoin = null, \StructType\LocationSearchRowBasic $locationJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setItemJoin($itemJoin)
            ->setLastAlternateSourceItemJoin($lastAlternateSourceItemJoin)
            ->setLocationJoin($locationJoin)
            ->setUserJoin($userJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\ItemDemandPlanSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\ItemDemandPlanSearchRowBasic $basic
     * @return \StructType\ItemDemandPlanSearchRow
     */
    public function setBasic(\StructType\ItemDemandPlanSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get itemJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getItemJoin()
    {
        return $this->itemJoin;
    }
    /**
     * Set itemJoin value
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @return \StructType\ItemDemandPlanSearchRow
     */
    public function setItemJoin(\StructType\ItemSearchRowBasic $itemJoin = null)
    {
        $this->itemJoin = $itemJoin;
        return $this;
    }
    /**
     * Get lastAlternateSourceItemJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getLastAlternateSourceItemJoin()
    {
        return $this->lastAlternateSourceItemJoin;
    }
    /**
     * Set lastAlternateSourceItemJoin value
     * @param \StructType\ItemSearchRowBasic $lastAlternateSourceItemJoin
     * @return \StructType\ItemDemandPlanSearchRow
     */
    public function setLastAlternateSourceItemJoin(\StructType\ItemSearchRowBasic $lastAlternateSourceItemJoin = null)
    {
        $this->lastAlternateSourceItemJoin = $lastAlternateSourceItemJoin;
        return $this;
    }
    /**
     * Get locationJoin value
     * @return \StructType\LocationSearchRowBasic|null
     */
    public function getLocationJoin()
    {
        return $this->locationJoin;
    }
    /**
     * Set locationJoin value
     * @param \StructType\LocationSearchRowBasic $locationJoin
     * @return \StructType\ItemDemandPlanSearchRow
     */
    public function setLocationJoin(\StructType\LocationSearchRowBasic $locationJoin = null)
    {
        $this->locationJoin = $locationJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\ItemDemandPlanSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $itemDemandPlanSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$itemDemandPlanSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($itemDemandPlanSearchRowCustomSearchJoinItem) ? get_class($itemDemandPlanSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($itemDemandPlanSearchRowCustomSearchJoinItem), var_export($itemDemandPlanSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\ItemDemandPlanSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\ItemDemandPlanSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
