<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItemFulfillmentPackageUspsList StructType
 * @subpackage Structs
 */
class ItemFulfillmentPackageUspsList extends AbstractStructBase
{
    /**
     * The packageUsps
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ItemFulfillmentPackageUsps[]
     */
    public $packageUsps;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for ItemFulfillmentPackageUspsList
     * @uses ItemFulfillmentPackageUspsList::setPackageUsps()
     * @uses ItemFulfillmentPackageUspsList::setReplaceAll()
     * @param \StructType\ItemFulfillmentPackageUsps[] $packageUsps
     * @param bool $replaceAll
     */
    public function __construct(array $packageUsps = array(), $replaceAll = true)
    {
        $this
            ->setPackageUsps($packageUsps)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get packageUsps value
     * @return \StructType\ItemFulfillmentPackageUsps[]|null
     */
    public function getPackageUsps()
    {
        return $this->packageUsps;
    }
    /**
     * This method is responsible for validating the values passed to the setPackageUsps method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackageUsps method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageUspsForArrayConstraintsFromSetPackageUsps(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $itemFulfillmentPackageUspsListPackageUspsItem) {
            // validation for constraint: itemType
            if (!$itemFulfillmentPackageUspsListPackageUspsItem instanceof \StructType\ItemFulfillmentPackageUsps) {
                $invalidValues[] = is_object($itemFulfillmentPackageUspsListPackageUspsItem) ? get_class($itemFulfillmentPackageUspsListPackageUspsItem) : sprintf('%s(%s)', gettype($itemFulfillmentPackageUspsListPackageUspsItem), var_export($itemFulfillmentPackageUspsListPackageUspsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The packageUsps property can only contain items of type \StructType\ItemFulfillmentPackageUsps, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set packageUsps value
     * @throws \InvalidArgumentException
     * @param \StructType\ItemFulfillmentPackageUsps[] $packageUsps
     * @return \StructType\ItemFulfillmentPackageUspsList
     */
    public function setPackageUsps(array $packageUsps = array())
    {
        // validation for constraint: array
        if ('' !== ($packageUspsArrayErrorMessage = self::validatePackageUspsForArrayConstraintsFromSetPackageUsps($packageUsps))) {
            throw new \InvalidArgumentException($packageUspsArrayErrorMessage, __LINE__);
        }
        $this->packageUsps = $packageUsps;
        return $this;
    }
    /**
     * Add item to packageUsps value
     * @throws \InvalidArgumentException
     * @param \StructType\ItemFulfillmentPackageUsps $item
     * @return \StructType\ItemFulfillmentPackageUspsList
     */
    public function addToPackageUsps(\StructType\ItemFulfillmentPackageUsps $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItemFulfillmentPackageUsps) {
            throw new \InvalidArgumentException(sprintf('The packageUsps property can only contain items of type \StructType\ItemFulfillmentPackageUsps, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->packageUsps[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\ItemFulfillmentPackageUspsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
