<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JobPercentCompleteOverrideList StructType
 * @subpackage Structs
 */
class JobPercentCompleteOverrideList extends AbstractStructBase
{
    /**
     * The jobPercentCompleteOverride
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JobPercentCompleteOverride[]
     */
    public $jobPercentCompleteOverride;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for JobPercentCompleteOverrideList
     * @uses JobPercentCompleteOverrideList::setJobPercentCompleteOverride()
     * @uses JobPercentCompleteOverrideList::setReplaceAll()
     * @param \StructType\JobPercentCompleteOverride[] $jobPercentCompleteOverride
     * @param bool $replaceAll
     */
    public function __construct(array $jobPercentCompleteOverride = array(), $replaceAll = true)
    {
        $this
            ->setJobPercentCompleteOverride($jobPercentCompleteOverride)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get jobPercentCompleteOverride value
     * @return \StructType\JobPercentCompleteOverride[]|null
     */
    public function getJobPercentCompleteOverride()
    {
        return $this->jobPercentCompleteOverride;
    }
    /**
     * This method is responsible for validating the values passed to the setJobPercentCompleteOverride method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJobPercentCompleteOverride method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJobPercentCompleteOverrideForArrayConstraintsFromSetJobPercentCompleteOverride(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $jobPercentCompleteOverrideListJobPercentCompleteOverrideItem) {
            // validation for constraint: itemType
            if (!$jobPercentCompleteOverrideListJobPercentCompleteOverrideItem instanceof \StructType\JobPercentCompleteOverride) {
                $invalidValues[] = is_object($jobPercentCompleteOverrideListJobPercentCompleteOverrideItem) ? get_class($jobPercentCompleteOverrideListJobPercentCompleteOverrideItem) : sprintf('%s(%s)', gettype($jobPercentCompleteOverrideListJobPercentCompleteOverrideItem), var_export($jobPercentCompleteOverrideListJobPercentCompleteOverrideItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The jobPercentCompleteOverride property can only contain items of type \StructType\JobPercentCompleteOverride, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set jobPercentCompleteOverride value
     * @throws \InvalidArgumentException
     * @param \StructType\JobPercentCompleteOverride[] $jobPercentCompleteOverride
     * @return \StructType\JobPercentCompleteOverrideList
     */
    public function setJobPercentCompleteOverride(array $jobPercentCompleteOverride = array())
    {
        // validation for constraint: array
        if ('' !== ($jobPercentCompleteOverrideArrayErrorMessage = self::validateJobPercentCompleteOverrideForArrayConstraintsFromSetJobPercentCompleteOverride($jobPercentCompleteOverride))) {
            throw new \InvalidArgumentException($jobPercentCompleteOverrideArrayErrorMessage, __LINE__);
        }
        $this->jobPercentCompleteOverride = $jobPercentCompleteOverride;
        return $this;
    }
    /**
     * Add item to jobPercentCompleteOverride value
     * @throws \InvalidArgumentException
     * @param \StructType\JobPercentCompleteOverride $item
     * @return \StructType\JobPercentCompleteOverrideList
     */
    public function addToJobPercentCompleteOverride(\StructType\JobPercentCompleteOverride $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JobPercentCompleteOverride) {
            throw new \InvalidArgumentException(sprintf('The jobPercentCompleteOverride property can only contain items of type \StructType\JobPercentCompleteOverride, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->jobPercentCompleteOverride[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\JobPercentCompleteOverrideList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
