<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LotNumberedAssemblyItemBillOfMaterialsList StructType
 * @subpackage Structs
 */
class LotNumberedAssemblyItemBillOfMaterialsList extends AbstractStructBase
{
    /**
     * The lotNumberedAssemblyItemBillOfMaterials
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LotNumberedAssemblyItemBillOfMaterials[]
     */
    public $lotNumberedAssemblyItemBillOfMaterials;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for LotNumberedAssemblyItemBillOfMaterialsList
     * @uses LotNumberedAssemblyItemBillOfMaterialsList::setLotNumberedAssemblyItemBillOfMaterials()
     * @uses LotNumberedAssemblyItemBillOfMaterialsList::setReplaceAll()
     * @param \StructType\LotNumberedAssemblyItemBillOfMaterials[] $lotNumberedAssemblyItemBillOfMaterials
     * @param bool $replaceAll
     */
    public function __construct(array $lotNumberedAssemblyItemBillOfMaterials = array(), $replaceAll = true)
    {
        $this
            ->setLotNumberedAssemblyItemBillOfMaterials($lotNumberedAssemblyItemBillOfMaterials)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get lotNumberedAssemblyItemBillOfMaterials value
     * @return \StructType\LotNumberedAssemblyItemBillOfMaterials[]|null
     */
    public function getLotNumberedAssemblyItemBillOfMaterials()
    {
        return $this->lotNumberedAssemblyItemBillOfMaterials;
    }
    /**
     * This method is responsible for validating the values passed to the setLotNumberedAssemblyItemBillOfMaterials method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLotNumberedAssemblyItemBillOfMaterials method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLotNumberedAssemblyItemBillOfMaterialsForArrayConstraintsFromSetLotNumberedAssemblyItemBillOfMaterials(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $lotNumberedAssemblyItemBillOfMaterialsListLotNumberedAssemblyItemBillOfMaterialsItem) {
            // validation for constraint: itemType
            if (!$lotNumberedAssemblyItemBillOfMaterialsListLotNumberedAssemblyItemBillOfMaterialsItem instanceof \StructType\LotNumberedAssemblyItemBillOfMaterials) {
                $invalidValues[] = is_object($lotNumberedAssemblyItemBillOfMaterialsListLotNumberedAssemblyItemBillOfMaterialsItem) ? get_class($lotNumberedAssemblyItemBillOfMaterialsListLotNumberedAssemblyItemBillOfMaterialsItem) : sprintf('%s(%s)', gettype($lotNumberedAssemblyItemBillOfMaterialsListLotNumberedAssemblyItemBillOfMaterialsItem), var_export($lotNumberedAssemblyItemBillOfMaterialsListLotNumberedAssemblyItemBillOfMaterialsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The lotNumberedAssemblyItemBillOfMaterials property can only contain items of type \StructType\LotNumberedAssemblyItemBillOfMaterials, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set lotNumberedAssemblyItemBillOfMaterials value
     * @throws \InvalidArgumentException
     * @param \StructType\LotNumberedAssemblyItemBillOfMaterials[] $lotNumberedAssemblyItemBillOfMaterials
     * @return \StructType\LotNumberedAssemblyItemBillOfMaterialsList
     */
    public function setLotNumberedAssemblyItemBillOfMaterials(array $lotNumberedAssemblyItemBillOfMaterials = array())
    {
        // validation for constraint: array
        if ('' !== ($lotNumberedAssemblyItemBillOfMaterialsArrayErrorMessage = self::validateLotNumberedAssemblyItemBillOfMaterialsForArrayConstraintsFromSetLotNumberedAssemblyItemBillOfMaterials($lotNumberedAssemblyItemBillOfMaterials))) {
            throw new \InvalidArgumentException($lotNumberedAssemblyItemBillOfMaterialsArrayErrorMessage, __LINE__);
        }
        $this->lotNumberedAssemblyItemBillOfMaterials = $lotNumberedAssemblyItemBillOfMaterials;
        return $this;
    }
    /**
     * Add item to lotNumberedAssemblyItemBillOfMaterials value
     * @throws \InvalidArgumentException
     * @param \StructType\LotNumberedAssemblyItemBillOfMaterials $item
     * @return \StructType\LotNumberedAssemblyItemBillOfMaterialsList
     */
    public function addToLotNumberedAssemblyItemBillOfMaterials(\StructType\LotNumberedAssemblyItemBillOfMaterials $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LotNumberedAssemblyItemBillOfMaterials) {
            throw new \InvalidArgumentException(sprintf('The lotNumberedAssemblyItemBillOfMaterials property can only contain items of type \StructType\LotNumberedAssemblyItemBillOfMaterials, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->lotNumberedAssemblyItemBillOfMaterials[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\LotNumberedAssemblyItemBillOfMaterialsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
