<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LotNumberedInventoryItemHierarchyVersionsList StructType
 * @subpackage Structs
 */
class LotNumberedInventoryItemHierarchyVersionsList extends AbstractStructBase
{
    /**
     * The lotNumberedInventoryItemHierarchyVersions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LotNumberedInventoryItemHierarchyVersions[]
     */
    public $lotNumberedInventoryItemHierarchyVersions;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for LotNumberedInventoryItemHierarchyVersionsList
     * @uses LotNumberedInventoryItemHierarchyVersionsList::setLotNumberedInventoryItemHierarchyVersions()
     * @uses LotNumberedInventoryItemHierarchyVersionsList::setReplaceAll()
     * @param \StructType\LotNumberedInventoryItemHierarchyVersions[] $lotNumberedInventoryItemHierarchyVersions
     * @param bool $replaceAll
     */
    public function __construct(array $lotNumberedInventoryItemHierarchyVersions = array(), $replaceAll = true)
    {
        $this
            ->setLotNumberedInventoryItemHierarchyVersions($lotNumberedInventoryItemHierarchyVersions)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get lotNumberedInventoryItemHierarchyVersions value
     * @return \StructType\LotNumberedInventoryItemHierarchyVersions[]|null
     */
    public function getLotNumberedInventoryItemHierarchyVersions()
    {
        return $this->lotNumberedInventoryItemHierarchyVersions;
    }
    /**
     * This method is responsible for validating the values passed to the setLotNumberedInventoryItemHierarchyVersions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLotNumberedInventoryItemHierarchyVersions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLotNumberedInventoryItemHierarchyVersionsForArrayConstraintsFromSetLotNumberedInventoryItemHierarchyVersions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $lotNumberedInventoryItemHierarchyVersionsListLotNumberedInventoryItemHierarchyVersionsItem) {
            // validation for constraint: itemType
            if (!$lotNumberedInventoryItemHierarchyVersionsListLotNumberedInventoryItemHierarchyVersionsItem instanceof \StructType\LotNumberedInventoryItemHierarchyVersions) {
                $invalidValues[] = is_object($lotNumberedInventoryItemHierarchyVersionsListLotNumberedInventoryItemHierarchyVersionsItem) ? get_class($lotNumberedInventoryItemHierarchyVersionsListLotNumberedInventoryItemHierarchyVersionsItem) : sprintf('%s(%s)', gettype($lotNumberedInventoryItemHierarchyVersionsListLotNumberedInventoryItemHierarchyVersionsItem), var_export($lotNumberedInventoryItemHierarchyVersionsListLotNumberedInventoryItemHierarchyVersionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The lotNumberedInventoryItemHierarchyVersions property can only contain items of type \StructType\LotNumberedInventoryItemHierarchyVersions, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set lotNumberedInventoryItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\LotNumberedInventoryItemHierarchyVersions[] $lotNumberedInventoryItemHierarchyVersions
     * @return \StructType\LotNumberedInventoryItemHierarchyVersionsList
     */
    public function setLotNumberedInventoryItemHierarchyVersions(array $lotNumberedInventoryItemHierarchyVersions = array())
    {
        // validation for constraint: array
        if ('' !== ($lotNumberedInventoryItemHierarchyVersionsArrayErrorMessage = self::validateLotNumberedInventoryItemHierarchyVersionsForArrayConstraintsFromSetLotNumberedInventoryItemHierarchyVersions($lotNumberedInventoryItemHierarchyVersions))) {
            throw new \InvalidArgumentException($lotNumberedInventoryItemHierarchyVersionsArrayErrorMessage, __LINE__);
        }
        $this->lotNumberedInventoryItemHierarchyVersions = $lotNumberedInventoryItemHierarchyVersions;
        return $this;
    }
    /**
     * Add item to lotNumberedInventoryItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\LotNumberedInventoryItemHierarchyVersions $item
     * @return \StructType\LotNumberedInventoryItemHierarchyVersionsList
     */
    public function addToLotNumberedInventoryItemHierarchyVersions(\StructType\LotNumberedInventoryItemHierarchyVersions $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LotNumberedInventoryItemHierarchyVersions) {
            throw new \InvalidArgumentException(sprintf('The lotNumberedInventoryItemHierarchyVersions property can only contain items of type \StructType\LotNumberedInventoryItemHierarchyVersions, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->lotNumberedInventoryItemHierarchyVersions[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\LotNumberedInventoryItemHierarchyVersionsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
