<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManufacturingOperationTaskSearchRow StructType
 * @subpackage Structs
 */
class ManufacturingOperationTaskSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ManufacturingOperationTaskSearchRowBasic
     */
    public $basic;
    /**
     * The predecessorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ManufacturingOperationTaskSearchRowBasic
     */
    public $predecessorJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The workOrderJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $workOrderJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for ManufacturingOperationTaskSearchRow
     * @uses ManufacturingOperationTaskSearchRow::setBasic()
     * @uses ManufacturingOperationTaskSearchRow::setPredecessorJoin()
     * @uses ManufacturingOperationTaskSearchRow::setUserJoin()
     * @uses ManufacturingOperationTaskSearchRow::setWorkOrderJoin()
     * @uses ManufacturingOperationTaskSearchRow::setCustomSearchJoin()
     * @param \StructType\ManufacturingOperationTaskSearchRowBasic $basic
     * @param \StructType\ManufacturingOperationTaskSearchRowBasic $predecessorJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\TransactionSearchRowBasic $workOrderJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\ManufacturingOperationTaskSearchRowBasic $basic = null, \StructType\ManufacturingOperationTaskSearchRowBasic $predecessorJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\TransactionSearchRowBasic $workOrderJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setPredecessorJoin($predecessorJoin)
            ->setUserJoin($userJoin)
            ->setWorkOrderJoin($workOrderJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\ManufacturingOperationTaskSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\ManufacturingOperationTaskSearchRowBasic $basic
     * @return \StructType\ManufacturingOperationTaskSearchRow
     */
    public function setBasic(\StructType\ManufacturingOperationTaskSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get predecessorJoin value
     * @return \StructType\ManufacturingOperationTaskSearchRowBasic|null
     */
    public function getPredecessorJoin()
    {
        return $this->predecessorJoin;
    }
    /**
     * Set predecessorJoin value
     * @param \StructType\ManufacturingOperationTaskSearchRowBasic $predecessorJoin
     * @return \StructType\ManufacturingOperationTaskSearchRow
     */
    public function setPredecessorJoin(\StructType\ManufacturingOperationTaskSearchRowBasic $predecessorJoin = null)
    {
        $this->predecessorJoin = $predecessorJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\ManufacturingOperationTaskSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get workOrderJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getWorkOrderJoin()
    {
        return $this->workOrderJoin;
    }
    /**
     * Set workOrderJoin value
     * @param \StructType\TransactionSearchRowBasic $workOrderJoin
     * @return \StructType\ManufacturingOperationTaskSearchRow
     */
    public function setWorkOrderJoin(\StructType\TransactionSearchRowBasic $workOrderJoin = null)
    {
        $this->workOrderJoin = $workOrderJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manufacturingOperationTaskSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$manufacturingOperationTaskSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($manufacturingOperationTaskSearchRowCustomSearchJoinItem) ? get_class($manufacturingOperationTaskSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($manufacturingOperationTaskSearchRowCustomSearchJoinItem), var_export($manufacturingOperationTaskSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\ManufacturingOperationTaskSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\ManufacturingOperationTaskSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
