<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManufacturingRoutingRoutingComponentList StructType
 * @subpackage Structs
 */
class ManufacturingRoutingRoutingComponentList extends AbstractStructBase
{
    /**
     * The manufacturingRoutingRoutingComponent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ManufacturingRoutingRoutingComponent[]
     */
    public $manufacturingRoutingRoutingComponent;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for ManufacturingRoutingRoutingComponentList
     * @uses ManufacturingRoutingRoutingComponentList::setManufacturingRoutingRoutingComponent()
     * @uses ManufacturingRoutingRoutingComponentList::setReplaceAll()
     * @param \StructType\ManufacturingRoutingRoutingComponent[] $manufacturingRoutingRoutingComponent
     * @param bool $replaceAll
     */
    public function __construct(array $manufacturingRoutingRoutingComponent = array(), $replaceAll = true)
    {
        $this
            ->setManufacturingRoutingRoutingComponent($manufacturingRoutingRoutingComponent)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get manufacturingRoutingRoutingComponent value
     * @return \StructType\ManufacturingRoutingRoutingComponent[]|null
     */
    public function getManufacturingRoutingRoutingComponent()
    {
        return $this->manufacturingRoutingRoutingComponent;
    }
    /**
     * This method is responsible for validating the values passed to the setManufacturingRoutingRoutingComponent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManufacturingRoutingRoutingComponent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManufacturingRoutingRoutingComponentForArrayConstraintsFromSetManufacturingRoutingRoutingComponent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manufacturingRoutingRoutingComponentListManufacturingRoutingRoutingComponentItem) {
            // validation for constraint: itemType
            if (!$manufacturingRoutingRoutingComponentListManufacturingRoutingRoutingComponentItem instanceof \StructType\ManufacturingRoutingRoutingComponent) {
                $invalidValues[] = is_object($manufacturingRoutingRoutingComponentListManufacturingRoutingRoutingComponentItem) ? get_class($manufacturingRoutingRoutingComponentListManufacturingRoutingRoutingComponentItem) : sprintf('%s(%s)', gettype($manufacturingRoutingRoutingComponentListManufacturingRoutingRoutingComponentItem), var_export($manufacturingRoutingRoutingComponentListManufacturingRoutingRoutingComponentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The manufacturingRoutingRoutingComponent property can only contain items of type \StructType\ManufacturingRoutingRoutingComponent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set manufacturingRoutingRoutingComponent value
     * @throws \InvalidArgumentException
     * @param \StructType\ManufacturingRoutingRoutingComponent[] $manufacturingRoutingRoutingComponent
     * @return \StructType\ManufacturingRoutingRoutingComponentList
     */
    public function setManufacturingRoutingRoutingComponent(array $manufacturingRoutingRoutingComponent = array())
    {
        // validation for constraint: array
        if ('' !== ($manufacturingRoutingRoutingComponentArrayErrorMessage = self::validateManufacturingRoutingRoutingComponentForArrayConstraintsFromSetManufacturingRoutingRoutingComponent($manufacturingRoutingRoutingComponent))) {
            throw new \InvalidArgumentException($manufacturingRoutingRoutingComponentArrayErrorMessage, __LINE__);
        }
        $this->manufacturingRoutingRoutingComponent = $manufacturingRoutingRoutingComponent;
        return $this;
    }
    /**
     * Add item to manufacturingRoutingRoutingComponent value
     * @throws \InvalidArgumentException
     * @param \StructType\ManufacturingRoutingRoutingComponent $item
     * @return \StructType\ManufacturingRoutingRoutingComponentList
     */
    public function addToManufacturingRoutingRoutingComponent(\StructType\ManufacturingRoutingRoutingComponent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ManufacturingRoutingRoutingComponent) {
            throw new \InvalidArgumentException(sprintf('The manufacturingRoutingRoutingComponent property can only contain items of type \StructType\ManufacturingRoutingRoutingComponent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->manufacturingRoutingRoutingComponent[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\ManufacturingRoutingRoutingComponentList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
