<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManufacturingRoutingRoutingStepList StructType
 * @subpackage Structs
 */
class ManufacturingRoutingRoutingStepList extends AbstractStructBase
{
    /**
     * The manufacturingRoutingRoutingStep
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ManufacturingRoutingRoutingStep[]
     */
    public $manufacturingRoutingRoutingStep;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for ManufacturingRoutingRoutingStepList
     * @uses ManufacturingRoutingRoutingStepList::setManufacturingRoutingRoutingStep()
     * @uses ManufacturingRoutingRoutingStepList::setReplaceAll()
     * @param \StructType\ManufacturingRoutingRoutingStep[] $manufacturingRoutingRoutingStep
     * @param bool $replaceAll
     */
    public function __construct(array $manufacturingRoutingRoutingStep = array(), $replaceAll = true)
    {
        $this
            ->setManufacturingRoutingRoutingStep($manufacturingRoutingRoutingStep)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get manufacturingRoutingRoutingStep value
     * @return \StructType\ManufacturingRoutingRoutingStep[]|null
     */
    public function getManufacturingRoutingRoutingStep()
    {
        return $this->manufacturingRoutingRoutingStep;
    }
    /**
     * This method is responsible for validating the values passed to the setManufacturingRoutingRoutingStep method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManufacturingRoutingRoutingStep method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManufacturingRoutingRoutingStepForArrayConstraintsFromSetManufacturingRoutingRoutingStep(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manufacturingRoutingRoutingStepListManufacturingRoutingRoutingStepItem) {
            // validation for constraint: itemType
            if (!$manufacturingRoutingRoutingStepListManufacturingRoutingRoutingStepItem instanceof \StructType\ManufacturingRoutingRoutingStep) {
                $invalidValues[] = is_object($manufacturingRoutingRoutingStepListManufacturingRoutingRoutingStepItem) ? get_class($manufacturingRoutingRoutingStepListManufacturingRoutingRoutingStepItem) : sprintf('%s(%s)', gettype($manufacturingRoutingRoutingStepListManufacturingRoutingRoutingStepItem), var_export($manufacturingRoutingRoutingStepListManufacturingRoutingRoutingStepItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The manufacturingRoutingRoutingStep property can only contain items of type \StructType\ManufacturingRoutingRoutingStep, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set manufacturingRoutingRoutingStep value
     * @throws \InvalidArgumentException
     * @param \StructType\ManufacturingRoutingRoutingStep[] $manufacturingRoutingRoutingStep
     * @return \StructType\ManufacturingRoutingRoutingStepList
     */
    public function setManufacturingRoutingRoutingStep(array $manufacturingRoutingRoutingStep = array())
    {
        // validation for constraint: array
        if ('' !== ($manufacturingRoutingRoutingStepArrayErrorMessage = self::validateManufacturingRoutingRoutingStepForArrayConstraintsFromSetManufacturingRoutingRoutingStep($manufacturingRoutingRoutingStep))) {
            throw new \InvalidArgumentException($manufacturingRoutingRoutingStepArrayErrorMessage, __LINE__);
        }
        $this->manufacturingRoutingRoutingStep = $manufacturingRoutingRoutingStep;
        return $this;
    }
    /**
     * Add item to manufacturingRoutingRoutingStep value
     * @throws \InvalidArgumentException
     * @param \StructType\ManufacturingRoutingRoutingStep $item
     * @return \StructType\ManufacturingRoutingRoutingStepList
     */
    public function addToManufacturingRoutingRoutingStep(\StructType\ManufacturingRoutingRoutingStep $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ManufacturingRoutingRoutingStep) {
            throw new \InvalidArgumentException(sprintf('The manufacturingRoutingRoutingStep property can only contain items of type \StructType\ManufacturingRoutingRoutingStep, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->manufacturingRoutingRoutingStep[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\ManufacturingRoutingRoutingStepList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
