<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManufacturingRoutingSearchRow StructType
 * @subpackage Structs
 */
class ManufacturingRoutingSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ManufacturingRoutingSearchRowBasic
     */
    public $basic;
    /**
     * The itemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $itemJoin;
    /**
     * The locationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\LocationSearchRowBasic
     */
    public $locationJoin;
    /**
     * The manufacturingCostTemplateJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ManufacturingCostTemplateSearchRowBasic
     */
    public $manufacturingCostTemplateJoin;
    /**
     * The manufacturingWorkCenterJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntityGroupSearchRowBasic
     */
    public $manufacturingWorkCenterJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for ManufacturingRoutingSearchRow
     * @uses ManufacturingRoutingSearchRow::setBasic()
     * @uses ManufacturingRoutingSearchRow::setItemJoin()
     * @uses ManufacturingRoutingSearchRow::setLocationJoin()
     * @uses ManufacturingRoutingSearchRow::setManufacturingCostTemplateJoin()
     * @uses ManufacturingRoutingSearchRow::setManufacturingWorkCenterJoin()
     * @uses ManufacturingRoutingSearchRow::setUserJoin()
     * @uses ManufacturingRoutingSearchRow::setCustomSearchJoin()
     * @param \StructType\ManufacturingRoutingSearchRowBasic $basic
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @param \StructType\LocationSearchRowBasic $locationJoin
     * @param \StructType\ManufacturingCostTemplateSearchRowBasic $manufacturingCostTemplateJoin
     * @param \StructType\EntityGroupSearchRowBasic $manufacturingWorkCenterJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\ManufacturingRoutingSearchRowBasic $basic = null, \StructType\ItemSearchRowBasic $itemJoin = null, \StructType\LocationSearchRowBasic $locationJoin = null, \StructType\ManufacturingCostTemplateSearchRowBasic $manufacturingCostTemplateJoin = null, \StructType\EntityGroupSearchRowBasic $manufacturingWorkCenterJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setItemJoin($itemJoin)
            ->setLocationJoin($locationJoin)
            ->setManufacturingCostTemplateJoin($manufacturingCostTemplateJoin)
            ->setManufacturingWorkCenterJoin($manufacturingWorkCenterJoin)
            ->setUserJoin($userJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\ManufacturingRoutingSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\ManufacturingRoutingSearchRowBasic $basic
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function setBasic(\StructType\ManufacturingRoutingSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get itemJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getItemJoin()
    {
        return $this->itemJoin;
    }
    /**
     * Set itemJoin value
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function setItemJoin(\StructType\ItemSearchRowBasic $itemJoin = null)
    {
        $this->itemJoin = $itemJoin;
        return $this;
    }
    /**
     * Get locationJoin value
     * @return \StructType\LocationSearchRowBasic|null
     */
    public function getLocationJoin()
    {
        return $this->locationJoin;
    }
    /**
     * Set locationJoin value
     * @param \StructType\LocationSearchRowBasic $locationJoin
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function setLocationJoin(\StructType\LocationSearchRowBasic $locationJoin = null)
    {
        $this->locationJoin = $locationJoin;
        return $this;
    }
    /**
     * Get manufacturingCostTemplateJoin value
     * @return \StructType\ManufacturingCostTemplateSearchRowBasic|null
     */
    public function getManufacturingCostTemplateJoin()
    {
        return $this->manufacturingCostTemplateJoin;
    }
    /**
     * Set manufacturingCostTemplateJoin value
     * @param \StructType\ManufacturingCostTemplateSearchRowBasic $manufacturingCostTemplateJoin
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function setManufacturingCostTemplateJoin(\StructType\ManufacturingCostTemplateSearchRowBasic $manufacturingCostTemplateJoin = null)
    {
        $this->manufacturingCostTemplateJoin = $manufacturingCostTemplateJoin;
        return $this;
    }
    /**
     * Get manufacturingWorkCenterJoin value
     * @return \StructType\EntityGroupSearchRowBasic|null
     */
    public function getManufacturingWorkCenterJoin()
    {
        return $this->manufacturingWorkCenterJoin;
    }
    /**
     * Set manufacturingWorkCenterJoin value
     * @param \StructType\EntityGroupSearchRowBasic $manufacturingWorkCenterJoin
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function setManufacturingWorkCenterJoin(\StructType\EntityGroupSearchRowBasic $manufacturingWorkCenterJoin = null)
    {
        $this->manufacturingWorkCenterJoin = $manufacturingWorkCenterJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manufacturingRoutingSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$manufacturingRoutingSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($manufacturingRoutingSearchRowCustomSearchJoinItem) ? get_class($manufacturingRoutingSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($manufacturingRoutingSearchRowCustomSearchJoinItem), var_export($manufacturingRoutingSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\ManufacturingRoutingSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
