<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NonInventoryPurchaseItemHierarchyVersionsList StructType
 * @subpackage Structs
 */
class NonInventoryPurchaseItemHierarchyVersionsList extends AbstractStructBase
{
    /**
     * The nonInventoryPurchaseItemHierarchyVersions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\NonInventoryPurchaseItemHierarchyVersions[]
     */
    public $nonInventoryPurchaseItemHierarchyVersions;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for NonInventoryPurchaseItemHierarchyVersionsList
     * @uses NonInventoryPurchaseItemHierarchyVersionsList::setNonInventoryPurchaseItemHierarchyVersions()
     * @uses NonInventoryPurchaseItemHierarchyVersionsList::setReplaceAll()
     * @param \StructType\NonInventoryPurchaseItemHierarchyVersions[] $nonInventoryPurchaseItemHierarchyVersions
     * @param bool $replaceAll
     */
    public function __construct(array $nonInventoryPurchaseItemHierarchyVersions = array(), $replaceAll = true)
    {
        $this
            ->setNonInventoryPurchaseItemHierarchyVersions($nonInventoryPurchaseItemHierarchyVersions)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get nonInventoryPurchaseItemHierarchyVersions value
     * @return \StructType\NonInventoryPurchaseItemHierarchyVersions[]|null
     */
    public function getNonInventoryPurchaseItemHierarchyVersions()
    {
        return $this->nonInventoryPurchaseItemHierarchyVersions;
    }
    /**
     * This method is responsible for validating the values passed to the setNonInventoryPurchaseItemHierarchyVersions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNonInventoryPurchaseItemHierarchyVersions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNonInventoryPurchaseItemHierarchyVersionsForArrayConstraintsFromSetNonInventoryPurchaseItemHierarchyVersions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $nonInventoryPurchaseItemHierarchyVersionsListNonInventoryPurchaseItemHierarchyVersionsItem) {
            // validation for constraint: itemType
            if (!$nonInventoryPurchaseItemHierarchyVersionsListNonInventoryPurchaseItemHierarchyVersionsItem instanceof \StructType\NonInventoryPurchaseItemHierarchyVersions) {
                $invalidValues[] = is_object($nonInventoryPurchaseItemHierarchyVersionsListNonInventoryPurchaseItemHierarchyVersionsItem) ? get_class($nonInventoryPurchaseItemHierarchyVersionsListNonInventoryPurchaseItemHierarchyVersionsItem) : sprintf('%s(%s)', gettype($nonInventoryPurchaseItemHierarchyVersionsListNonInventoryPurchaseItemHierarchyVersionsItem), var_export($nonInventoryPurchaseItemHierarchyVersionsListNonInventoryPurchaseItemHierarchyVersionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The nonInventoryPurchaseItemHierarchyVersions property can only contain items of type \StructType\NonInventoryPurchaseItemHierarchyVersions, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set nonInventoryPurchaseItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\NonInventoryPurchaseItemHierarchyVersions[] $nonInventoryPurchaseItemHierarchyVersions
     * @return \StructType\NonInventoryPurchaseItemHierarchyVersionsList
     */
    public function setNonInventoryPurchaseItemHierarchyVersions(array $nonInventoryPurchaseItemHierarchyVersions = array())
    {
        // validation for constraint: array
        if ('' !== ($nonInventoryPurchaseItemHierarchyVersionsArrayErrorMessage = self::validateNonInventoryPurchaseItemHierarchyVersionsForArrayConstraintsFromSetNonInventoryPurchaseItemHierarchyVersions($nonInventoryPurchaseItemHierarchyVersions))) {
            throw new \InvalidArgumentException($nonInventoryPurchaseItemHierarchyVersionsArrayErrorMessage, __LINE__);
        }
        $this->nonInventoryPurchaseItemHierarchyVersions = $nonInventoryPurchaseItemHierarchyVersions;
        return $this;
    }
    /**
     * Add item to nonInventoryPurchaseItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\NonInventoryPurchaseItemHierarchyVersions $item
     * @return \StructType\NonInventoryPurchaseItemHierarchyVersionsList
     */
    public function addToNonInventoryPurchaseItemHierarchyVersions(\StructType\NonInventoryPurchaseItemHierarchyVersions $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\NonInventoryPurchaseItemHierarchyVersions) {
            throw new \InvalidArgumentException(sprintf('The nonInventoryPurchaseItemHierarchyVersions property can only contain items of type \StructType\NonInventoryPurchaseItemHierarchyVersions, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->nonInventoryPurchaseItemHierarchyVersions[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\NonInventoryPurchaseItemHierarchyVersionsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
