<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaycheckJournalCompanyContributionList StructType
 * @subpackage Structs
 */
class PaycheckJournalCompanyContributionList extends AbstractStructBase
{
    /**
     * The paycheckJournalCompanyContribution
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaycheckJournalCompanyContribution[]
     */
    public $paycheckJournalCompanyContribution;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PaycheckJournalCompanyContributionList
     * @uses PaycheckJournalCompanyContributionList::setPaycheckJournalCompanyContribution()
     * @uses PaycheckJournalCompanyContributionList::setReplaceAll()
     * @param \StructType\PaycheckJournalCompanyContribution[] $paycheckJournalCompanyContribution
     * @param bool $replaceAll
     */
    public function __construct(array $paycheckJournalCompanyContribution = array(), $replaceAll = true)
    {
        $this
            ->setPaycheckJournalCompanyContribution($paycheckJournalCompanyContribution)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get paycheckJournalCompanyContribution value
     * @return \StructType\PaycheckJournalCompanyContribution[]|null
     */
    public function getPaycheckJournalCompanyContribution()
    {
        return $this->paycheckJournalCompanyContribution;
    }
    /**
     * This method is responsible for validating the values passed to the setPaycheckJournalCompanyContribution method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaycheckJournalCompanyContribution method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaycheckJournalCompanyContributionForArrayConstraintsFromSetPaycheckJournalCompanyContribution(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paycheckJournalCompanyContributionListPaycheckJournalCompanyContributionItem) {
            // validation for constraint: itemType
            if (!$paycheckJournalCompanyContributionListPaycheckJournalCompanyContributionItem instanceof \StructType\PaycheckJournalCompanyContribution) {
                $invalidValues[] = is_object($paycheckJournalCompanyContributionListPaycheckJournalCompanyContributionItem) ? get_class($paycheckJournalCompanyContributionListPaycheckJournalCompanyContributionItem) : sprintf('%s(%s)', gettype($paycheckJournalCompanyContributionListPaycheckJournalCompanyContributionItem), var_export($paycheckJournalCompanyContributionListPaycheckJournalCompanyContributionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The paycheckJournalCompanyContribution property can only contain items of type \StructType\PaycheckJournalCompanyContribution, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set paycheckJournalCompanyContribution value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckJournalCompanyContribution[] $paycheckJournalCompanyContribution
     * @return \StructType\PaycheckJournalCompanyContributionList
     */
    public function setPaycheckJournalCompanyContribution(array $paycheckJournalCompanyContribution = array())
    {
        // validation for constraint: array
        if ('' !== ($paycheckJournalCompanyContributionArrayErrorMessage = self::validatePaycheckJournalCompanyContributionForArrayConstraintsFromSetPaycheckJournalCompanyContribution($paycheckJournalCompanyContribution))) {
            throw new \InvalidArgumentException($paycheckJournalCompanyContributionArrayErrorMessage, __LINE__);
        }
        $this->paycheckJournalCompanyContribution = $paycheckJournalCompanyContribution;
        return $this;
    }
    /**
     * Add item to paycheckJournalCompanyContribution value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckJournalCompanyContribution $item
     * @return \StructType\PaycheckJournalCompanyContributionList
     */
    public function addToPaycheckJournalCompanyContribution(\StructType\PaycheckJournalCompanyContribution $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaycheckJournalCompanyContribution) {
            throw new \InvalidArgumentException(sprintf('The paycheckJournalCompanyContribution property can only contain items of type \StructType\PaycheckJournalCompanyContribution, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->paycheckJournalCompanyContribution[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PaycheckJournalCompanyContributionList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
