<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaycheckPayContribList StructType
 * @subpackage Structs
 */
class PaycheckPayContribList extends AbstractStructBase
{
    /**
     * The paycheckPayContrib
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaycheckPayContrib[]
     */
    public $paycheckPayContrib;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PaycheckPayContribList
     * @uses PaycheckPayContribList::setPaycheckPayContrib()
     * @uses PaycheckPayContribList::setReplaceAll()
     * @param \StructType\PaycheckPayContrib[] $paycheckPayContrib
     * @param bool $replaceAll
     */
    public function __construct(array $paycheckPayContrib = array(), $replaceAll = true)
    {
        $this
            ->setPaycheckPayContrib($paycheckPayContrib)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get paycheckPayContrib value
     * @return \StructType\PaycheckPayContrib[]|null
     */
    public function getPaycheckPayContrib()
    {
        return $this->paycheckPayContrib;
    }
    /**
     * This method is responsible for validating the values passed to the setPaycheckPayContrib method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaycheckPayContrib method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaycheckPayContribForArrayConstraintsFromSetPaycheckPayContrib(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paycheckPayContribListPaycheckPayContribItem) {
            // validation for constraint: itemType
            if (!$paycheckPayContribListPaycheckPayContribItem instanceof \StructType\PaycheckPayContrib) {
                $invalidValues[] = is_object($paycheckPayContribListPaycheckPayContribItem) ? get_class($paycheckPayContribListPaycheckPayContribItem) : sprintf('%s(%s)', gettype($paycheckPayContribListPaycheckPayContribItem), var_export($paycheckPayContribListPaycheckPayContribItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The paycheckPayContrib property can only contain items of type \StructType\PaycheckPayContrib, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set paycheckPayContrib value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayContrib[] $paycheckPayContrib
     * @return \StructType\PaycheckPayContribList
     */
    public function setPaycheckPayContrib(array $paycheckPayContrib = array())
    {
        // validation for constraint: array
        if ('' !== ($paycheckPayContribArrayErrorMessage = self::validatePaycheckPayContribForArrayConstraintsFromSetPaycheckPayContrib($paycheckPayContrib))) {
            throw new \InvalidArgumentException($paycheckPayContribArrayErrorMessage, __LINE__);
        }
        $this->paycheckPayContrib = $paycheckPayContrib;
        return $this;
    }
    /**
     * Add item to paycheckPayContrib value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayContrib $item
     * @return \StructType\PaycheckPayContribList
     */
    public function addToPaycheckPayContrib(\StructType\PaycheckPayContrib $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaycheckPayContrib) {
            throw new \InvalidArgumentException(sprintf('The paycheckPayContrib property can only contain items of type \StructType\PaycheckPayContrib, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->paycheckPayContrib[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PaycheckPayContribList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
