<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaycheckPayDisburseList StructType
 * @subpackage Structs
 */
class PaycheckPayDisburseList extends AbstractStructBase
{
    /**
     * The paycheckPayDisburse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaycheckPayDisburse[]
     */
    public $paycheckPayDisburse;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PaycheckPayDisburseList
     * @uses PaycheckPayDisburseList::setPaycheckPayDisburse()
     * @uses PaycheckPayDisburseList::setReplaceAll()
     * @param \StructType\PaycheckPayDisburse[] $paycheckPayDisburse
     * @param bool $replaceAll
     */
    public function __construct(array $paycheckPayDisburse = array(), $replaceAll = true)
    {
        $this
            ->setPaycheckPayDisburse($paycheckPayDisburse)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get paycheckPayDisburse value
     * @return \StructType\PaycheckPayDisburse[]|null
     */
    public function getPaycheckPayDisburse()
    {
        return $this->paycheckPayDisburse;
    }
    /**
     * This method is responsible for validating the values passed to the setPaycheckPayDisburse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaycheckPayDisburse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaycheckPayDisburseForArrayConstraintsFromSetPaycheckPayDisburse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paycheckPayDisburseListPaycheckPayDisburseItem) {
            // validation for constraint: itemType
            if (!$paycheckPayDisburseListPaycheckPayDisburseItem instanceof \StructType\PaycheckPayDisburse) {
                $invalidValues[] = is_object($paycheckPayDisburseListPaycheckPayDisburseItem) ? get_class($paycheckPayDisburseListPaycheckPayDisburseItem) : sprintf('%s(%s)', gettype($paycheckPayDisburseListPaycheckPayDisburseItem), var_export($paycheckPayDisburseListPaycheckPayDisburseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The paycheckPayDisburse property can only contain items of type \StructType\PaycheckPayDisburse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set paycheckPayDisburse value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayDisburse[] $paycheckPayDisburse
     * @return \StructType\PaycheckPayDisburseList
     */
    public function setPaycheckPayDisburse(array $paycheckPayDisburse = array())
    {
        // validation for constraint: array
        if ('' !== ($paycheckPayDisburseArrayErrorMessage = self::validatePaycheckPayDisburseForArrayConstraintsFromSetPaycheckPayDisburse($paycheckPayDisburse))) {
            throw new \InvalidArgumentException($paycheckPayDisburseArrayErrorMessage, __LINE__);
        }
        $this->paycheckPayDisburse = $paycheckPayDisburse;
        return $this;
    }
    /**
     * Add item to paycheckPayDisburse value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayDisburse $item
     * @return \StructType\PaycheckPayDisburseList
     */
    public function addToPaycheckPayDisburse(\StructType\PaycheckPayDisburse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaycheckPayDisburse) {
            throw new \InvalidArgumentException(sprintf('The paycheckPayDisburse property can only contain items of type \StructType\PaycheckPayDisburse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->paycheckPayDisburse[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PaycheckPayDisburseList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
