<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaycheckPayEarnList StructType
 * @subpackage Structs
 */
class PaycheckPayEarnList extends AbstractStructBase
{
    /**
     * The paycheckPayEarn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaycheckPayEarn[]
     */
    public $paycheckPayEarn;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PaycheckPayEarnList
     * @uses PaycheckPayEarnList::setPaycheckPayEarn()
     * @uses PaycheckPayEarnList::setReplaceAll()
     * @param \StructType\PaycheckPayEarn[] $paycheckPayEarn
     * @param bool $replaceAll
     */
    public function __construct(array $paycheckPayEarn = array(), $replaceAll = true)
    {
        $this
            ->setPaycheckPayEarn($paycheckPayEarn)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get paycheckPayEarn value
     * @return \StructType\PaycheckPayEarn[]|null
     */
    public function getPaycheckPayEarn()
    {
        return $this->paycheckPayEarn;
    }
    /**
     * This method is responsible for validating the values passed to the setPaycheckPayEarn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaycheckPayEarn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaycheckPayEarnForArrayConstraintsFromSetPaycheckPayEarn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paycheckPayEarnListPaycheckPayEarnItem) {
            // validation for constraint: itemType
            if (!$paycheckPayEarnListPaycheckPayEarnItem instanceof \StructType\PaycheckPayEarn) {
                $invalidValues[] = is_object($paycheckPayEarnListPaycheckPayEarnItem) ? get_class($paycheckPayEarnListPaycheckPayEarnItem) : sprintf('%s(%s)', gettype($paycheckPayEarnListPaycheckPayEarnItem), var_export($paycheckPayEarnListPaycheckPayEarnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The paycheckPayEarn property can only contain items of type \StructType\PaycheckPayEarn, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set paycheckPayEarn value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayEarn[] $paycheckPayEarn
     * @return \StructType\PaycheckPayEarnList
     */
    public function setPaycheckPayEarn(array $paycheckPayEarn = array())
    {
        // validation for constraint: array
        if ('' !== ($paycheckPayEarnArrayErrorMessage = self::validatePaycheckPayEarnForArrayConstraintsFromSetPaycheckPayEarn($paycheckPayEarn))) {
            throw new \InvalidArgumentException($paycheckPayEarnArrayErrorMessage, __LINE__);
        }
        $this->paycheckPayEarn = $paycheckPayEarn;
        return $this;
    }
    /**
     * Add item to paycheckPayEarn value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayEarn $item
     * @return \StructType\PaycheckPayEarnList
     */
    public function addToPaycheckPayEarn(\StructType\PaycheckPayEarn $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaycheckPayEarn) {
            throw new \InvalidArgumentException(sprintf('The paycheckPayEarn property can only contain items of type \StructType\PaycheckPayEarn, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->paycheckPayEarn[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PaycheckPayEarnList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
