<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PeriodEndJournalLineList StructType
 * @subpackage Structs
 */
class PeriodEndJournalLineList extends AbstractStructBase
{
    /**
     * The periodEndJournalLine
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PeriodEndJournalLine[]
     */
    public $periodEndJournalLine;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PeriodEndJournalLineList
     * @uses PeriodEndJournalLineList::setPeriodEndJournalLine()
     * @uses PeriodEndJournalLineList::setReplaceAll()
     * @param \StructType\PeriodEndJournalLine[] $periodEndJournalLine
     * @param bool $replaceAll
     */
    public function __construct(array $periodEndJournalLine = array(), $replaceAll = true)
    {
        $this
            ->setPeriodEndJournalLine($periodEndJournalLine)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get periodEndJournalLine value
     * @return \StructType\PeriodEndJournalLine[]|null
     */
    public function getPeriodEndJournalLine()
    {
        return $this->periodEndJournalLine;
    }
    /**
     * This method is responsible for validating the values passed to the setPeriodEndJournalLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPeriodEndJournalLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePeriodEndJournalLineForArrayConstraintsFromSetPeriodEndJournalLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $periodEndJournalLineListPeriodEndJournalLineItem) {
            // validation for constraint: itemType
            if (!$periodEndJournalLineListPeriodEndJournalLineItem instanceof \StructType\PeriodEndJournalLine) {
                $invalidValues[] = is_object($periodEndJournalLineListPeriodEndJournalLineItem) ? get_class($periodEndJournalLineListPeriodEndJournalLineItem) : sprintf('%s(%s)', gettype($periodEndJournalLineListPeriodEndJournalLineItem), var_export($periodEndJournalLineListPeriodEndJournalLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The periodEndJournalLine property can only contain items of type \StructType\PeriodEndJournalLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set periodEndJournalLine value
     * @throws \InvalidArgumentException
     * @param \StructType\PeriodEndJournalLine[] $periodEndJournalLine
     * @return \StructType\PeriodEndJournalLineList
     */
    public function setPeriodEndJournalLine(array $periodEndJournalLine = array())
    {
        // validation for constraint: array
        if ('' !== ($periodEndJournalLineArrayErrorMessage = self::validatePeriodEndJournalLineForArrayConstraintsFromSetPeriodEndJournalLine($periodEndJournalLine))) {
            throw new \InvalidArgumentException($periodEndJournalLineArrayErrorMessage, __LINE__);
        }
        $this->periodEndJournalLine = $periodEndJournalLine;
        return $this;
    }
    /**
     * Add item to periodEndJournalLine value
     * @throws \InvalidArgumentException
     * @param \StructType\PeriodEndJournalLine $item
     * @return \StructType\PeriodEndJournalLineList
     */
    public function addToPeriodEndJournalLine(\StructType\PeriodEndJournalLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PeriodEndJournalLine) {
            throw new \InvalidArgumentException(sprintf('The periodEndJournalLine property can only contain items of type \StructType\PeriodEndJournalLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->periodEndJournalLine[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PeriodEndJournalLineList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
