<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PostingTransactionSummaryFilter StructType
 * @subpackage Structs
 */
class PostingTransactionSummaryFilter extends AbstractStructBase
{
    /**
     * The period
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $period;
    /**
     * The account
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $account;
    /**
     * The parentItem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $parentItem;
    /**
     * The item
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $item;
    /**
     * The entity
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $entity;
    /**
     * The department
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $department;
    /**
     * The class
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $class;
    /**
     * The location
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $location;
    /**
     * The subsidiary
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $subsidiary;
    /**
     * The book
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RecordRefList
     */
    public $book;
    /**
     * Constructor method for PostingTransactionSummaryFilter
     * @uses PostingTransactionSummaryFilter::setPeriod()
     * @uses PostingTransactionSummaryFilter::setAccount()
     * @uses PostingTransactionSummaryFilter::setParentItem()
     * @uses PostingTransactionSummaryFilter::setItem()
     * @uses PostingTransactionSummaryFilter::setEntity()
     * @uses PostingTransactionSummaryFilter::setDepartment()
     * @uses PostingTransactionSummaryFilter::setClass()
     * @uses PostingTransactionSummaryFilter::setLocation()
     * @uses PostingTransactionSummaryFilter::setSubsidiary()
     * @uses PostingTransactionSummaryFilter::setBook()
     * @param \StructType\RecordRefList $period
     * @param \StructType\RecordRefList $account
     * @param \StructType\RecordRefList $parentItem
     * @param \StructType\RecordRefList $item
     * @param \StructType\RecordRefList $entity
     * @param \StructType\RecordRefList $department
     * @param \StructType\RecordRefList $class
     * @param \StructType\RecordRefList $location
     * @param \StructType\RecordRefList $subsidiary
     * @param \StructType\RecordRefList $book
     */
    public function __construct(\StructType\RecordRefList $period = null, \StructType\RecordRefList $account = null, \StructType\RecordRefList $parentItem = null, \StructType\RecordRefList $item = null, \StructType\RecordRefList $entity = null, \StructType\RecordRefList $department = null, \StructType\RecordRefList $class = null, \StructType\RecordRefList $location = null, \StructType\RecordRefList $subsidiary = null, \StructType\RecordRefList $book = null)
    {
        $this
            ->setPeriod($period)
            ->setAccount($account)
            ->setParentItem($parentItem)
            ->setItem($item)
            ->setEntity($entity)
            ->setDepartment($department)
            ->setClass($class)
            ->setLocation($location)
            ->setSubsidiary($subsidiary)
            ->setBook($book);
    }
    /**
     * Get period value
     * @return \StructType\RecordRefList|null
     */
    public function getPeriod()
    {
        return $this->period;
    }
    /**
     * Set period value
     * @param \StructType\RecordRefList $period
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setPeriod(\StructType\RecordRefList $period = null)
    {
        $this->period = $period;
        return $this;
    }
    /**
     * Get account value
     * @return \StructType\RecordRefList|null
     */
    public function getAccount()
    {
        return $this->account;
    }
    /**
     * Set account value
     * @param \StructType\RecordRefList $account
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setAccount(\StructType\RecordRefList $account = null)
    {
        $this->account = $account;
        return $this;
    }
    /**
     * Get parentItem value
     * @return \StructType\RecordRefList|null
     */
    public function getParentItem()
    {
        return $this->parentItem;
    }
    /**
     * Set parentItem value
     * @param \StructType\RecordRefList $parentItem
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setParentItem(\StructType\RecordRefList $parentItem = null)
    {
        $this->parentItem = $parentItem;
        return $this;
    }
    /**
     * Get item value
     * @return \StructType\RecordRefList|null
     */
    public function getItem()
    {
        return $this->item;
    }
    /**
     * Set item value
     * @param \StructType\RecordRefList $item
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setItem(\StructType\RecordRefList $item = null)
    {
        $this->item = $item;
        return $this;
    }
    /**
     * Get entity value
     * @return \StructType\RecordRefList|null
     */
    public function getEntity()
    {
        return $this->entity;
    }
    /**
     * Set entity value
     * @param \StructType\RecordRefList $entity
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setEntity(\StructType\RecordRefList $entity = null)
    {
        $this->entity = $entity;
        return $this;
    }
    /**
     * Get department value
     * @return \StructType\RecordRefList|null
     */
    public function getDepartment()
    {
        return $this->department;
    }
    /**
     * Set department value
     * @param \StructType\RecordRefList $department
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setDepartment(\StructType\RecordRefList $department = null)
    {
        $this->department = $department;
        return $this;
    }
    /**
     * Get class value
     * @return \StructType\RecordRefList|null
     */
    public function getClass()
    {
        return $this->class;
    }
    /**
     * Set class value
     * @param \StructType\RecordRefList $class
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setClass(\StructType\RecordRefList $class = null)
    {
        $this->class = $class;
        return $this;
    }
    /**
     * Get location value
     * @return \StructType\RecordRefList|null
     */
    public function getLocation()
    {
        return $this->location;
    }
    /**
     * Set location value
     * @param \StructType\RecordRefList $location
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setLocation(\StructType\RecordRefList $location = null)
    {
        $this->location = $location;
        return $this;
    }
    /**
     * Get subsidiary value
     * @return \StructType\RecordRefList|null
     */
    public function getSubsidiary()
    {
        return $this->subsidiary;
    }
    /**
     * Set subsidiary value
     * @param \StructType\RecordRefList $subsidiary
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setSubsidiary(\StructType\RecordRefList $subsidiary = null)
    {
        $this->subsidiary = $subsidiary;
        return $this;
    }
    /**
     * Get book value
     * @return \StructType\RecordRefList|null
     */
    public function getBook()
    {
        return $this->book;
    }
    /**
     * Set book value
     * @param \StructType\RecordRefList $book
     * @return \StructType\PostingTransactionSummaryFilter
     */
    public function setBook(\StructType\RecordRefList $book = null)
    {
        $this->book = $book;
        return $this;
    }
}
