<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProjectTaskSearchRow StructType
 * @subpackage Structs
 */
class ProjectTaskSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ProjectTaskSearchRowBasic
     */
    public $basic;
    /**
     * The jobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchRowBasic
     */
    public $jobJoin;
    /**
     * The predecessorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ProjectTaskSearchRowBasic
     */
    public $predecessorJoin;
    /**
     * The projectTaskAssignmentJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ProjectTaskAssignmentSearchRowBasic
     */
    public $projectTaskAssignmentJoin;
    /**
     * The resourceAllocationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ResourceAllocationSearchRowBasic
     */
    public $resourceAllocationJoin;
    /**
     * The successorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ProjectTaskSearchRowBasic
     */
    public $successorJoin;
    /**
     * The timeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TimeBillSearchRowBasic
     */
    public $timeJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for ProjectTaskSearchRow
     * @uses ProjectTaskSearchRow::setBasic()
     * @uses ProjectTaskSearchRow::setJobJoin()
     * @uses ProjectTaskSearchRow::setPredecessorJoin()
     * @uses ProjectTaskSearchRow::setProjectTaskAssignmentJoin()
     * @uses ProjectTaskSearchRow::setResourceAllocationJoin()
     * @uses ProjectTaskSearchRow::setSuccessorJoin()
     * @uses ProjectTaskSearchRow::setTimeJoin()
     * @uses ProjectTaskSearchRow::setTransactionJoin()
     * @uses ProjectTaskSearchRow::setUserJoin()
     * @uses ProjectTaskSearchRow::setUserNotesJoin()
     * @uses ProjectTaskSearchRow::setCustomSearchJoin()
     * @param \StructType\ProjectTaskSearchRowBasic $basic
     * @param \StructType\JobSearchRowBasic $jobJoin
     * @param \StructType\ProjectTaskSearchRowBasic $predecessorJoin
     * @param \StructType\ProjectTaskAssignmentSearchRowBasic $projectTaskAssignmentJoin
     * @param \StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin
     * @param \StructType\ProjectTaskSearchRowBasic $successorJoin
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\ProjectTaskSearchRowBasic $basic = null, \StructType\JobSearchRowBasic $jobJoin = null, \StructType\ProjectTaskSearchRowBasic $predecessorJoin = null, \StructType\ProjectTaskAssignmentSearchRowBasic $projectTaskAssignmentJoin = null, \StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin = null, \StructType\ProjectTaskSearchRowBasic $successorJoin = null, \StructType\TimeBillSearchRowBasic $timeJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setJobJoin($jobJoin)
            ->setPredecessorJoin($predecessorJoin)
            ->setProjectTaskAssignmentJoin($projectTaskAssignmentJoin)
            ->setResourceAllocationJoin($resourceAllocationJoin)
            ->setSuccessorJoin($successorJoin)
            ->setTimeJoin($timeJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\ProjectTaskSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\ProjectTaskSearchRowBasic $basic
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setBasic(\StructType\ProjectTaskSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get jobJoin value
     * @return \StructType\JobSearchRowBasic|null
     */
    public function getJobJoin()
    {
        return $this->jobJoin;
    }
    /**
     * Set jobJoin value
     * @param \StructType\JobSearchRowBasic $jobJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setJobJoin(\StructType\JobSearchRowBasic $jobJoin = null)
    {
        $this->jobJoin = $jobJoin;
        return $this;
    }
    /**
     * Get predecessorJoin value
     * @return \StructType\ProjectTaskSearchRowBasic|null
     */
    public function getPredecessorJoin()
    {
        return $this->predecessorJoin;
    }
    /**
     * Set predecessorJoin value
     * @param \StructType\ProjectTaskSearchRowBasic $predecessorJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setPredecessorJoin(\StructType\ProjectTaskSearchRowBasic $predecessorJoin = null)
    {
        $this->predecessorJoin = $predecessorJoin;
        return $this;
    }
    /**
     * Get projectTaskAssignmentJoin value
     * @return \StructType\ProjectTaskAssignmentSearchRowBasic|null
     */
    public function getProjectTaskAssignmentJoin()
    {
        return $this->projectTaskAssignmentJoin;
    }
    /**
     * Set projectTaskAssignmentJoin value
     * @param \StructType\ProjectTaskAssignmentSearchRowBasic $projectTaskAssignmentJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setProjectTaskAssignmentJoin(\StructType\ProjectTaskAssignmentSearchRowBasic $projectTaskAssignmentJoin = null)
    {
        $this->projectTaskAssignmentJoin = $projectTaskAssignmentJoin;
        return $this;
    }
    /**
     * Get resourceAllocationJoin value
     * @return \StructType\ResourceAllocationSearchRowBasic|null
     */
    public function getResourceAllocationJoin()
    {
        return $this->resourceAllocationJoin;
    }
    /**
     * Set resourceAllocationJoin value
     * @param \StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setResourceAllocationJoin(\StructType\ResourceAllocationSearchRowBasic $resourceAllocationJoin = null)
    {
        $this->resourceAllocationJoin = $resourceAllocationJoin;
        return $this;
    }
    /**
     * Get successorJoin value
     * @return \StructType\ProjectTaskSearchRowBasic|null
     */
    public function getSuccessorJoin()
    {
        return $this->successorJoin;
    }
    /**
     * Set successorJoin value
     * @param \StructType\ProjectTaskSearchRowBasic $successorJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setSuccessorJoin(\StructType\ProjectTaskSearchRowBasic $successorJoin = null)
    {
        $this->successorJoin = $successorJoin;
        return $this;
    }
    /**
     * Get timeJoin value
     * @return \StructType\TimeBillSearchRowBasic|null
     */
    public function getTimeJoin()
    {
        return $this->timeJoin;
    }
    /**
     * Set timeJoin value
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setTimeJoin(\StructType\TimeBillSearchRowBasic $timeJoin = null)
    {
        $this->timeJoin = $timeJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $projectTaskSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$projectTaskSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($projectTaskSearchRowCustomSearchJoinItem) ? get_class($projectTaskSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($projectTaskSearchRowCustomSearchJoinItem), var_export($projectTaskSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\ProjectTaskSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\ProjectTaskSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
