<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PurchaseRequisitionExpenseList StructType
 * @subpackage Structs
 */
class PurchaseRequisitionExpenseList extends AbstractStructBase
{
    /**
     * The purchaseRequisitionExpense
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PurchaseRequisitionExpense[]
     */
    public $purchaseRequisitionExpense;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PurchaseRequisitionExpenseList
     * @uses PurchaseRequisitionExpenseList::setPurchaseRequisitionExpense()
     * @uses PurchaseRequisitionExpenseList::setReplaceAll()
     * @param \StructType\PurchaseRequisitionExpense[] $purchaseRequisitionExpense
     * @param bool $replaceAll
     */
    public function __construct(array $purchaseRequisitionExpense = array(), $replaceAll = true)
    {
        $this
            ->setPurchaseRequisitionExpense($purchaseRequisitionExpense)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get purchaseRequisitionExpense value
     * @return \StructType\PurchaseRequisitionExpense[]|null
     */
    public function getPurchaseRequisitionExpense()
    {
        return $this->purchaseRequisitionExpense;
    }
    /**
     * This method is responsible for validating the values passed to the setPurchaseRequisitionExpense method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPurchaseRequisitionExpense method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePurchaseRequisitionExpenseForArrayConstraintsFromSetPurchaseRequisitionExpense(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $purchaseRequisitionExpenseListPurchaseRequisitionExpenseItem) {
            // validation for constraint: itemType
            if (!$purchaseRequisitionExpenseListPurchaseRequisitionExpenseItem instanceof \StructType\PurchaseRequisitionExpense) {
                $invalidValues[] = is_object($purchaseRequisitionExpenseListPurchaseRequisitionExpenseItem) ? get_class($purchaseRequisitionExpenseListPurchaseRequisitionExpenseItem) : sprintf('%s(%s)', gettype($purchaseRequisitionExpenseListPurchaseRequisitionExpenseItem), var_export($purchaseRequisitionExpenseListPurchaseRequisitionExpenseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The purchaseRequisitionExpense property can only contain items of type \StructType\PurchaseRequisitionExpense, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set purchaseRequisitionExpense value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseRequisitionExpense[] $purchaseRequisitionExpense
     * @return \StructType\PurchaseRequisitionExpenseList
     */
    public function setPurchaseRequisitionExpense(array $purchaseRequisitionExpense = array())
    {
        // validation for constraint: array
        if ('' !== ($purchaseRequisitionExpenseArrayErrorMessage = self::validatePurchaseRequisitionExpenseForArrayConstraintsFromSetPurchaseRequisitionExpense($purchaseRequisitionExpense))) {
            throw new \InvalidArgumentException($purchaseRequisitionExpenseArrayErrorMessage, __LINE__);
        }
        $this->purchaseRequisitionExpense = $purchaseRequisitionExpense;
        return $this;
    }
    /**
     * Add item to purchaseRequisitionExpense value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseRequisitionExpense $item
     * @return \StructType\PurchaseRequisitionExpenseList
     */
    public function addToPurchaseRequisitionExpense(\StructType\PurchaseRequisitionExpense $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PurchaseRequisitionExpense) {
            throw new \InvalidArgumentException(sprintf('The purchaseRequisitionExpense property can only contain items of type \StructType\PurchaseRequisitionExpense, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->purchaseRequisitionExpense[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PurchaseRequisitionExpenseList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
