<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RevRecScheduleSearch StructType
 * @subpackage Structs
 */
class RevRecScheduleSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RevRecScheduleSearchBasic
     */
    public $basic;
    /**
     * The appliedToTransactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $appliedToTransactionJoin;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchBasic
     */
    public $customerJoin;
    /**
     * The itemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchBasic
     */
    public $itemJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * Constructor method for RevRecScheduleSearch
     * @uses RevRecScheduleSearch::setBasic()
     * @uses RevRecScheduleSearch::setAppliedToTransactionJoin()
     * @uses RevRecScheduleSearch::setCustomerJoin()
     * @uses RevRecScheduleSearch::setItemJoin()
     * @uses RevRecScheduleSearch::setTransactionJoin()
     * @uses RevRecScheduleSearch::setUserJoin()
     * @param \StructType\RevRecScheduleSearchBasic $basic
     * @param \StructType\TransactionSearchBasic $appliedToTransactionJoin
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @param \StructType\ItemSearchBasic $itemJoin
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     */
    public function __construct(\StructType\RevRecScheduleSearchBasic $basic = null, \StructType\TransactionSearchBasic $appliedToTransactionJoin = null, \StructType\CustomerSearchBasic $customerJoin = null, \StructType\ItemSearchBasic $itemJoin = null, \StructType\TransactionSearchBasic $transactionJoin = null, \StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this
            ->setBasic($basic)
            ->setAppliedToTransactionJoin($appliedToTransactionJoin)
            ->setCustomerJoin($customerJoin)
            ->setItemJoin($itemJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin);
    }
    /**
     * Get basic value
     * @return \StructType\RevRecScheduleSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\RevRecScheduleSearchBasic $basic
     * @return \StructType\RevRecScheduleSearch
     */
    public function setBasic(\StructType\RevRecScheduleSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get appliedToTransactionJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getAppliedToTransactionJoin()
    {
        return $this->appliedToTransactionJoin;
    }
    /**
     * Set appliedToTransactionJoin value
     * @param \StructType\TransactionSearchBasic $appliedToTransactionJoin
     * @return \StructType\RevRecScheduleSearch
     */
    public function setAppliedToTransactionJoin(\StructType\TransactionSearchBasic $appliedToTransactionJoin = null)
    {
        $this->appliedToTransactionJoin = $appliedToTransactionJoin;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @return \StructType\RevRecScheduleSearch
     */
    public function setCustomerJoin(\StructType\CustomerSearchBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get itemJoin value
     * @return \StructType\ItemSearchBasic|null
     */
    public function getItemJoin()
    {
        return $this->itemJoin;
    }
    /**
     * Set itemJoin value
     * @param \StructType\ItemSearchBasic $itemJoin
     * @return \StructType\RevRecScheduleSearch
     */
    public function setItemJoin(\StructType\ItemSearchBasic $itemJoin = null)
    {
        $this->itemJoin = $itemJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @return \StructType\RevRecScheduleSearch
     */
    public function setTransactionJoin(\StructType\TransactionSearchBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\RevRecScheduleSearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
}
