<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RevRecScheduleSearchRow StructType
 * @subpackage Structs
 */
class RevRecScheduleSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RevRecScheduleSearchRowBasic
     */
    public $basic;
    /**
     * The appliedToTransactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $appliedToTransactionJoin;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $customerJoin;
    /**
     * The itemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $itemJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * Constructor method for RevRecScheduleSearchRow
     * @uses RevRecScheduleSearchRow::setBasic()
     * @uses RevRecScheduleSearchRow::setAppliedToTransactionJoin()
     * @uses RevRecScheduleSearchRow::setCustomerJoin()
     * @uses RevRecScheduleSearchRow::setItemJoin()
     * @uses RevRecScheduleSearchRow::setTransactionJoin()
     * @uses RevRecScheduleSearchRow::setUserJoin()
     * @param \StructType\RevRecScheduleSearchRowBasic $basic
     * @param \StructType\TransactionSearchRowBasic $appliedToTransactionJoin
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     */
    public function __construct(\StructType\RevRecScheduleSearchRowBasic $basic = null, \StructType\TransactionSearchRowBasic $appliedToTransactionJoin = null, \StructType\CustomerSearchRowBasic $customerJoin = null, \StructType\ItemSearchRowBasic $itemJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this
            ->setBasic($basic)
            ->setAppliedToTransactionJoin($appliedToTransactionJoin)
            ->setCustomerJoin($customerJoin)
            ->setItemJoin($itemJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin);
    }
    /**
     * Get basic value
     * @return \StructType\RevRecScheduleSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\RevRecScheduleSearchRowBasic $basic
     * @return \StructType\RevRecScheduleSearchRow
     */
    public function setBasic(\StructType\RevRecScheduleSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get appliedToTransactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getAppliedToTransactionJoin()
    {
        return $this->appliedToTransactionJoin;
    }
    /**
     * Set appliedToTransactionJoin value
     * @param \StructType\TransactionSearchRowBasic $appliedToTransactionJoin
     * @return \StructType\RevRecScheduleSearchRow
     */
    public function setAppliedToTransactionJoin(\StructType\TransactionSearchRowBasic $appliedToTransactionJoin = null)
    {
        $this->appliedToTransactionJoin = $appliedToTransactionJoin;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @return \StructType\RevRecScheduleSearchRow
     */
    public function setCustomerJoin(\StructType\CustomerSearchRowBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get itemJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getItemJoin()
    {
        return $this->itemJoin;
    }
    /**
     * Set itemJoin value
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @return \StructType\RevRecScheduleSearchRow
     */
    public function setItemJoin(\StructType\ItemSearchRowBasic $itemJoin = null)
    {
        $this->itemJoin = $itemJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\RevRecScheduleSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\RevRecScheduleSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
}
