<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchColumnLongField StructType
 * @subpackage Structs
 */
class SearchColumnLongField extends SearchColumnField
{
    /**
     * The searchValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $searchValue;
    /**
     * Constructor method for SearchColumnLongField
     * @uses SearchColumnLongField::setSearchValue()
     * @param int $searchValue
     */
    public function __construct($searchValue = null)
    {
        $this
            ->setSearchValue($searchValue);
    }
    /**
     * Get searchValue value
     * @return int|null
     */
    public function getSearchValue()
    {
        return $this->searchValue;
    }
    /**
     * Set searchValue value
     * @param int $searchValue
     * @return \StructType\SearchColumnLongField
     */
    public function setSearchValue($searchValue = null)
    {
        // validation for constraint: int
        if (!is_null($searchValue) && !(is_int($searchValue) || ctype_digit($searchValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($searchValue, true), gettype($searchValue)), __LINE__);
        }
        $this->searchValue = $searchValue;
        return $this;
    }
}
