<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SerializedAssemblyItemBillOfMaterialsList StructType
 * @subpackage Structs
 */
class SerializedAssemblyItemBillOfMaterialsList extends AbstractStructBase
{
    /**
     * The serializedAssemblyItemBillOfMaterials
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SerializedAssemblyItemBillOfMaterials[]
     */
    public $serializedAssemblyItemBillOfMaterials;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for SerializedAssemblyItemBillOfMaterialsList
     * @uses SerializedAssemblyItemBillOfMaterialsList::setSerializedAssemblyItemBillOfMaterials()
     * @uses SerializedAssemblyItemBillOfMaterialsList::setReplaceAll()
     * @param \StructType\SerializedAssemblyItemBillOfMaterials[] $serializedAssemblyItemBillOfMaterials
     * @param bool $replaceAll
     */
    public function __construct(array $serializedAssemblyItemBillOfMaterials = array(), $replaceAll = true)
    {
        $this
            ->setSerializedAssemblyItemBillOfMaterials($serializedAssemblyItemBillOfMaterials)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get serializedAssemblyItemBillOfMaterials value
     * @return \StructType\SerializedAssemblyItemBillOfMaterials[]|null
     */
    public function getSerializedAssemblyItemBillOfMaterials()
    {
        return $this->serializedAssemblyItemBillOfMaterials;
    }
    /**
     * This method is responsible for validating the values passed to the setSerializedAssemblyItemBillOfMaterials method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSerializedAssemblyItemBillOfMaterials method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSerializedAssemblyItemBillOfMaterialsForArrayConstraintsFromSetSerializedAssemblyItemBillOfMaterials(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $serializedAssemblyItemBillOfMaterialsListSerializedAssemblyItemBillOfMaterialsItem) {
            // validation for constraint: itemType
            if (!$serializedAssemblyItemBillOfMaterialsListSerializedAssemblyItemBillOfMaterialsItem instanceof \StructType\SerializedAssemblyItemBillOfMaterials) {
                $invalidValues[] = is_object($serializedAssemblyItemBillOfMaterialsListSerializedAssemblyItemBillOfMaterialsItem) ? get_class($serializedAssemblyItemBillOfMaterialsListSerializedAssemblyItemBillOfMaterialsItem) : sprintf('%s(%s)', gettype($serializedAssemblyItemBillOfMaterialsListSerializedAssemblyItemBillOfMaterialsItem), var_export($serializedAssemblyItemBillOfMaterialsListSerializedAssemblyItemBillOfMaterialsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The serializedAssemblyItemBillOfMaterials property can only contain items of type \StructType\SerializedAssemblyItemBillOfMaterials, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set serializedAssemblyItemBillOfMaterials value
     * @throws \InvalidArgumentException
     * @param \StructType\SerializedAssemblyItemBillOfMaterials[] $serializedAssemblyItemBillOfMaterials
     * @return \StructType\SerializedAssemblyItemBillOfMaterialsList
     */
    public function setSerializedAssemblyItemBillOfMaterials(array $serializedAssemblyItemBillOfMaterials = array())
    {
        // validation for constraint: array
        if ('' !== ($serializedAssemblyItemBillOfMaterialsArrayErrorMessage = self::validateSerializedAssemblyItemBillOfMaterialsForArrayConstraintsFromSetSerializedAssemblyItemBillOfMaterials($serializedAssemblyItemBillOfMaterials))) {
            throw new \InvalidArgumentException($serializedAssemblyItemBillOfMaterialsArrayErrorMessage, __LINE__);
        }
        $this->serializedAssemblyItemBillOfMaterials = $serializedAssemblyItemBillOfMaterials;
        return $this;
    }
    /**
     * Add item to serializedAssemblyItemBillOfMaterials value
     * @throws \InvalidArgumentException
     * @param \StructType\SerializedAssemblyItemBillOfMaterials $item
     * @return \StructType\SerializedAssemblyItemBillOfMaterialsList
     */
    public function addToSerializedAssemblyItemBillOfMaterials(\StructType\SerializedAssemblyItemBillOfMaterials $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SerializedAssemblyItemBillOfMaterials) {
            throw new \InvalidArgumentException(sprintf('The serializedAssemblyItemBillOfMaterials property can only contain items of type \StructType\SerializedAssemblyItemBillOfMaterials, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->serializedAssemblyItemBillOfMaterials[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\SerializedAssemblyItemBillOfMaterialsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
