<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SerializedInventoryItemHierarchyVersionsList StructType
 * @subpackage Structs
 */
class SerializedInventoryItemHierarchyVersionsList extends AbstractStructBase
{
    /**
     * The serializedInventoryItemHierarchyVersions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SerializedInventoryItemHierarchyVersions[]
     */
    public $serializedInventoryItemHierarchyVersions;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for SerializedInventoryItemHierarchyVersionsList
     * @uses SerializedInventoryItemHierarchyVersionsList::setSerializedInventoryItemHierarchyVersions()
     * @uses SerializedInventoryItemHierarchyVersionsList::setReplaceAll()
     * @param \StructType\SerializedInventoryItemHierarchyVersions[] $serializedInventoryItemHierarchyVersions
     * @param bool $replaceAll
     */
    public function __construct(array $serializedInventoryItemHierarchyVersions = array(), $replaceAll = true)
    {
        $this
            ->setSerializedInventoryItemHierarchyVersions($serializedInventoryItemHierarchyVersions)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get serializedInventoryItemHierarchyVersions value
     * @return \StructType\SerializedInventoryItemHierarchyVersions[]|null
     */
    public function getSerializedInventoryItemHierarchyVersions()
    {
        return $this->serializedInventoryItemHierarchyVersions;
    }
    /**
     * This method is responsible for validating the values passed to the setSerializedInventoryItemHierarchyVersions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSerializedInventoryItemHierarchyVersions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSerializedInventoryItemHierarchyVersionsForArrayConstraintsFromSetSerializedInventoryItemHierarchyVersions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $serializedInventoryItemHierarchyVersionsListSerializedInventoryItemHierarchyVersionsItem) {
            // validation for constraint: itemType
            if (!$serializedInventoryItemHierarchyVersionsListSerializedInventoryItemHierarchyVersionsItem instanceof \StructType\SerializedInventoryItemHierarchyVersions) {
                $invalidValues[] = is_object($serializedInventoryItemHierarchyVersionsListSerializedInventoryItemHierarchyVersionsItem) ? get_class($serializedInventoryItemHierarchyVersionsListSerializedInventoryItemHierarchyVersionsItem) : sprintf('%s(%s)', gettype($serializedInventoryItemHierarchyVersionsListSerializedInventoryItemHierarchyVersionsItem), var_export($serializedInventoryItemHierarchyVersionsListSerializedInventoryItemHierarchyVersionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The serializedInventoryItemHierarchyVersions property can only contain items of type \StructType\SerializedInventoryItemHierarchyVersions, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set serializedInventoryItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\SerializedInventoryItemHierarchyVersions[] $serializedInventoryItemHierarchyVersions
     * @return \StructType\SerializedInventoryItemHierarchyVersionsList
     */
    public function setSerializedInventoryItemHierarchyVersions(array $serializedInventoryItemHierarchyVersions = array())
    {
        // validation for constraint: array
        if ('' !== ($serializedInventoryItemHierarchyVersionsArrayErrorMessage = self::validateSerializedInventoryItemHierarchyVersionsForArrayConstraintsFromSetSerializedInventoryItemHierarchyVersions($serializedInventoryItemHierarchyVersions))) {
            throw new \InvalidArgumentException($serializedInventoryItemHierarchyVersionsArrayErrorMessage, __LINE__);
        }
        $this->serializedInventoryItemHierarchyVersions = $serializedInventoryItemHierarchyVersions;
        return $this;
    }
    /**
     * Add item to serializedInventoryItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\SerializedInventoryItemHierarchyVersions $item
     * @return \StructType\SerializedInventoryItemHierarchyVersionsList
     */
    public function addToSerializedInventoryItemHierarchyVersions(\StructType\SerializedInventoryItemHierarchyVersions $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SerializedInventoryItemHierarchyVersions) {
            throw new \InvalidArgumentException(sprintf('The serializedInventoryItemHierarchyVersions property can only contain items of type \StructType\SerializedInventoryItemHierarchyVersions, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->serializedInventoryItemHierarchyVersions[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\SerializedInventoryItemHierarchyVersionsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
