<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServicePurchaseItemHierarchyVersionsList StructType
 * @subpackage Structs
 */
class ServicePurchaseItemHierarchyVersionsList extends AbstractStructBase
{
    /**
     * The servicePurchaseItemHierarchyVersions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServicePurchaseItemHierarchyVersions[]
     */
    public $servicePurchaseItemHierarchyVersions;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for ServicePurchaseItemHierarchyVersionsList
     * @uses ServicePurchaseItemHierarchyVersionsList::setServicePurchaseItemHierarchyVersions()
     * @uses ServicePurchaseItemHierarchyVersionsList::setReplaceAll()
     * @param \StructType\ServicePurchaseItemHierarchyVersions[] $servicePurchaseItemHierarchyVersions
     * @param bool $replaceAll
     */
    public function __construct(array $servicePurchaseItemHierarchyVersions = array(), $replaceAll = true)
    {
        $this
            ->setServicePurchaseItemHierarchyVersions($servicePurchaseItemHierarchyVersions)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get servicePurchaseItemHierarchyVersions value
     * @return \StructType\ServicePurchaseItemHierarchyVersions[]|null
     */
    public function getServicePurchaseItemHierarchyVersions()
    {
        return $this->servicePurchaseItemHierarchyVersions;
    }
    /**
     * This method is responsible for validating the values passed to the setServicePurchaseItemHierarchyVersions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServicePurchaseItemHierarchyVersions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServicePurchaseItemHierarchyVersionsForArrayConstraintsFromSetServicePurchaseItemHierarchyVersions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $servicePurchaseItemHierarchyVersionsListServicePurchaseItemHierarchyVersionsItem) {
            // validation for constraint: itemType
            if (!$servicePurchaseItemHierarchyVersionsListServicePurchaseItemHierarchyVersionsItem instanceof \StructType\ServicePurchaseItemHierarchyVersions) {
                $invalidValues[] = is_object($servicePurchaseItemHierarchyVersionsListServicePurchaseItemHierarchyVersionsItem) ? get_class($servicePurchaseItemHierarchyVersionsListServicePurchaseItemHierarchyVersionsItem) : sprintf('%s(%s)', gettype($servicePurchaseItemHierarchyVersionsListServicePurchaseItemHierarchyVersionsItem), var_export($servicePurchaseItemHierarchyVersionsListServicePurchaseItemHierarchyVersionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The servicePurchaseItemHierarchyVersions property can only contain items of type \StructType\ServicePurchaseItemHierarchyVersions, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set servicePurchaseItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePurchaseItemHierarchyVersions[] $servicePurchaseItemHierarchyVersions
     * @return \StructType\ServicePurchaseItemHierarchyVersionsList
     */
    public function setServicePurchaseItemHierarchyVersions(array $servicePurchaseItemHierarchyVersions = array())
    {
        // validation for constraint: array
        if ('' !== ($servicePurchaseItemHierarchyVersionsArrayErrorMessage = self::validateServicePurchaseItemHierarchyVersionsForArrayConstraintsFromSetServicePurchaseItemHierarchyVersions($servicePurchaseItemHierarchyVersions))) {
            throw new \InvalidArgumentException($servicePurchaseItemHierarchyVersionsArrayErrorMessage, __LINE__);
        }
        $this->servicePurchaseItemHierarchyVersions = $servicePurchaseItemHierarchyVersions;
        return $this;
    }
    /**
     * Add item to servicePurchaseItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\ServicePurchaseItemHierarchyVersions $item
     * @return \StructType\ServicePurchaseItemHierarchyVersionsList
     */
    public function addToServicePurchaseItemHierarchyVersions(\StructType\ServicePurchaseItemHierarchyVersions $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServicePurchaseItemHierarchyVersions) {
            throw new \InvalidArgumentException(sprintf('The servicePurchaseItemHierarchyVersions property can only contain items of type \StructType\ServicePurchaseItemHierarchyVersions, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->servicePurchaseItemHierarchyVersions[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\ServicePurchaseItemHierarchyVersionsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
