<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceResaleItemHierarchyVersionsList StructType
 * @subpackage Structs
 */
class ServiceResaleItemHierarchyVersionsList extends AbstractStructBase
{
    /**
     * The serviceResaleItemHierarchyVersions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ServiceResaleItemHierarchyVersions[]
     */
    public $serviceResaleItemHierarchyVersions;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for ServiceResaleItemHierarchyVersionsList
     * @uses ServiceResaleItemHierarchyVersionsList::setServiceResaleItemHierarchyVersions()
     * @uses ServiceResaleItemHierarchyVersionsList::setReplaceAll()
     * @param \StructType\ServiceResaleItemHierarchyVersions[] $serviceResaleItemHierarchyVersions
     * @param bool $replaceAll
     */
    public function __construct(array $serviceResaleItemHierarchyVersions = array(), $replaceAll = true)
    {
        $this
            ->setServiceResaleItemHierarchyVersions($serviceResaleItemHierarchyVersions)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get serviceResaleItemHierarchyVersions value
     * @return \StructType\ServiceResaleItemHierarchyVersions[]|null
     */
    public function getServiceResaleItemHierarchyVersions()
    {
        return $this->serviceResaleItemHierarchyVersions;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceResaleItemHierarchyVersions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceResaleItemHierarchyVersions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceResaleItemHierarchyVersionsForArrayConstraintsFromSetServiceResaleItemHierarchyVersions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $serviceResaleItemHierarchyVersionsListServiceResaleItemHierarchyVersionsItem) {
            // validation for constraint: itemType
            if (!$serviceResaleItemHierarchyVersionsListServiceResaleItemHierarchyVersionsItem instanceof \StructType\ServiceResaleItemHierarchyVersions) {
                $invalidValues[] = is_object($serviceResaleItemHierarchyVersionsListServiceResaleItemHierarchyVersionsItem) ? get_class($serviceResaleItemHierarchyVersionsListServiceResaleItemHierarchyVersionsItem) : sprintf('%s(%s)', gettype($serviceResaleItemHierarchyVersionsListServiceResaleItemHierarchyVersionsItem), var_export($serviceResaleItemHierarchyVersionsListServiceResaleItemHierarchyVersionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The serviceResaleItemHierarchyVersions property can only contain items of type \StructType\ServiceResaleItemHierarchyVersions, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set serviceResaleItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceResaleItemHierarchyVersions[] $serviceResaleItemHierarchyVersions
     * @return \StructType\ServiceResaleItemHierarchyVersionsList
     */
    public function setServiceResaleItemHierarchyVersions(array $serviceResaleItemHierarchyVersions = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceResaleItemHierarchyVersionsArrayErrorMessage = self::validateServiceResaleItemHierarchyVersionsForArrayConstraintsFromSetServiceResaleItemHierarchyVersions($serviceResaleItemHierarchyVersions))) {
            throw new \InvalidArgumentException($serviceResaleItemHierarchyVersionsArrayErrorMessage, __LINE__);
        }
        $this->serviceResaleItemHierarchyVersions = $serviceResaleItemHierarchyVersions;
        return $this;
    }
    /**
     * Add item to serviceResaleItemHierarchyVersions value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceResaleItemHierarchyVersions $item
     * @return \StructType\ServiceResaleItemHierarchyVersionsList
     */
    public function addToServiceResaleItemHierarchyVersions(\StructType\ServiceResaleItemHierarchyVersions $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceResaleItemHierarchyVersions) {
            throw new \InvalidArgumentException(sprintf('The serviceResaleItemHierarchyVersions property can only contain items of type \StructType\ServiceResaleItemHierarchyVersions, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->serviceResaleItemHierarchyVersions[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\ServiceResaleItemHierarchyVersionsList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
