<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SolutionSearchRow StructType
 * @subpackage Structs
 */
class SolutionSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SolutionSearchRowBasic
     */
    public $basic;
    /**
     * The caseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SupportCaseSearchRowBasic
     */
    public $caseJoin;
    /**
     * The relatedSolutionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SolutionSearchRowBasic
     */
    public $relatedSolutionJoin;
    /**
     * The topicJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TopicSearchRowBasic
     */
    public $topicJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for SolutionSearchRow
     * @uses SolutionSearchRow::setBasic()
     * @uses SolutionSearchRow::setCaseJoin()
     * @uses SolutionSearchRow::setRelatedSolutionJoin()
     * @uses SolutionSearchRow::setTopicJoin()
     * @uses SolutionSearchRow::setUserJoin()
     * @uses SolutionSearchRow::setUserNotesJoin()
     * @uses SolutionSearchRow::setCustomSearchJoin()
     * @param \StructType\SolutionSearchRowBasic $basic
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @param \StructType\SolutionSearchRowBasic $relatedSolutionJoin
     * @param \StructType\TopicSearchRowBasic $topicJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\SolutionSearchRowBasic $basic = null, \StructType\SupportCaseSearchRowBasic $caseJoin = null, \StructType\SolutionSearchRowBasic $relatedSolutionJoin = null, \StructType\TopicSearchRowBasic $topicJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCaseJoin($caseJoin)
            ->setRelatedSolutionJoin($relatedSolutionJoin)
            ->setTopicJoin($topicJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\SolutionSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\SolutionSearchRowBasic $basic
     * @return \StructType\SolutionSearchRow
     */
    public function setBasic(\StructType\SolutionSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get caseJoin value
     * @return \StructType\SupportCaseSearchRowBasic|null
     */
    public function getCaseJoin()
    {
        return $this->caseJoin;
    }
    /**
     * Set caseJoin value
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @return \StructType\SolutionSearchRow
     */
    public function setCaseJoin(\StructType\SupportCaseSearchRowBasic $caseJoin = null)
    {
        $this->caseJoin = $caseJoin;
        return $this;
    }
    /**
     * Get relatedSolutionJoin value
     * @return \StructType\SolutionSearchRowBasic|null
     */
    public function getRelatedSolutionJoin()
    {
        return $this->relatedSolutionJoin;
    }
    /**
     * Set relatedSolutionJoin value
     * @param \StructType\SolutionSearchRowBasic $relatedSolutionJoin
     * @return \StructType\SolutionSearchRow
     */
    public function setRelatedSolutionJoin(\StructType\SolutionSearchRowBasic $relatedSolutionJoin = null)
    {
        $this->relatedSolutionJoin = $relatedSolutionJoin;
        return $this;
    }
    /**
     * Get topicJoin value
     * @return \StructType\TopicSearchRowBasic|null
     */
    public function getTopicJoin()
    {
        return $this->topicJoin;
    }
    /**
     * Set topicJoin value
     * @param \StructType\TopicSearchRowBasic $topicJoin
     * @return \StructType\SolutionSearchRow
     */
    public function setTopicJoin(\StructType\TopicSearchRowBasic $topicJoin = null)
    {
        $this->topicJoin = $topicJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\SolutionSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\SolutionSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $solutionSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$solutionSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($solutionSearchRowCustomSearchJoinItem) ? get_class($solutionSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($solutionSearchRowCustomSearchJoinItem), var_export($solutionSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\SolutionSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\SolutionSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
