<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StatisticalJournalEntryLineList StructType
 * @subpackage Structs
 */
class StatisticalJournalEntryLineList extends AbstractStructBase
{
    /**
     * The statisticalJournalEntryLine
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\StatisticalJournalEntryLine[]
     */
    public $statisticalJournalEntryLine;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for StatisticalJournalEntryLineList
     * @uses StatisticalJournalEntryLineList::setStatisticalJournalEntryLine()
     * @uses StatisticalJournalEntryLineList::setReplaceAll()
     * @param \StructType\StatisticalJournalEntryLine[] $statisticalJournalEntryLine
     * @param bool $replaceAll
     */
    public function __construct(array $statisticalJournalEntryLine = array(), $replaceAll = true)
    {
        $this
            ->setStatisticalJournalEntryLine($statisticalJournalEntryLine)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get statisticalJournalEntryLine value
     * @return \StructType\StatisticalJournalEntryLine[]|null
     */
    public function getStatisticalJournalEntryLine()
    {
        return $this->statisticalJournalEntryLine;
    }
    /**
     * This method is responsible for validating the values passed to the setStatisticalJournalEntryLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStatisticalJournalEntryLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStatisticalJournalEntryLineForArrayConstraintsFromSetStatisticalJournalEntryLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $statisticalJournalEntryLineListStatisticalJournalEntryLineItem) {
            // validation for constraint: itemType
            if (!$statisticalJournalEntryLineListStatisticalJournalEntryLineItem instanceof \StructType\StatisticalJournalEntryLine) {
                $invalidValues[] = is_object($statisticalJournalEntryLineListStatisticalJournalEntryLineItem) ? get_class($statisticalJournalEntryLineListStatisticalJournalEntryLineItem) : sprintf('%s(%s)', gettype($statisticalJournalEntryLineListStatisticalJournalEntryLineItem), var_export($statisticalJournalEntryLineListStatisticalJournalEntryLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The statisticalJournalEntryLine property can only contain items of type \StructType\StatisticalJournalEntryLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set statisticalJournalEntryLine value
     * @throws \InvalidArgumentException
     * @param \StructType\StatisticalJournalEntryLine[] $statisticalJournalEntryLine
     * @return \StructType\StatisticalJournalEntryLineList
     */
    public function setStatisticalJournalEntryLine(array $statisticalJournalEntryLine = array())
    {
        // validation for constraint: array
        if ('' !== ($statisticalJournalEntryLineArrayErrorMessage = self::validateStatisticalJournalEntryLineForArrayConstraintsFromSetStatisticalJournalEntryLine($statisticalJournalEntryLine))) {
            throw new \InvalidArgumentException($statisticalJournalEntryLineArrayErrorMessage, __LINE__);
        }
        $this->statisticalJournalEntryLine = $statisticalJournalEntryLine;
        return $this;
    }
    /**
     * Add item to statisticalJournalEntryLine value
     * @throws \InvalidArgumentException
     * @param \StructType\StatisticalJournalEntryLine $item
     * @return \StructType\StatisticalJournalEntryLineList
     */
    public function addToStatisticalJournalEntryLine(\StructType\StatisticalJournalEntryLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StatisticalJournalEntryLine) {
            throw new \InvalidArgumentException(sprintf('The statisticalJournalEntryLine property can only contain items of type \StructType\StatisticalJournalEntryLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->statisticalJournalEntryLine[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\StatisticalJournalEntryLineList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
