<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubsidiaryAccountingBookDetailList StructType
 * @subpackage Structs
 */
class SubsidiaryAccountingBookDetailList extends AbstractStructBase
{
    /**
     * The subsidiaryAccountingBookDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SubsidiaryAccountingBookDetail[]
     */
    public $subsidiaryAccountingBookDetail;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for SubsidiaryAccountingBookDetailList
     * @uses SubsidiaryAccountingBookDetailList::setSubsidiaryAccountingBookDetail()
     * @uses SubsidiaryAccountingBookDetailList::setReplaceAll()
     * @param \StructType\SubsidiaryAccountingBookDetail[] $subsidiaryAccountingBookDetail
     * @param bool $replaceAll
     */
    public function __construct(array $subsidiaryAccountingBookDetail = array(), $replaceAll = true)
    {
        $this
            ->setSubsidiaryAccountingBookDetail($subsidiaryAccountingBookDetail)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get subsidiaryAccountingBookDetail value
     * @return \StructType\SubsidiaryAccountingBookDetail[]|null
     */
    public function getSubsidiaryAccountingBookDetail()
    {
        return $this->subsidiaryAccountingBookDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setSubsidiaryAccountingBookDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubsidiaryAccountingBookDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubsidiaryAccountingBookDetailForArrayConstraintsFromSetSubsidiaryAccountingBookDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $subsidiaryAccountingBookDetailListSubsidiaryAccountingBookDetailItem) {
            // validation for constraint: itemType
            if (!$subsidiaryAccountingBookDetailListSubsidiaryAccountingBookDetailItem instanceof \StructType\SubsidiaryAccountingBookDetail) {
                $invalidValues[] = is_object($subsidiaryAccountingBookDetailListSubsidiaryAccountingBookDetailItem) ? get_class($subsidiaryAccountingBookDetailListSubsidiaryAccountingBookDetailItem) : sprintf('%s(%s)', gettype($subsidiaryAccountingBookDetailListSubsidiaryAccountingBookDetailItem), var_export($subsidiaryAccountingBookDetailListSubsidiaryAccountingBookDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The subsidiaryAccountingBookDetail property can only contain items of type \StructType\SubsidiaryAccountingBookDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set subsidiaryAccountingBookDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\SubsidiaryAccountingBookDetail[] $subsidiaryAccountingBookDetail
     * @return \StructType\SubsidiaryAccountingBookDetailList
     */
    public function setSubsidiaryAccountingBookDetail(array $subsidiaryAccountingBookDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($subsidiaryAccountingBookDetailArrayErrorMessage = self::validateSubsidiaryAccountingBookDetailForArrayConstraintsFromSetSubsidiaryAccountingBookDetail($subsidiaryAccountingBookDetail))) {
            throw new \InvalidArgumentException($subsidiaryAccountingBookDetailArrayErrorMessage, __LINE__);
        }
        $this->subsidiaryAccountingBookDetail = $subsidiaryAccountingBookDetail;
        return $this;
    }
    /**
     * Add item to subsidiaryAccountingBookDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\SubsidiaryAccountingBookDetail $item
     * @return \StructType\SubsidiaryAccountingBookDetailList
     */
    public function addToSubsidiaryAccountingBookDetail(\StructType\SubsidiaryAccountingBookDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubsidiaryAccountingBookDetail) {
            throw new \InvalidArgumentException(sprintf('The subsidiaryAccountingBookDetail property can only contain items of type \StructType\SubsidiaryAccountingBookDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->subsidiaryAccountingBookDetail[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\SubsidiaryAccountingBookDetailList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
