<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SubsidiarySearch StructType
 * @subpackage Structs
 */
class SubsidiarySearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubsidiarySearchBasic
     */
    public $basic;
    /**
     * The addressJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AddressSearchBasic
     */
    public $addressJoin;
    /**
     * The defaultAdvanceToApplyAccountJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AccountSearchBasic
     */
    public $defaultAdvanceToApplyAccountJoin;
    /**
     * The returnAddressJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AddressSearchBasic
     */
    public $returnAddressJoin;
    /**
     * The shippingAddressJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AddressSearchBasic
     */
    public $shippingAddressJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for SubsidiarySearch
     * @uses SubsidiarySearch::setBasic()
     * @uses SubsidiarySearch::setAddressJoin()
     * @uses SubsidiarySearch::setDefaultAdvanceToApplyAccountJoin()
     * @uses SubsidiarySearch::setReturnAddressJoin()
     * @uses SubsidiarySearch::setShippingAddressJoin()
     * @uses SubsidiarySearch::setUserJoin()
     * @uses SubsidiarySearch::setCustomSearchJoin()
     * @param \StructType\SubsidiarySearchBasic $basic
     * @param \StructType\AddressSearchBasic $addressJoin
     * @param \StructType\AccountSearchBasic $defaultAdvanceToApplyAccountJoin
     * @param \StructType\AddressSearchBasic $returnAddressJoin
     * @param \StructType\AddressSearchBasic $shippingAddressJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\SubsidiarySearchBasic $basic = null, \StructType\AddressSearchBasic $addressJoin = null, \StructType\AccountSearchBasic $defaultAdvanceToApplyAccountJoin = null, \StructType\AddressSearchBasic $returnAddressJoin = null, \StructType\AddressSearchBasic $shippingAddressJoin = null, \StructType\EmployeeSearchBasic $userJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setAddressJoin($addressJoin)
            ->setDefaultAdvanceToApplyAccountJoin($defaultAdvanceToApplyAccountJoin)
            ->setReturnAddressJoin($returnAddressJoin)
            ->setShippingAddressJoin($shippingAddressJoin)
            ->setUserJoin($userJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\SubsidiarySearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\SubsidiarySearchBasic $basic
     * @return \StructType\SubsidiarySearch
     */
    public function setBasic(\StructType\SubsidiarySearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get addressJoin value
     * @return \StructType\AddressSearchBasic|null
     */
    public function getAddressJoin()
    {
        return $this->addressJoin;
    }
    /**
     * Set addressJoin value
     * @param \StructType\AddressSearchBasic $addressJoin
     * @return \StructType\SubsidiarySearch
     */
    public function setAddressJoin(\StructType\AddressSearchBasic $addressJoin = null)
    {
        $this->addressJoin = $addressJoin;
        return $this;
    }
    /**
     * Get defaultAdvanceToApplyAccountJoin value
     * @return \StructType\AccountSearchBasic|null
     */
    public function getDefaultAdvanceToApplyAccountJoin()
    {
        return $this->defaultAdvanceToApplyAccountJoin;
    }
    /**
     * Set defaultAdvanceToApplyAccountJoin value
     * @param \StructType\AccountSearchBasic $defaultAdvanceToApplyAccountJoin
     * @return \StructType\SubsidiarySearch
     */
    public function setDefaultAdvanceToApplyAccountJoin(\StructType\AccountSearchBasic $defaultAdvanceToApplyAccountJoin = null)
    {
        $this->defaultAdvanceToApplyAccountJoin = $defaultAdvanceToApplyAccountJoin;
        return $this;
    }
    /**
     * Get returnAddressJoin value
     * @return \StructType\AddressSearchBasic|null
     */
    public function getReturnAddressJoin()
    {
        return $this->returnAddressJoin;
    }
    /**
     * Set returnAddressJoin value
     * @param \StructType\AddressSearchBasic $returnAddressJoin
     * @return \StructType\SubsidiarySearch
     */
    public function setReturnAddressJoin(\StructType\AddressSearchBasic $returnAddressJoin = null)
    {
        $this->returnAddressJoin = $returnAddressJoin;
        return $this;
    }
    /**
     * Get shippingAddressJoin value
     * @return \StructType\AddressSearchBasic|null
     */
    public function getShippingAddressJoin()
    {
        return $this->shippingAddressJoin;
    }
    /**
     * Set shippingAddressJoin value
     * @param \StructType\AddressSearchBasic $shippingAddressJoin
     * @return \StructType\SubsidiarySearch
     */
    public function setShippingAddressJoin(\StructType\AddressSearchBasic $shippingAddressJoin = null)
    {
        $this->shippingAddressJoin = $shippingAddressJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\SubsidiarySearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $subsidiarySearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$subsidiarySearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($subsidiarySearchCustomSearchJoinItem) ? get_class($subsidiarySearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($subsidiarySearchCustomSearchJoinItem), var_export($subsidiarySearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\SubsidiarySearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\SubsidiarySearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
