<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaxTypeNexusesTaxList StructType
 * @subpackage Structs
 */
class TaxTypeNexusesTaxList extends AbstractStructBase
{
    /**
     * The nexusesTax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\TaxTypeNexusesTax[]
     */
    public $nexusesTax;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for TaxTypeNexusesTaxList
     * @uses TaxTypeNexusesTaxList::setNexusesTax()
     * @uses TaxTypeNexusesTaxList::setReplaceAll()
     * @param \StructType\TaxTypeNexusesTax[] $nexusesTax
     * @param bool $replaceAll
     */
    public function __construct(array $nexusesTax = array(), $replaceAll = true)
    {
        $this
            ->setNexusesTax($nexusesTax)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get nexusesTax value
     * @return \StructType\TaxTypeNexusesTax[]|null
     */
    public function getNexusesTax()
    {
        return $this->nexusesTax;
    }
    /**
     * This method is responsible for validating the values passed to the setNexusesTax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNexusesTax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNexusesTaxForArrayConstraintsFromSetNexusesTax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $taxTypeNexusesTaxListNexusesTaxItem) {
            // validation for constraint: itemType
            if (!$taxTypeNexusesTaxListNexusesTaxItem instanceof \StructType\TaxTypeNexusesTax) {
                $invalidValues[] = is_object($taxTypeNexusesTaxListNexusesTaxItem) ? get_class($taxTypeNexusesTaxListNexusesTaxItem) : sprintf('%s(%s)', gettype($taxTypeNexusesTaxListNexusesTaxItem), var_export($taxTypeNexusesTaxListNexusesTaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The nexusesTax property can only contain items of type \StructType\TaxTypeNexusesTax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set nexusesTax value
     * @throws \InvalidArgumentException
     * @param \StructType\TaxTypeNexusesTax[] $nexusesTax
     * @return \StructType\TaxTypeNexusesTaxList
     */
    public function setNexusesTax(array $nexusesTax = array())
    {
        // validation for constraint: array
        if ('' !== ($nexusesTaxArrayErrorMessage = self::validateNexusesTaxForArrayConstraintsFromSetNexusesTax($nexusesTax))) {
            throw new \InvalidArgumentException($nexusesTaxArrayErrorMessage, __LINE__);
        }
        $this->nexusesTax = $nexusesTax;
        return $this;
    }
    /**
     * Add item to nexusesTax value
     * @throws \InvalidArgumentException
     * @param \StructType\TaxTypeNexusesTax $item
     * @return \StructType\TaxTypeNexusesTaxList
     */
    public function addToNexusesTax(\StructType\TaxTypeNexusesTax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TaxTypeNexusesTax) {
            throw new \InvalidArgumentException(sprintf('The nexusesTax property can only contain items of type \StructType\TaxTypeNexusesTax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->nexusesTax[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\TaxTypeNexusesTaxList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
