<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitsTypeSearchBasic StructType
 * @subpackage Structs
 */
class UnitsTypeSearchBasic extends SearchRecordBasic
{
    /**
     * The abbreviation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $abbreviation;
    /**
     * The baseUnit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $baseUnit;
    /**
     * The conversionRate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $conversionRate;
    /**
     * The externalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $externalId;
    /**
     * The externalIdString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $externalIdString;
    /**
     * The internalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $internalId;
    /**
     * The internalIdNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $internalIdNumber;
    /**
     * The isInActive
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchBooleanField
     */
    public $isInActive;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $name;
    /**
     * The pluralAbbreviation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $pluralAbbreviation;
    /**
     * The pluralName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $pluralName;
    /**
     * The unitName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $unitName;
    /**
     * Constructor method for UnitsTypeSearchBasic
     * @uses UnitsTypeSearchBasic::setAbbreviation()
     * @uses UnitsTypeSearchBasic::setBaseUnit()
     * @uses UnitsTypeSearchBasic::setConversionRate()
     * @uses UnitsTypeSearchBasic::setExternalId()
     * @uses UnitsTypeSearchBasic::setExternalIdString()
     * @uses UnitsTypeSearchBasic::setInternalId()
     * @uses UnitsTypeSearchBasic::setInternalIdNumber()
     * @uses UnitsTypeSearchBasic::setIsInActive()
     * @uses UnitsTypeSearchBasic::setName()
     * @uses UnitsTypeSearchBasic::setPluralAbbreviation()
     * @uses UnitsTypeSearchBasic::setPluralName()
     * @uses UnitsTypeSearchBasic::setUnitName()
     * @param \StructType\SearchStringField $abbreviation
     * @param \StructType\SearchBooleanField $baseUnit
     * @param \StructType\SearchStringField $conversionRate
     * @param \StructType\SearchMultiSelectField $externalId
     * @param \StructType\SearchStringField $externalIdString
     * @param \StructType\SearchMultiSelectField $internalId
     * @param \StructType\SearchLongField $internalIdNumber
     * @param \StructType\SearchBooleanField $isInActive
     * @param \StructType\SearchStringField $name
     * @param \StructType\SearchStringField $pluralAbbreviation
     * @param \StructType\SearchStringField $pluralName
     * @param \StructType\SearchStringField $unitName
     */
    public function __construct(\StructType\SearchStringField $abbreviation = null, \StructType\SearchBooleanField $baseUnit = null, \StructType\SearchStringField $conversionRate = null, \StructType\SearchMultiSelectField $externalId = null, \StructType\SearchStringField $externalIdString = null, \StructType\SearchMultiSelectField $internalId = null, \StructType\SearchLongField $internalIdNumber = null, \StructType\SearchBooleanField $isInActive = null, \StructType\SearchStringField $name = null, \StructType\SearchStringField $pluralAbbreviation = null, \StructType\SearchStringField $pluralName = null, \StructType\SearchStringField $unitName = null)
    {
        $this
            ->setAbbreviation($abbreviation)
            ->setBaseUnit($baseUnit)
            ->setConversionRate($conversionRate)
            ->setExternalId($externalId)
            ->setExternalIdString($externalIdString)
            ->setInternalId($internalId)
            ->setInternalIdNumber($internalIdNumber)
            ->setIsInActive($isInActive)
            ->setName($name)
            ->setPluralAbbreviation($pluralAbbreviation)
            ->setPluralName($pluralName)
            ->setUnitName($unitName);
    }
    /**
     * Get abbreviation value
     * @return \StructType\SearchStringField|null
     */
    public function getAbbreviation()
    {
        return $this->abbreviation;
    }
    /**
     * Set abbreviation value
     * @param \StructType\SearchStringField $abbreviation
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setAbbreviation(\StructType\SearchStringField $abbreviation = null)
    {
        $this->abbreviation = $abbreviation;
        return $this;
    }
    /**
     * Get baseUnit value
     * @return \StructType\SearchBooleanField|null
     */
    public function getBaseUnit()
    {
        return $this->baseUnit;
    }
    /**
     * Set baseUnit value
     * @param \StructType\SearchBooleanField $baseUnit
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setBaseUnit(\StructType\SearchBooleanField $baseUnit = null)
    {
        $this->baseUnit = $baseUnit;
        return $this;
    }
    /**
     * Get conversionRate value
     * @return \StructType\SearchStringField|null
     */
    public function getConversionRate()
    {
        return $this->conversionRate;
    }
    /**
     * Set conversionRate value
     * @param \StructType\SearchStringField $conversionRate
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setConversionRate(\StructType\SearchStringField $conversionRate = null)
    {
        $this->conversionRate = $conversionRate;
        return $this;
    }
    /**
     * Get externalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param \StructType\SearchMultiSelectField $externalId
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setExternalId(\StructType\SearchMultiSelectField $externalId = null)
    {
        $this->externalId = $externalId;
        return $this;
    }
    /**
     * Get externalIdString value
     * @return \StructType\SearchStringField|null
     */
    public function getExternalIdString()
    {
        return $this->externalIdString;
    }
    /**
     * Set externalIdString value
     * @param \StructType\SearchStringField $externalIdString
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setExternalIdString(\StructType\SearchStringField $externalIdString = null)
    {
        $this->externalIdString = $externalIdString;
        return $this;
    }
    /**
     * Get internalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getInternalId()
    {
        return $this->internalId;
    }
    /**
     * Set internalId value
     * @param \StructType\SearchMultiSelectField $internalId
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setInternalId(\StructType\SearchMultiSelectField $internalId = null)
    {
        $this->internalId = $internalId;
        return $this;
    }
    /**
     * Get internalIdNumber value
     * @return \StructType\SearchLongField|null
     */
    public function getInternalIdNumber()
    {
        return $this->internalIdNumber;
    }
    /**
     * Set internalIdNumber value
     * @param \StructType\SearchLongField $internalIdNumber
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setInternalIdNumber(\StructType\SearchLongField $internalIdNumber = null)
    {
        $this->internalIdNumber = $internalIdNumber;
        return $this;
    }
    /**
     * Get isInActive value
     * @return \StructType\SearchBooleanField|null
     */
    public function getIsInActive()
    {
        return $this->isInActive;
    }
    /**
     * Set isInActive value
     * @param \StructType\SearchBooleanField $isInActive
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setIsInActive(\StructType\SearchBooleanField $isInActive = null)
    {
        $this->isInActive = $isInActive;
        return $this;
    }
    /**
     * Get name value
     * @return \StructType\SearchStringField|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param \StructType\SearchStringField $name
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setName(\StructType\SearchStringField $name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get pluralAbbreviation value
     * @return \StructType\SearchStringField|null
     */
    public function getPluralAbbreviation()
    {
        return $this->pluralAbbreviation;
    }
    /**
     * Set pluralAbbreviation value
     * @param \StructType\SearchStringField $pluralAbbreviation
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setPluralAbbreviation(\StructType\SearchStringField $pluralAbbreviation = null)
    {
        $this->pluralAbbreviation = $pluralAbbreviation;
        return $this;
    }
    /**
     * Get pluralName value
     * @return \StructType\SearchStringField|null
     */
    public function getPluralName()
    {
        return $this->pluralName;
    }
    /**
     * Set pluralName value
     * @param \StructType\SearchStringField $pluralName
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setPluralName(\StructType\SearchStringField $pluralName = null)
    {
        $this->pluralName = $pluralName;
        return $this;
    }
    /**
     * Get unitName value
     * @return \StructType\SearchStringField|null
     */
    public function getUnitName()
    {
        return $this->unitName;
    }
    /**
     * Set unitName value
     * @param \StructType\SearchStringField $unitName
     * @return \StructType\UnitsTypeSearchBasic
     */
    public function setUnitName(\StructType\SearchStringField $unitName = null)
    {
        $this->unitName = $unitName;
        return $this;
    }
}
