<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UsageSearchBasic StructType
 * @subpackage Structs
 */
class UsageSearchBasic extends SearchRecordBasic
{
    /**
     * The customer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $customer;
    /**
     * The date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDateField
     */
    public $date;
    /**
     * The externalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $externalId;
    /**
     * The externalIdString
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $externalIdString;
    /**
     * The internalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $internalId;
    /**
     * The internalIdNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchLongField
     */
    public $internalIdNumber;
    /**
     * The item
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $item;
    /**
     * The memo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchStringField
     */
    public $memo;
    /**
     * The quantity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchDoubleField
     */
    public $quantity;
    /**
     * The subscription
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $subscription;
    /**
     * The subscriptionLine
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $subscriptionLine;
    /**
     * The subscriptionPlan
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchMultiSelectField
     */
    public $subscriptionPlan;
    /**
     * Constructor method for UsageSearchBasic
     * @uses UsageSearchBasic::setCustomer()
     * @uses UsageSearchBasic::setDate()
     * @uses UsageSearchBasic::setExternalId()
     * @uses UsageSearchBasic::setExternalIdString()
     * @uses UsageSearchBasic::setInternalId()
     * @uses UsageSearchBasic::setInternalIdNumber()
     * @uses UsageSearchBasic::setItem()
     * @uses UsageSearchBasic::setMemo()
     * @uses UsageSearchBasic::setQuantity()
     * @uses UsageSearchBasic::setSubscription()
     * @uses UsageSearchBasic::setSubscriptionLine()
     * @uses UsageSearchBasic::setSubscriptionPlan()
     * @param \StructType\SearchMultiSelectField $customer
     * @param \StructType\SearchDateField $date
     * @param \StructType\SearchMultiSelectField $externalId
     * @param \StructType\SearchStringField $externalIdString
     * @param \StructType\SearchMultiSelectField $internalId
     * @param \StructType\SearchLongField $internalIdNumber
     * @param \StructType\SearchMultiSelectField $item
     * @param \StructType\SearchStringField $memo
     * @param \StructType\SearchDoubleField $quantity
     * @param \StructType\SearchMultiSelectField $subscription
     * @param \StructType\SearchMultiSelectField $subscriptionLine
     * @param \StructType\SearchMultiSelectField $subscriptionPlan
     */
    public function __construct(\StructType\SearchMultiSelectField $customer = null, \StructType\SearchDateField $date = null, \StructType\SearchMultiSelectField $externalId = null, \StructType\SearchStringField $externalIdString = null, \StructType\SearchMultiSelectField $internalId = null, \StructType\SearchLongField $internalIdNumber = null, \StructType\SearchMultiSelectField $item = null, \StructType\SearchStringField $memo = null, \StructType\SearchDoubleField $quantity = null, \StructType\SearchMultiSelectField $subscription = null, \StructType\SearchMultiSelectField $subscriptionLine = null, \StructType\SearchMultiSelectField $subscriptionPlan = null)
    {
        $this
            ->setCustomer($customer)
            ->setDate($date)
            ->setExternalId($externalId)
            ->setExternalIdString($externalIdString)
            ->setInternalId($internalId)
            ->setInternalIdNumber($internalIdNumber)
            ->setItem($item)
            ->setMemo($memo)
            ->setQuantity($quantity)
            ->setSubscription($subscription)
            ->setSubscriptionLine($subscriptionLine)
            ->setSubscriptionPlan($subscriptionPlan);
    }
    /**
     * Get customer value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getCustomer()
    {
        return $this->customer;
    }
    /**
     * Set customer value
     * @param \StructType\SearchMultiSelectField $customer
     * @return \StructType\UsageSearchBasic
     */
    public function setCustomer(\StructType\SearchMultiSelectField $customer = null)
    {
        $this->customer = $customer;
        return $this;
    }
    /**
     * Get date value
     * @return \StructType\SearchDateField|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param \StructType\SearchDateField $date
     * @return \StructType\UsageSearchBasic
     */
    public function setDate(\StructType\SearchDateField $date = null)
    {
        $this->date = $date;
        return $this;
    }
    /**
     * Get externalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param \StructType\SearchMultiSelectField $externalId
     * @return \StructType\UsageSearchBasic
     */
    public function setExternalId(\StructType\SearchMultiSelectField $externalId = null)
    {
        $this->externalId = $externalId;
        return $this;
    }
    /**
     * Get externalIdString value
     * @return \StructType\SearchStringField|null
     */
    public function getExternalIdString()
    {
        return $this->externalIdString;
    }
    /**
     * Set externalIdString value
     * @param \StructType\SearchStringField $externalIdString
     * @return \StructType\UsageSearchBasic
     */
    public function setExternalIdString(\StructType\SearchStringField $externalIdString = null)
    {
        $this->externalIdString = $externalIdString;
        return $this;
    }
    /**
     * Get internalId value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getInternalId()
    {
        return $this->internalId;
    }
    /**
     * Set internalId value
     * @param \StructType\SearchMultiSelectField $internalId
     * @return \StructType\UsageSearchBasic
     */
    public function setInternalId(\StructType\SearchMultiSelectField $internalId = null)
    {
        $this->internalId = $internalId;
        return $this;
    }
    /**
     * Get internalIdNumber value
     * @return \StructType\SearchLongField|null
     */
    public function getInternalIdNumber()
    {
        return $this->internalIdNumber;
    }
    /**
     * Set internalIdNumber value
     * @param \StructType\SearchLongField $internalIdNumber
     * @return \StructType\UsageSearchBasic
     */
    public function setInternalIdNumber(\StructType\SearchLongField $internalIdNumber = null)
    {
        $this->internalIdNumber = $internalIdNumber;
        return $this;
    }
    /**
     * Get item value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getItem()
    {
        return $this->item;
    }
    /**
     * Set item value
     * @param \StructType\SearchMultiSelectField $item
     * @return \StructType\UsageSearchBasic
     */
    public function setItem(\StructType\SearchMultiSelectField $item = null)
    {
        $this->item = $item;
        return $this;
    }
    /**
     * Get memo value
     * @return \StructType\SearchStringField|null
     */
    public function getMemo()
    {
        return $this->memo;
    }
    /**
     * Set memo value
     * @param \StructType\SearchStringField $memo
     * @return \StructType\UsageSearchBasic
     */
    public function setMemo(\StructType\SearchStringField $memo = null)
    {
        $this->memo = $memo;
        return $this;
    }
    /**
     * Get quantity value
     * @return \StructType\SearchDoubleField|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param \StructType\SearchDoubleField $quantity
     * @return \StructType\UsageSearchBasic
     */
    public function setQuantity(\StructType\SearchDoubleField $quantity = null)
    {
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get subscription value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getSubscription()
    {
        return $this->subscription;
    }
    /**
     * Set subscription value
     * @param \StructType\SearchMultiSelectField $subscription
     * @return \StructType\UsageSearchBasic
     */
    public function setSubscription(\StructType\SearchMultiSelectField $subscription = null)
    {
        $this->subscription = $subscription;
        return $this;
    }
    /**
     * Get subscriptionLine value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getSubscriptionLine()
    {
        return $this->subscriptionLine;
    }
    /**
     * Set subscriptionLine value
     * @param \StructType\SearchMultiSelectField $subscriptionLine
     * @return \StructType\UsageSearchBasic
     */
    public function setSubscriptionLine(\StructType\SearchMultiSelectField $subscriptionLine = null)
    {
        $this->subscriptionLine = $subscriptionLine;
        return $this;
    }
    /**
     * Get subscriptionPlan value
     * @return \StructType\SearchMultiSelectField|null
     */
    public function getSubscriptionPlan()
    {
        return $this->subscriptionPlan;
    }
    /**
     * Set subscriptionPlan value
     * @param \StructType\SearchMultiSelectField $subscriptionPlan
     * @return \StructType\UsageSearchBasic
     */
    public function setSubscriptionPlan(\StructType\SearchMultiSelectField $subscriptionPlan = null)
    {
        $this->subscriptionPlan = $subscriptionPlan;
        return $this;
    }
}
