<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VendorSearchRow StructType
 * @subpackage Structs
 */
class VendorSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchRowBasic
     */
    public $basic;
    /**
     * The accountJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AccountSearchRowBasic
     */
    public $accountJoin;
    /**
     * The campaignResponseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchRowBasic
     */
    public $campaignResponseJoin;
    /**
     * The contactJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContactSearchRowBasic
     */
    public $contactJoin;
    /**
     * The contactPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContactSearchRowBasic
     */
    public $contactPrimaryJoin;
    /**
     * The expAccountJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AccountSearchRowBasic
     */
    public $expAccountJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchRowBasic
     */
    public $fileJoin;
    /**
     * The manufacturingLocationsJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\LocationSearchRowBasic
     */
    public $manufacturingLocationsJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesJoin;
    /**
     * The mseSubsidiaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MseSubsidiarySearchRowBasic
     */
    public $mseSubsidiaryJoin;
    /**
     * The messagesFromJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesFromJoin;
    /**
     * The messagesToJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesToJoin;
    /**
     * The taxRegistrationJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntityTaxRegistrationSearchRowBasic
     */
    public $taxRegistrationJoin;
    /**
     * The timeApproverJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $timeApproverJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for VendorSearchRow
     * @uses VendorSearchRow::setBasic()
     * @uses VendorSearchRow::setAccountJoin()
     * @uses VendorSearchRow::setCampaignResponseJoin()
     * @uses VendorSearchRow::setContactJoin()
     * @uses VendorSearchRow::setContactPrimaryJoin()
     * @uses VendorSearchRow::setExpAccountJoin()
     * @uses VendorSearchRow::setFileJoin()
     * @uses VendorSearchRow::setManufacturingLocationsJoin()
     * @uses VendorSearchRow::setMessagesJoin()
     * @uses VendorSearchRow::setMseSubsidiaryJoin()
     * @uses VendorSearchRow::setMessagesFromJoin()
     * @uses VendorSearchRow::setMessagesToJoin()
     * @uses VendorSearchRow::setTaxRegistrationJoin()
     * @uses VendorSearchRow::setTimeApproverJoin()
     * @uses VendorSearchRow::setTransactionJoin()
     * @uses VendorSearchRow::setUserJoin()
     * @uses VendorSearchRow::setUserNotesJoin()
     * @uses VendorSearchRow::setCustomSearchJoin()
     * @param \StructType\VendorSearchRowBasic $basic
     * @param \StructType\AccountSearchRowBasic $accountJoin
     * @param \StructType\CampaignSearchRowBasic $campaignResponseJoin
     * @param \StructType\ContactSearchRowBasic $contactJoin
     * @param \StructType\ContactSearchRowBasic $contactPrimaryJoin
     * @param \StructType\AccountSearchRowBasic $expAccountJoin
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @param \StructType\LocationSearchRowBasic $manufacturingLocationsJoin
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @param \StructType\MseSubsidiarySearchRowBasic $mseSubsidiaryJoin
     * @param \StructType\MessageSearchRowBasic $messagesFromJoin
     * @param \StructType\MessageSearchRowBasic $messagesToJoin
     * @param \StructType\EntityTaxRegistrationSearchRowBasic $taxRegistrationJoin
     * @param \StructType\EmployeeSearchRowBasic $timeApproverJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\VendorSearchRowBasic $basic = null, \StructType\AccountSearchRowBasic $accountJoin = null, \StructType\CampaignSearchRowBasic $campaignResponseJoin = null, \StructType\ContactSearchRowBasic $contactJoin = null, \StructType\ContactSearchRowBasic $contactPrimaryJoin = null, \StructType\AccountSearchRowBasic $expAccountJoin = null, \StructType\FileSearchRowBasic $fileJoin = null, \StructType\LocationSearchRowBasic $manufacturingLocationsJoin = null, \StructType\MessageSearchRowBasic $messagesJoin = null, \StructType\MseSubsidiarySearchRowBasic $mseSubsidiaryJoin = null, \StructType\MessageSearchRowBasic $messagesFromJoin = null, \StructType\MessageSearchRowBasic $messagesToJoin = null, \StructType\EntityTaxRegistrationSearchRowBasic $taxRegistrationJoin = null, \StructType\EmployeeSearchRowBasic $timeApproverJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setAccountJoin($accountJoin)
            ->setCampaignResponseJoin($campaignResponseJoin)
            ->setContactJoin($contactJoin)
            ->setContactPrimaryJoin($contactPrimaryJoin)
            ->setExpAccountJoin($expAccountJoin)
            ->setFileJoin($fileJoin)
            ->setManufacturingLocationsJoin($manufacturingLocationsJoin)
            ->setMessagesJoin($messagesJoin)
            ->setMseSubsidiaryJoin($mseSubsidiaryJoin)
            ->setMessagesFromJoin($messagesFromJoin)
            ->setMessagesToJoin($messagesToJoin)
            ->setTaxRegistrationJoin($taxRegistrationJoin)
            ->setTimeApproverJoin($timeApproverJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\VendorSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\VendorSearchRowBasic $basic
     * @return \StructType\VendorSearchRow
     */
    public function setBasic(\StructType\VendorSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get accountJoin value
     * @return \StructType\AccountSearchRowBasic|null
     */
    public function getAccountJoin()
    {
        return $this->accountJoin;
    }
    /**
     * Set accountJoin value
     * @param \StructType\AccountSearchRowBasic $accountJoin
     * @return \StructType\VendorSearchRow
     */
    public function setAccountJoin(\StructType\AccountSearchRowBasic $accountJoin = null)
    {
        $this->accountJoin = $accountJoin;
        return $this;
    }
    /**
     * Get campaignResponseJoin value
     * @return \StructType\CampaignSearchRowBasic|null
     */
    public function getCampaignResponseJoin()
    {
        return $this->campaignResponseJoin;
    }
    /**
     * Set campaignResponseJoin value
     * @param \StructType\CampaignSearchRowBasic $campaignResponseJoin
     * @return \StructType\VendorSearchRow
     */
    public function setCampaignResponseJoin(\StructType\CampaignSearchRowBasic $campaignResponseJoin = null)
    {
        $this->campaignResponseJoin = $campaignResponseJoin;
        return $this;
    }
    /**
     * Get contactJoin value
     * @return \StructType\ContactSearchRowBasic|null
     */
    public function getContactJoin()
    {
        return $this->contactJoin;
    }
    /**
     * Set contactJoin value
     * @param \StructType\ContactSearchRowBasic $contactJoin
     * @return \StructType\VendorSearchRow
     */
    public function setContactJoin(\StructType\ContactSearchRowBasic $contactJoin = null)
    {
        $this->contactJoin = $contactJoin;
        return $this;
    }
    /**
     * Get contactPrimaryJoin value
     * @return \StructType\ContactSearchRowBasic|null
     */
    public function getContactPrimaryJoin()
    {
        return $this->contactPrimaryJoin;
    }
    /**
     * Set contactPrimaryJoin value
     * @param \StructType\ContactSearchRowBasic $contactPrimaryJoin
     * @return \StructType\VendorSearchRow
     */
    public function setContactPrimaryJoin(\StructType\ContactSearchRowBasic $contactPrimaryJoin = null)
    {
        $this->contactPrimaryJoin = $contactPrimaryJoin;
        return $this;
    }
    /**
     * Get expAccountJoin value
     * @return \StructType\AccountSearchRowBasic|null
     */
    public function getExpAccountJoin()
    {
        return $this->expAccountJoin;
    }
    /**
     * Set expAccountJoin value
     * @param \StructType\AccountSearchRowBasic $expAccountJoin
     * @return \StructType\VendorSearchRow
     */
    public function setExpAccountJoin(\StructType\AccountSearchRowBasic $expAccountJoin = null)
    {
        $this->expAccountJoin = $expAccountJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchRowBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @return \StructType\VendorSearchRow
     */
    public function setFileJoin(\StructType\FileSearchRowBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get manufacturingLocationsJoin value
     * @return \StructType\LocationSearchRowBasic|null
     */
    public function getManufacturingLocationsJoin()
    {
        return $this->manufacturingLocationsJoin;
    }
    /**
     * Set manufacturingLocationsJoin value
     * @param \StructType\LocationSearchRowBasic $manufacturingLocationsJoin
     * @return \StructType\VendorSearchRow
     */
    public function setManufacturingLocationsJoin(\StructType\LocationSearchRowBasic $manufacturingLocationsJoin = null)
    {
        $this->manufacturingLocationsJoin = $manufacturingLocationsJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @return \StructType\VendorSearchRow
     */
    public function setMessagesJoin(\StructType\MessageSearchRowBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get mseSubsidiaryJoin value
     * @return \StructType\MseSubsidiarySearchRowBasic|null
     */
    public function getMseSubsidiaryJoin()
    {
        return $this->mseSubsidiaryJoin;
    }
    /**
     * Set mseSubsidiaryJoin value
     * @param \StructType\MseSubsidiarySearchRowBasic $mseSubsidiaryJoin
     * @return \StructType\VendorSearchRow
     */
    public function setMseSubsidiaryJoin(\StructType\MseSubsidiarySearchRowBasic $mseSubsidiaryJoin = null)
    {
        $this->mseSubsidiaryJoin = $mseSubsidiaryJoin;
        return $this;
    }
    /**
     * Get messagesFromJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesFromJoin()
    {
        return $this->messagesFromJoin;
    }
    /**
     * Set messagesFromJoin value
     * @param \StructType\MessageSearchRowBasic $messagesFromJoin
     * @return \StructType\VendorSearchRow
     */
    public function setMessagesFromJoin(\StructType\MessageSearchRowBasic $messagesFromJoin = null)
    {
        $this->messagesFromJoin = $messagesFromJoin;
        return $this;
    }
    /**
     * Get messagesToJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesToJoin()
    {
        return $this->messagesToJoin;
    }
    /**
     * Set messagesToJoin value
     * @param \StructType\MessageSearchRowBasic $messagesToJoin
     * @return \StructType\VendorSearchRow
     */
    public function setMessagesToJoin(\StructType\MessageSearchRowBasic $messagesToJoin = null)
    {
        $this->messagesToJoin = $messagesToJoin;
        return $this;
    }
    /**
     * Get taxRegistrationJoin value
     * @return \StructType\EntityTaxRegistrationSearchRowBasic|null
     */
    public function getTaxRegistrationJoin()
    {
        return $this->taxRegistrationJoin;
    }
    /**
     * Set taxRegistrationJoin value
     * @param \StructType\EntityTaxRegistrationSearchRowBasic $taxRegistrationJoin
     * @return \StructType\VendorSearchRow
     */
    public function setTaxRegistrationJoin(\StructType\EntityTaxRegistrationSearchRowBasic $taxRegistrationJoin = null)
    {
        $this->taxRegistrationJoin = $taxRegistrationJoin;
        return $this;
    }
    /**
     * Get timeApproverJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getTimeApproverJoin()
    {
        return $this->timeApproverJoin;
    }
    /**
     * Set timeApproverJoin value
     * @param \StructType\EmployeeSearchRowBasic $timeApproverJoin
     * @return \StructType\VendorSearchRow
     */
    public function setTimeApproverJoin(\StructType\EmployeeSearchRowBasic $timeApproverJoin = null)
    {
        $this->timeApproverJoin = $timeApproverJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\VendorSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\VendorSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\VendorSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vendorSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$vendorSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($vendorSearchRowCustomSearchJoinItem) ? get_class($vendorSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($vendorSearchRowCustomSearchJoinItem), var_export($vendorSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\VendorSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\VendorSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
