<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VendorSubsidiaryRelationshipSearch StructType
 * @subpackage Structs
 */
class VendorSubsidiaryRelationshipSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSubsidiaryRelationshipSearchBasic
     */
    public $basic;
    /**
     * The subsidiaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SubsidiarySearchBasic
     */
    public $subsidiaryJoin;
    /**
     * The vendorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchBasic
     */
    public $vendorJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for VendorSubsidiaryRelationshipSearch
     * @uses VendorSubsidiaryRelationshipSearch::setBasic()
     * @uses VendorSubsidiaryRelationshipSearch::setSubsidiaryJoin()
     * @uses VendorSubsidiaryRelationshipSearch::setVendorJoin()
     * @uses VendorSubsidiaryRelationshipSearch::setCustomSearchJoin()
     * @param \StructType\VendorSubsidiaryRelationshipSearchBasic $basic
     * @param \StructType\SubsidiarySearchBasic $subsidiaryJoin
     * @param \StructType\VendorSearchBasic $vendorJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\VendorSubsidiaryRelationshipSearchBasic $basic = null, \StructType\SubsidiarySearchBasic $subsidiaryJoin = null, \StructType\VendorSearchBasic $vendorJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setSubsidiaryJoin($subsidiaryJoin)
            ->setVendorJoin($vendorJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\VendorSubsidiaryRelationshipSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\VendorSubsidiaryRelationshipSearchBasic $basic
     * @return \StructType\VendorSubsidiaryRelationshipSearch
     */
    public function setBasic(\StructType\VendorSubsidiaryRelationshipSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get subsidiaryJoin value
     * @return \StructType\SubsidiarySearchBasic|null
     */
    public function getSubsidiaryJoin()
    {
        return $this->subsidiaryJoin;
    }
    /**
     * Set subsidiaryJoin value
     * @param \StructType\SubsidiarySearchBasic $subsidiaryJoin
     * @return \StructType\VendorSubsidiaryRelationshipSearch
     */
    public function setSubsidiaryJoin(\StructType\SubsidiarySearchBasic $subsidiaryJoin = null)
    {
        $this->subsidiaryJoin = $subsidiaryJoin;
        return $this;
    }
    /**
     * Get vendorJoin value
     * @return \StructType\VendorSearchBasic|null
     */
    public function getVendorJoin()
    {
        return $this->vendorJoin;
    }
    /**
     * Set vendorJoin value
     * @param \StructType\VendorSearchBasic $vendorJoin
     * @return \StructType\VendorSubsidiaryRelationshipSearch
     */
    public function setVendorJoin(\StructType\VendorSearchBasic $vendorJoin = null)
    {
        $this->vendorJoin = $vendorJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vendorSubsidiaryRelationshipSearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$vendorSubsidiaryRelationshipSearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($vendorSubsidiaryRelationshipSearchCustomSearchJoinItem) ? get_class($vendorSubsidiaryRelationshipSearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($vendorSubsidiaryRelationshipSearchCustomSearchJoinItem), var_export($vendorSubsidiaryRelationshipSearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\VendorSubsidiaryRelationshipSearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\VendorSubsidiaryRelationshipSearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
