<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WorkOrderCompletionOperationList StructType
 * @subpackage Structs
 */
class WorkOrderCompletionOperationList extends AbstractStructBase
{
    /**
     * The workOrderCompletionOperation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\WorkOrderCompletionOperation[]
     */
    public $workOrderCompletionOperation;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for WorkOrderCompletionOperationList
     * @uses WorkOrderCompletionOperationList::setWorkOrderCompletionOperation()
     * @uses WorkOrderCompletionOperationList::setReplaceAll()
     * @param \StructType\WorkOrderCompletionOperation[] $workOrderCompletionOperation
     * @param bool $replaceAll
     */
    public function __construct(array $workOrderCompletionOperation = array(), $replaceAll = true)
    {
        $this
            ->setWorkOrderCompletionOperation($workOrderCompletionOperation)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get workOrderCompletionOperation value
     * @return \StructType\WorkOrderCompletionOperation[]|null
     */
    public function getWorkOrderCompletionOperation()
    {
        return $this->workOrderCompletionOperation;
    }
    /**
     * This method is responsible for validating the values passed to the setWorkOrderCompletionOperation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWorkOrderCompletionOperation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWorkOrderCompletionOperationForArrayConstraintsFromSetWorkOrderCompletionOperation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $workOrderCompletionOperationListWorkOrderCompletionOperationItem) {
            // validation for constraint: itemType
            if (!$workOrderCompletionOperationListWorkOrderCompletionOperationItem instanceof \StructType\WorkOrderCompletionOperation) {
                $invalidValues[] = is_object($workOrderCompletionOperationListWorkOrderCompletionOperationItem) ? get_class($workOrderCompletionOperationListWorkOrderCompletionOperationItem) : sprintf('%s(%s)', gettype($workOrderCompletionOperationListWorkOrderCompletionOperationItem), var_export($workOrderCompletionOperationListWorkOrderCompletionOperationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The workOrderCompletionOperation property can only contain items of type \StructType\WorkOrderCompletionOperation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set workOrderCompletionOperation value
     * @throws \InvalidArgumentException
     * @param \StructType\WorkOrderCompletionOperation[] $workOrderCompletionOperation
     * @return \StructType\WorkOrderCompletionOperationList
     */
    public function setWorkOrderCompletionOperation(array $workOrderCompletionOperation = array())
    {
        // validation for constraint: array
        if ('' !== ($workOrderCompletionOperationArrayErrorMessage = self::validateWorkOrderCompletionOperationForArrayConstraintsFromSetWorkOrderCompletionOperation($workOrderCompletionOperation))) {
            throw new \InvalidArgumentException($workOrderCompletionOperationArrayErrorMessage, __LINE__);
        }
        $this->workOrderCompletionOperation = $workOrderCompletionOperation;
        return $this;
    }
    /**
     * Add item to workOrderCompletionOperation value
     * @throws \InvalidArgumentException
     * @param \StructType\WorkOrderCompletionOperation $item
     * @return \StructType\WorkOrderCompletionOperationList
     */
    public function addToWorkOrderCompletionOperation(\StructType\WorkOrderCompletionOperation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WorkOrderCompletionOperation) {
            throw new \InvalidArgumentException(sprintf('The workOrderCompletionOperation property can only contain items of type \StructType\WorkOrderCompletionOperation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->workOrderCompletionOperation[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\WorkOrderCompletionOperationList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
